unit NVIAC_BASIS;
//
//  The basis class also defining of timing and semitransparency....
//  TNVIAC_BASIS - Basis Class - it OUGHT to be first at using queue...
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs,nviac_bitmap_unit,NVIAC_BASIS_TIMER;



type
  TNVIAC_BASIS = class;
  INVIAC_TIMER = interface(IUnknown)
  ['{EFDDB480-59B3-11D5-9C33-F82D3A0AE9B4}']
    procedure ReintroduceTimerBasis(ANewBasis : TNVIAC_BASIS);
    procedure TryRegisterTimer;
    procedure TryUnregisterTimer;
    procedure TimerTick(ANumberTick : Integer);//send the tick
  end;
  INVIAC_SEMITRANSPARENCE = interface(IUnknown)//Any control that support this interface will semitransparent...
  ['{EFDDB481-59B3-11D5-9C33-F82D3A0AE9B4}']
    procedure ReintroduceBasis(ANewBasis : TNVIAC_BASIS);//Get new basis if it changes
    procedure TryRegisterSemiQueque;//Register in semi queue
    procedure TryUnregisterSemiQueque;//Unregister
    function GetFullBitmap: TBitmap;//This is full bitmap that we can look at form
    function GetCurrentSize : TSize;//Size of control
    function GetCurrentBitmap: TBitmap;//Bitmap to process semi
    function GetCurrentOffset: TPoint;//position of control by form client rect
    function GetCurrentRegion: HRGN;//Region of control trimming (where to paint - will painted only here on back)
    function GetSemiClass : Byte;//1 - Alpha,2 - bitmap
    function GetAlpha : Byte;//alpha
    function GetAlphaBitmap : TBitmap;//alpha bitmap sizes=Current Bitmap
    procedure ContinueBitmap;//Requiring to draw the bitmap after semi to full image
    procedure TryPaint;//Requiring to redraw the control (Repaint - usually, some complex for Controls having others controls)
    procedure SetCurrRect(ARect : TRect);//This is setting of rect where and only where you can draw Current/Continue bitmap
    function GetSemiControl: TControl;//Must Return someself t.i. -> Result:=Self;
    function IsVisible: Boolean;//MustReturn Visibility of item -> Result:=Self.Visible;
  end;
  PNVIACSemi_LIST = ^TNVIACSemi_LIST;
  TNVIACSemi_LIST = record
    PreviousSemi : PNVIACSemi_LIST;
    NextSemi : PNVIACSemi_LIST;
    ASemi :  INVIAC_SEMITRANSPARENCE;
  end;
  PNVIACTimer_LIST = ^TNVIACTimer_LIST;
  TNVIACTimer_LIST = record
    PreviousTimed : PNVIACTimer_LIST;
    NextTimed : PNVIACTimer_LIST;
    ATimed :  INVIAC_TIMER;
  end;

  TNVIAC_H_Align = (nviachLeft,nviachRight ,nviachCenter);
  TNVIAC_V_Align = (nviacvTop ,nviacvBottom,nviacvCenter);
  TNVIAC_3DStyle = (nviac3dsSimple,nviac3dsRised,nviac3dsPressed);
  TNVIAC_Bitmap_Apply = (nviacbaTile,nviacbaCenter,nviacbaStretch,nviacbaCenterTile);


  TNVIAC_BASIS = class(TComponent)
  private
    AFirstTimed,ALastTimed,ACurrTimed : PNVIACTimer_LIST;


    AFirstSemi,ALastSemi,ACurrSemi : PNVIACSemi_LIST;
    AFirstSemi2,ALastSemi2,ACurrSemi2 : PNVIACSemi_LIST;
    INeedRearrange : Boolean;
    HorScrollV,VerScrollV : Boolean;
    ABasisBitmap : TBitmap;
    FFormBitmap: TBitmap;
    FFormBitmapApply: TNVIAC_Bitmap_Apply;

    FPreviousMessageEater,FNextMessageEater : TNVIAC_BASIS;
    FIntTimer : TNVIAC_BASIS_TIMER;
    AInternalHookForm : TForm;
    OldParentWndProc : TFarProc;//Hook variables...
    NewparentWndProc : Pointer;
    FOwnerColor : TColor;
    FOwnerSize : TSize;
    ATimerData : Integer;
    FGridSizeDesign: byte;
    FGridColor: Tcolor;
    FGridEnabled: Boolean;


    procedure InternalHook;
    procedure InternalUnHook;

    procedure SetFormBitmap(Value: TBitmap);
    procedure SetFormBitmapApply(Value: TNVIAC_Bitmap_Apply);

    procedure HookForm;
    procedure UnHookForm;
    function MyMessageHook(Wparam,LParam : Integer): integer;
    procedure DrawOnForm;
    procedure OnFormPaint(Sender: TObject);
    procedure CallDefault(var Message: Tmessage);
    procedure HookWndProc(var Message: Tmessage);
    procedure CheckAndDrawOwnerForm;

    procedure DrawBack(DC : HDC;ARect : TRect);
    function BackisCleared: Boolean;
    procedure BackIsUpdated(AControl: TControl);
    function IsHandleOfMe(AWinControl : TWinControl;AHandle : HWND;out AWinControlRes : TWinControl): Boolean;
    function IsNotLoadingDestroying: Boolean;
    procedure ReArrangeSemi;
    procedure ArrangeSemiAt(AWinControl: TWinControl;var NumberEated : integer;NumberAll : integer);
    procedure AddToSemiQueue2(ASemi : INVIAC_SEMITRANSPARENCE);
    procedure MoveQueue2to1;
    procedure SetGridSizeDesign(Value: byte);
    procedure SetGridColor(Value: Tcolor);
    function SemiIsChild(AParentSemi,ATestSemi : INVIAC_SEMITRANSPARENCE): Boolean;
    procedure SetGridEnabled(Value: Boolean);
    procedure ProcessTimerQueue(ANumberTick : Integer);
  protected
    { Protected declarations }
  public
    AFirst : Boolean;


    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent);override;

    procedure AddToSemiQueue(ASemi : INVIAC_SEMITRANSPARENCE);
    procedure RemoveFromSemiQueue(ASemi : INVIAC_SEMITRANSPARENCE);
    procedure SemiIsUpdated(ASemi : INVIAC_SEMITRANSPARENCE);
    procedure SemiIsHiding(ASemi : INVIAC_SEMITRANSPARENCE);
    procedure AllBackIsUpdated;

    procedure AddToTimerQueue(ATimed : INVIAC_TIMER);
    procedure RemoveFromTimerQueue(ATimed : INVIAC_TIMER);

  published
    property FormBitmap : TBitmap read FFormBitmap write SetFormBitmap;
    property FormBitmapApply : TNVIAC_Bitmap_Apply read FFormBitmapApply write SetFormBitmapApply default nviacbaTile;
    property GridSizeDesign : byte read FGridSizeDesign write SetGridSizeDesign default 8;
    property GridColor : Tcolor read FGridColor write SetGridColor default clGray;
    property GridEnabled : Boolean read FGridEnabled write SetGridEnabled default True;
  end;

function Is_NVIAC_BASIS_We_Got(AComponent : TComponent;var ABasis : TNVIAC_BASIS): Boolean;
procedure Reintroduce_NVIAC_BASIS(AComponent : TComponent);
function GetControlPosition(AControl : TControl): TSize;
function GetControlVisualRGN(AControl : TControl): HRGN;
//function return the current basis at ABasis for component AComponent... if exists
implementation
var CurrMessageEater : TNVIAC_BASIS;
    FHook : HHOOK;
function ControlSupportsSemi(AControl: TControl): Boolean;
var AInterface : INVIAC_SEMITRANSPARENCE;
begin
  if Assigned(AControl) and
     AControl.GetInterface(INVIAC_SEMITRANSPARENCE,AInterface) then
    begin
      AInterface:=nil;
      Result:=True;
    end else
    begin
      Result:=False;
    end;
end;

function MessageProc_(HCode : integer;Wparam : integer;Lparam : integer): integer;stdcall;
begin
  if HCode=HC_ACTION then
    begin
      if assigned(CurrMessageEater) then
         begin
            result:=CurrMessageEater.MyMessageHook(Wparam,LParam);
            if result<>0 then result:=CallNextHookEx(FHook,HCode,Wparam,LParam);
         end else result:=CallNextHookEx(FHook,HCode,Wparam,LParam);
    end else
    begin
      if HCode<0 then
        begin
          result:=CallNextHookEx(FHook,HCode,Wparam,LParam);
        end else
        begin
          if assigned(CurrMessageEater) then
          begin
          result:=CurrMessageEater.MyMessageHook(Wparam,LParam);
          if result<>0 then result:=CallNextHookEx(FHook,HCode,Wparam,LParam);
          end else  result:=CallNextHookEx(FHook,HCode,Wparam,LParam);
        end;
    end;
end;
function GetControlVisualRGN(AControl : TControl): HRGN;
var x,y,dx,dy : integer;
    ARGN : HRGN;
begin
  if assigned(AControl) then
    begin
      if AControl is TWinControl then
        begin
          if (AControl as TWinControl).HandleAllocated  then
            begin
              Result:=CreateRectRGN(0,0,0,0);
              if 0=Integer(GetWindowRGN((AControl as TWinControl).Handle,Result)) then   //not
                begin
                  DeleteObject(Result);
                  Result:=CreateRectRGN(0,0,AControl.Width,AControl.Height);
                end;
            end else
            begin
              Result:=CreateRectRGN(0,0,AControl.Width,AControl.Height);
            end;
        end else
        begin
          Result:=CreateRectRGN(0,0,AControl.Width,AControl.Height);
        end;  
      x:=0;y:=0;dx:=0;dy:=0;
      while not(AControl.Parent is TForm) do
        begin
          x:=x+dx+AControl.Left;
          y:=y+dy+AControl.Top;
          AControl:=AControl.Parent;
          if (AControl as TWinControl).HandleAllocated then
            begin
              dx:=((AControl as TWinControl).Width-(AControl as TWinControl).ClientWidth) div 2;
              dy:=(AControl as TWinControl).Height-(AControl as TWinControl).ClientHeight - dx;
              ARGN:=CreateRectRGN(0,0,0,0);
              if 0=Integer(GetWindowRGN((AControl as TWinControl).Handle,ARGN)) then //not
                begin
                  DeleteObject(ARGN);
                  ARGN:=CreateRectRGN(0,0,AControl.Width,AControl.Height);
                end;
              OffsetRGN(ARGN,-x-dx,-y-dy);
              CombineRGN(Result,Result,ARGN,RGN_AND);
              DeleteObject(ARGN);
            end;
        end;

    end else
    begin
      Result:=0;
    end;
end;
function GetControlPosition(AControl : TControl): TSize;
var ACopy : TControl;
    dx,dy : integer;
begin
  Result.cx:=0;
  Result.cy:=0;
  ACopy:=AControl;
  while assigned(AControl) do
    begin
      if AControl is TWinControl then
        begin
          if ACopy=AControl then
            begin
              Result.cx:=AControl.Left;
              Result.cy:=AControl.Top;
            end else
            begin
              if AControl is TScrollingWinControl then
                begin
                  if (AControl as TWinControl).HandleAllocated then
                    begin
                      dx:=((AControl as TWinControl).Width-(AControl as TWinControl).ClientWidth) div 2;
                      dy:=(AControl as TWinControl).Height-(AControl as TWinControl).ClientHeight-dx;
                      if not(AControl is TForm) then
                        begin
                          Result.cx:=Result.cx+dx+AControl.Left;
                          Result.cy:=Result.cy+dy+AControl.Top;
                        end;
                    end else
                    begin
                      if not(AControl is TForm) then
                        begin
                          Result.cx:=Result.cx+AControl.Left;
                          Result.cy:=Result.cy+AControl.Top;
                        end;
                    end;
                end else
                begin
                  if (AControl as TWinControl).HandleAllocated then
                    begin
                      dx:=((AControl as TWinControl).Width-(AControl as TWinControl).ClientWidth) div 2;
                      dy:=(AControl as TWinControl).Height-(AControl as TWinControl).ClientHeight-dx;
                      Result.cx:=Result.cx+dx+AControl.Left;
                      Result.cy:=Result.cy+dy+AControl.Top;
                    end else
                    begin
                      Result.cx:=Result.cx+AControl.Left;
                      Result.cy:=Result.cy+AControl.Top;
                    end;
                end;
            end;
        end else
        begin
          Result.cx:=AControl.Left;
          Result.cy:=AControl.Top;
        end;
      if AControl is TForm then break else AControl:=AControl.Parent;
    end;
end;
procedure Reintroduce_NVIAC_BASIS(AComponent : TComponent);
var LastForm : TForm;
begin
  LastForm:=nil;
  while assigned(AComponent) do
    begin
      if AComponent is TForm then LastForm:=(AComponent as TForm);
      AComponent:=AComponent.Owner;
    end;
  if assigned(LastForm) then
    begin
      TNVIAC_BASIS.Create(LastForm);
    end;
end;
function Is_NVIAC_BASIS_We_Got(AComponent : TComponent;var ABasis : TNVIAC_BASIS): Boolean;
var i : integer;
LastForm : TForm;
begin
  LastForm:=nil;
  while assigned(AComponent) do
    begin
      if AComponent is TForm then LastForm:=(AComponent as TForm);
      AComponent:=AComponent.Owner;
    end;
  if assigned(LastForm) then
    begin
      ABasis:=nil;
      result:=false;
      for i:=0 to LastForm.ComponentCount-1 do
        begin
          if LastForm.Components[i] is  TNVIAC_BASIS then
            begin
              ABasis:=(LastForm.Components[i] as  TNVIAC_BASIS);
              Result:=True;
              Break;
            end;
        end;
    end else
    begin
      ABasis:=nil;
      result:=false;
    end;
end;


{ TNVIAC_BASIS }

procedure TNVIAC_BASIS.AddToSemiQueue(ASemi: INVIAC_SEMITRANSPARENCE);
var
  AOldSemi : PNVIACSemi_LIST;
begin
  //add to end of queue...
  AOldSemi:=ACurrSemi;
  New(ACurrSemi);
  ACurrSemi.ASemi:=ASemi;
  ACurrSemi.NextSemi:=nil;
  if nil<>AOldSemi then
    begin
      AOldSemi.NextSemi:=ACurrSemi;
      ACurrSemi.PreviousSemi:=AOldSemi;
    end else
    begin
      ACurrSemi.PreviousSemi:=Nil;
    end;
  if nil=AFirstSemi then AFirstSemi:=ACurrSemi;
  ALastSemi:=ACurrSemi;
  if IsNotLoadingDestroying then INeedRearrange:=True;
end;



procedure TNVIAC_BASIS.Assign(Source: TPersistent);
var
  AWorkSemi : PNVIACSemi_LIST;
  AWorkTimed : PNVIACTimer_LIST;
begin
  if Source is TNVIAC_BASIS then
    begin
      FFormBitmap.Width:=(Source as TNVIAC_BASIS).FFormBitmap.Width;
      FFormBitmap.Height:=(Source as TNVIAC_BASIS).FFormBitmap.Height;
      FFormBitmap.Canvas.Draw(0,0,(Source as TNVIAC_BASIS).FFormBitmap);
      FFormBitmapApply:=(Source as TNVIAC_BASIS).FFormBitmapApply;
      FGridSizeDesign:=(Source as TNVIAC_BASIS).FGridSizeDesign;
      FGridColor:=(Source as TNVIAC_BASIS).FGridColor;
      FGridEnabled:=(Source as TNVIAC_BASIS).FGridEnabled;
      AWorkSemi:=(Source as TNVIAC_BASIS).AFirstSemi;
      while assigned(AWorkSemi) do
        begin
          self.AddToSemiQueue(AWorkSemi.ASemi);
          AWorkSemi:=AWorkSemi.NextSemi;

        end;
      AWorkTimed:=(Source as TNVIAC_BASIS).AFirstTimed;
      while assigned(AWorkTimed) do
        begin
          self.AddToTimerQueue(AWorkTimed.ATimed);
          AWorkTimed:=AWorkTimed.NextTimed;
        end;
    end else
    begin
      inherited Assign(Source);
    end;
end;

constructor TNVIAC_BASIS.Create(AOwner: TComponent);
var i : integer;
    AWorkSemi : PNVIACSemi_LIST;
    AWorkTimed : PNVIACTimer_LIST;
    RGN : HRGN;
    AComponent: TComponent;
begin

  if not (AOwner is TForm) then
    begin
      ShowMessage('Only Form could be owner of TNVIAC_BASIS');
      Halt;
    end else
    begin
      inherited Create(AOwner);
      AFirst:=True;
      (AOwner as TForm).OnPaint:=OnFormPaint;
      (AOwner as TForm).OnShow:=OnFormPaint;
      (AOwner as TForm).ControlStyle:=(AOwner as TForm).ControlStyle+[csOpaque];
      FGridSizeDesign:=8;
      FGridColor:=clGray;
      FGridEnabled:=True;
      INeedRearrange:=false;
      HorScrollV :=false;
      VerScrollV :=false;
      AFirstSemi:=NIL;
      ALastSemi:=NIl;
      ACurrSemi:=NIL;
      AFirstTimed:=NIL;
      ALastTimed:=NIl;
      ACurrTimed:=NIL;
      FNextMessageEater:=nil;
      FPreviousMessageEater:=nil;
      FFormBitmap:=TBitmap.Create;
      FFormBitmap.PixelFormat:=pf24Bit;
      FFormBitmapApply:=nviacbaTile;
      HookForm;
      i:=0;
      while i<(AOwner.ComponentCount)  do
        begin
          if (AOwner.Components[i] is TNVIAC_BASIS) and
            ((AOwner.Components[i] as TNVIAC_BASIS)<>self) then
            begin
              self.Assign(AOwner.Components[i] as TNVIAC_BASIS);
              AComponent:=AOwner.Components[i];
              AOwner.RemoveComponent(AComponent);
              AComponent.free;
              AWorkSemi:=self.AFirstSemi;
              while assigned(AWorkSemi) do
                begin
                  AWorkSemi.ASemi.ReintroduceBasis(Self);
                  AWorkSemi:=AWorkSemi.NextSemi;
                end;
              AWorkTimed:=self.AFirstTimed;
              while assigned(AWorkTimed) do
                begin
                  AWorkTimed.ATimed.ReintroduceTimerBasis(self);
                  AWorkTimed:=AWorkTimed.NextTimed;
                end;
            end;
          inc(i);
        end;
      ABasisBitmap:=TBitmap.Create;
      ABasisBitmap.PixelFormat:=pf24Bit;
      AInternalHookForm:=TForm.CreateNew(Self);
      AInternalHookForm.Parent:=nil;
      AInternalHookForm.Width:=0;
      AInternalHookForm.Height:=0;
      AInternalHookForm.Left:=Screen.Width;
      AInternalHookForm.Top:=Screen.Height;
      AInternalHookForm.Show;

      RGN:=CreateRectRGN(0,0,0,0);
      if AInternalHookForm.HandleAllocated then SetWindowRgn(AInternalHookForm.Handle,RGN,TRUE) else
      deleteobject(RGN);
      InternalHook;
      FIntTimer:=TNVIAC_BASIS_TIMER.Create(TRUE);
      if AInternalHookForm.HandleAllocated then FIntTimer.AHandle:=AInternalHookForm.Handle;
      FIntTimer.ICanTime:=True;
      FIntTimer.Resume;
      FOwnerColor :=(AOwner as TForm).Color;
      if (AOwner as TForm).HandleAllocated then FOwnerSize.cx:=(AOwner as TForm).ClientWidth;
      if (AOwner as TForm).HandleAllocated then FOwnerSize.cy:=(AOwner as TForm).ClientHeight;
    end;
end;

destructor TNVIAC_BASIS.Destroy;
begin
  if FIntTimer.Suspended then
    begin
      FIntTimer.Terminate;
      FIntTimer.Resume;
    end else
    begin
      FIntTimer.Suspend;
      FIntTimer.Terminate;
      FIntTimer.Resume;
    end;
  FIntTimer.WaitFor;
  FIntTimer.Free;
  InternalUnHook;
  AInternalHookForm.Hide;
  AInternalHookForm.Release;
  AInternalHookForm.Free;
  AInternalHookForm:=nil;
  while nil<>ALastTimed do
    begin
      ACurrTimed:=ALastTimed.PreviousTimed;
      ALastTimed.ATimed.ReintroduceTimerBasis(nil);
      ALastTimed.ATimed:=nil;
      Dispose(ALastTimed);
      ALastTimed:=ACurrTimed;
    end;
  while nil<>ALastSemi do
    begin
      ACurrSemi:=ALastSemi.PreviousSemi;
      ALastSemi.ASemi.ReintroduceBasis(nil);
      ALastSemi.ASemi:=nil;
      Dispose(ALastSemi);
      ALastSemi:=ACurrSemi;
    end;
  UnHookForm;
  FFormBitmap.Free;
  ABasisBitmap.Free;
  //Last word to remove with guaranty the threads we do the next...
  inherited Destroy;
end;


procedure TNVIAC_BASIS.RemoveFromSemiQueue(ASemi: INVIAC_SEMITRANSPARENCE);
var
  AFoundSemi : PNVIACSemi_LIST;
begin
  AFoundSemi:=AFirstSemi;
  if nil<>AFoundSemi then
    begin
      while (ASemi<>AFoundSemi.ASemi) and (nil<>AFoundSemi.NextSemi) do AFoundSemi:=AFoundSemi.NextSemi;
      if ASemi=AFoundSemi.ASemi then
        begin
          if nil<>AFoundSemi.PreviousSemi then
            begin
              AFoundSemi.PreviousSemi.NextSemi:=AFoundSemi.NextSemi;
            end;
          if nil<>AFoundSemi.NextSemi then
            begin
              AFoundSemi.NextSemi.PreviousSemi:=AFoundSemi.PreviousSemi;
            end;
          if AFirstSemi=AFoundSemi then
            begin
              AFirstSemi:=AFoundSemi.NextSemi;
            end;
          if ALastSemi=AFoundSemi then
            begin
              ALastSemi:=AFoundSemi.PreviousSemi;
            end;
          if ACurrSemi=AFoundSemi then
            begin
              if nil<>AFoundSemi.PreviousSemi then
                begin
                  ACurrsemi:=AFoundSemi.PreviousSemi;
                end else
                begin
                  ACurrsemi:=AFoundSemi.NextSemi;
                end;
            end;  
          Dispose(AFoundSemi);
          AllBackIsUpdated;
        end;
    end;
end;

procedure TNVIAC_BASIS.SemiIsHiding(ASemi: INVIAC_SEMITRANSPARENCE);
var
  AWorkSemi : PNVIACSemi_LIST;
  ASize,ASize1 : TSize;
  AOffset,AOffset1 : TPoint;
  ARect,ACurrRect : TRect;
  ARGN,ARGN2 :HRGN;
begin
  //here we define the image...
  if (not assigned(Owner)) or (not (Owner as TForm).HandleAllocated ) or (not assigned(ASemi)) or
     (not IsNotLoadingDestroying) then
    begin
      exit;
    end;
  if INeedRearrange then
    begin
      INeedRearrange:=False;
      ReArrangeSemi;
    end;   
  ASize:=ASemi.GetCurrentSize;
  AOffset:=ASemi.GetCurrentOffset;
  ABasisBitmap.Width:=(Owner as TForm).ClientWidth;
  ABasisBitmap.Height:=(Owner as TForm).ClientHeight;
  DrawBack(ABasisBitmap.Canvas.Handle,Rect(0,0,ABasisBitmap.Width,ABasisBitmap.Height));


  AWorkSemi:=AFirstSemi;
  while assigned(AWorkSemi) and (AWorkSemi.ASemi<>ASemi) do
    begin
      //here we got the result before required
      if AWorkSemi.ASemi.IsVisible then
        begin
          AWorkSemi.ASemi.SetCurrRect(Rect(0,0,0,0));
          ASize1:=AWorkSemi.ASemi.GetCurrentSize;
          AOffset1:=AWorkSemi.ASemi.GetCurrentOffset;
          intersectrect(ARect,Rect(AOffset.x,AOffset.y,AOffset.x+ASize.cx,AOffset.y+ASize.cy),
                              Rect(AOffset1.x,AOffset1.y,AOffset1.x+ASize1.cx,AOffset1.y+ASize1.cy));
          if not  IsRectEmpty(ARect) then
            begin
              ARGN:=AWorkSemi.ASemi.GetCurrentRegion;
              ARGN2:=GetControlVisualRGN(AWorkSemi.ASemi.GetSemiControl);
              if ARGN2<>0 then
                begin
                  CombineRGN(ARGN,ARGN,ARGN2,RGN_AND);
                  DeleteObject(ARGN2);
                end;
              if ARGN=0 then
                begin
                  ABasisBitmap.Canvas.Draw(AOffset1.x,AOffset1.y,AWorkSemi.ASemi.GetFullBitmap);
                end else
                begin
                  OffsetRGN(ARGN,AOffset1.x,AOffset1.y);
                  SelectClipRgn(ABasisBitmap.canvas.handle,ARGN);
                  ABasisBitmap.Canvas.Draw(AOffset1.x,AOffset1.y,AWorkSemi.ASemi.GetFullBitmap);
                  SelectClipRgn(ABasisBitmap.canvas.handle,0);
                  OffsetRGN(ARGN,-AOffset1.x,-AOffset1.y);
                  DeleteObject(ARGN);
                end;
            end;
        end;
      AWorkSemi:=AWorkSemi.NextSemi;
    end;
  //and here we semi images....

  if assigned(AWorkSemi) then AWorkSemi:=AWorkSemi.NextSemi;
  if not assigned(AWorkSemi) then exit;
  repeat
    if AWorkSemi.ASemi.IsVisible and (not SemiIsChild(ASemi,AWorkSemi.ASemi))then
      begin
        ASize1:=AWorkSemi.ASemi.GetCurrentSize;
        AOffset1:=AWorkSemi.ASemi.GetCurrentOffset;
        intersectrect(ARect,Rect(AOffset.x,AOffset.y,AOffset.x+ASize.cx,AOffset.y+ASize.cy),
                            Rect(AOffset1.x,AOffset1.y,AOffset1.x+ASize1.cx,AOffset1.y+ASize1.cy));
        if not  IsRectEmpty(ARect) then
          begin
            ACurrRect:=Rect(AOffset.x,AOffset.y,ASize.cx+AOffset.x,AOffset.y+ASize.cy);
            offsetrect(ACurrRect,-AOffset1.x,-AOffset1.y);
            AWorkSemi.ASemi.SetCurrRect(ACurrRect);
            ARGN:=AWorkSemi.ASemi.GetCurrentRegion;
            ARGN2:=GetControlVisualRGN(AWorkSemi.ASemi.GetSemiControl);
              if ARGN2<>0 then
                begin
                  CombineRGN(ARGN,ARGN,ARGN2,RGN_AND);
                  DeleteObject(ARGN2);
                end;
            if ARGN=0 then
              begin
                if AWorkSemi.ASemi.GetSemiClass=1 then
                  begin// by alpha
                    NVIAC_GetAlphaBitmap24(ABasisBitmap,AWorkSemi.ASemi.GetCurrentBitmap,AWorkSemi.ASemi.GetAlpha,
                                           AOffset1.x,AOffset1.y);
                  end else
                  begin

                    NVIAC_GetABitAlphaBitmap24(ABasisBitmap,AWorkSemi.ASemi.GetCurrentBitmap,AWorkSemi.ASemi.GetAlphaBitmap,
                                                   AOffset1.x,AOffset1.y);

                  end;
              end else
              begin
                if AWorkSemi.ASemi.GetSemiClass=1 then
                  begin// by alpha
                    NVIAC_GetAlphaBitmap24RGN(ABasisBitmap,AWorkSemi.ASemi.GetCurrentBitmap,AWorkSemi.ASemi.GetAlpha,
                                              AOffset1.x,AOffset1.y,ARGN);
                  end else
                  begin
                    NVIAC_GetABitAlphaBitmap24RGN(ABasisBitmap,AWorkSemi.ASemi.GetCurrentBitmap,AWorkSemi.ASemi.GetAlphaBitmap,
                                                  AOffset1.x,AOffset1.y,ARGN);
                  end;
              end;
            AWorkSemi.ASemi.ContinueBitmap;//Draw the Bitmap...to end...
            //Back updating...
            if ARGN=0 then
              begin
                ABasisBitmap.Canvas.Draw(AOffset1.x,AOffset1.y,AWorkSemi.ASemi.GetFullBitmap);
              end else
              begin
                OffsetRGN(ARGN,AOffset1.x,AOffset1.y);
                SelectClipRgn(ABasisBitmap.canvas.handle,ARGN);
                ABasisBitmap.Canvas.Draw(AOffset1.x,AOffset1.y,AWorkSemi.ASemi.GetFullBitmap);
                SelectClipRgn(ABasisBitmap.canvas.handle,0);
                OffsetRGN(ARGN,-AOffset1.x,-AOffset1.y);
                DeleteObject(ARGN);
              end;
            AWorkSemi.ASemi.TryPaint;//Invalidate
          end;
        AWorkSemi.ASemi.SetCurrRect(Rect(0,0,0,0));
      end;
    AWorkSemi:=AWorkSemi.NextSemi;
  until not assigned(AWorkSemi);
end;



procedure TNVIAC_BASIS.SemiIsUpdated(ASemi: INVIAC_SEMITRANSPARENCE);
var
  AWorkSemi : PNVIACSemi_LIST;
  ASize,ASize1 : TSize;
  AOffset,AOffset1 : TPoint;
  ARect,ACurrRect : TRect;
  ARGN,ARGN2 :HRGN;
begin
  //here we define the image...
  if (not assigned(Owner)) or (not IsNotLoadingDestroying) then
    begin
      exit;
    end;
  if INeedRearrange then
    begin
      INeedRearrange:=False;
      ReArrangeSemi;
    end;
  ASize:=ASemi.GetCurrentSize;
  AOffset:=ASemi.GetCurrentOffset;
  ABasisBitmap.Width:=(Owner as TForm).ClientWidth;
  ABasisBitmap.Height:=(Owner as TForm).ClientHeight;
  DrawBack(ABasisBitmap.Canvas.Handle,Rect(0,0,ABasisBitmap.Width,ABasisBitmap.Height));


  AWorkSemi:=AFirstSemi;
  while (AWorkSemi.ASemi<>ASemi) do
    begin
      //here we got the result before required
      if AWorkSemi.ASemi.IsVisible then
        begin
          AWorkSemi.ASemi.SetCurrRect(Rect(0,0,0,0));
          ASize1:=AWorkSemi.ASemi.GetCurrentSize;
          AOffset1:=AWorkSemi.ASemi.GetCurrentOffset;
          intersectrect(ARect,Rect(AOffset.x,AOffset.y,AOffset.x+ASize.cx,AOffset.y+ASize.cy),
                              Rect(AOffset1.x,AOffset1.y,AOffset1.x+ASize1.cx,AOffset1.y+ASize1.cy));
          if not  IsRectEmpty(ARect) then
            begin
              ARGN:=AWorkSemi.ASemi.GetCurrentRegion;
              ARGN2:=GetControlVisualRGN(AWorkSemi.ASemi.GetSemiControl);
              if ARGN2<>0 then
                begin
                  CombineRGN(ARGN,ARGN,ARGN2,RGN_AND);
                  DeleteObject(ARGN2);
                end;
              if ARGN=0 then
                begin
                  ABasisBitmap.Canvas.Draw(AOffset1.x,AOffset1.y,AWorkSemi.ASemi.GetFullBitmap);
                end else
                begin
                  OffsetRGN(ARGN,AOffset1.x,AOffset1.y);
                  SelectClipRgn(ABasisBitmap.canvas.handle,ARGN);
                  ABasisBitmap.Canvas.Draw(AOffset1.x,AOffset1.y,AWorkSemi.ASemi.GetFullBitmap);
                  SelectClipRgn(ABasisBitmap.canvas.handle,0);
                  OffsetRGN(ARGN,-AOffset1.x,-AOffset1.y);
                  DeleteObject(ARGN);
                end;
            end;
        end;
      AWorkSemi:=AWorkSemi.NextSemi;
    end;
  //and here we semi images....

  repeat
    if AWorkSemi.ASemi.IsVisible then
      begin
        ASize1:=AWorkSemi.ASemi.GetCurrentSize;
        AOffset1:=AWorkSemi.ASemi.GetCurrentOffset;
        intersectrect(ARect,Rect(AOffset.x,AOffset.y,AOffset.x+ASize.cx,AOffset.y+ASize.cy),
                            Rect(AOffset1.x,AOffset1.y,AOffset1.x+ASize1.cx,AOffset1.y+ASize1.cy));
        if not  IsRectEmpty(ARect) then
          begin
            ACurrRect:=Rect(AOffset.x,AOffset.y,ASize.cx+AOffset.x,AOffset.y+ASize.cy);
            OffsetRect(ACurrRect,-AOffset1.x,-AOffset1.y);
            AWorkSemi.ASemi.SetCurrRect(ACurrRect);
            ARGN:=AWorkSemi.ASemi.GetCurrentRegion;
            ARGN2:=GetControlVisualRGN(AWorkSemi.ASemi.GetSemiControl);
              if ARGN2<>0 then
                begin
                  CombineRGN(ARGN,ARGN,ARGN2,RGN_AND);
                  DeleteObject(ARGN2);
                end;
            if ARGN=0 then
              begin
                if AWorkSemi.ASemi.GetSemiClass=1 then
                  begin// by alpha
                    NVIAC_GetAlphaBitmap24(ABasisBitmap,AWorkSemi.ASemi.GetCurrentBitmap,AWorkSemi.ASemi.GetAlpha,
                                           AOffset1.x,AOffset1.y);
                  end else
                  begin

                   NVIAC_GetABitAlphaBitmap24(ABasisBitmap,AWorkSemi.ASemi.GetCurrentBitmap,AWorkSemi.ASemi.GetAlphaBitmap,
                                                   AOffset1.x,AOffset1.y);

                  end;
              end else
              begin
                if AWorkSemi.ASemi.GetSemiClass=1 then
                  begin// by alpha
                    NVIAC_GetAlphaBitmap24RGN(ABasisBitmap,AWorkSemi.ASemi.GetCurrentBitmap,AWorkSemi.ASemi.GetAlpha,
                                              AOffset1.x,AOffset1.y,ARGN);
                  end else
                  begin
                    NVIAC_GetABitAlphaBitmap24RGN(ABasisBitmap,AWorkSemi.ASemi.GetCurrentBitmap,AWorkSemi.ASemi.GetAlphaBitmap,
                                                  AOffset1.x,AOffset1.y,ARGN);
                  end;
              end;
            AWorkSemi.ASemi.ContinueBitmap;//Draw the Bitmap...to end...
            //Back updating...
            if ARGN=0 then
              begin
                ABasisBitmap.Canvas.Draw(AOffset1.x,AOffset1.y,AWorkSemi.ASemi.GetFullBitmap);
              end else
              begin
                OffsetRGN(ARGN,AOffset1.x,AOffset1.y);
                SelectClipRgn(ABasisBitmap.canvas.handle,ARGN);
                ABasisBitmap.Canvas.Draw(AOffset1.x,AOffset1.y,AWorkSemi.ASemi.GetFullBitmap);
                SelectClipRgn(ABasisBitmap.canvas.handle,0);
                OffsetRGN(ARGN,-AOffset1.x,-AOffset1.y);
                DeleteObject(ARGN);
              end;
            AWorkSemi.ASemi.TryPaint;
          end;
        AWorkSemi.ASemi.SetCurrRect(Rect(0,0,0,0));
      end;
    AWorkSemi:=AWorkSemi.NextSemi;
  until not assigned(AWorkSemi);
end;

procedure TNVIAC_BASIS.SetFormBitmap(Value: TBitmap);
begin
  if assigned(Value) then
    begin
      FFormBitmap.Width:=Value.Width;
      FFormBitmap.Height:=Value.Height;
      FFormBitmap.Canvas.Draw(0,0,Value);
    end else
    begin
      FFormBitmap.Width:=0;
    end;
  if assigned(Owner) and (Owner is TForm) then (Owner as TForm).Repaint;
  AllBackIsUpdated;
  DrawOnForm;
end;

procedure TNVIAC_BASIS.SetFormBitmapApply(Value: TNVIAC_Bitmap_Apply);
begin
  if Value<>FFormBitmapApply then
    begin
      FFormBitmapApply := Value;
      if assigned(Owner) and (Owner is TForm) then (Owner as TForm).Repaint;
      AllBackIsUpdated;
      DrawOnForm;
    end;
end;


procedure TNVIAC_BASIS.HookForm;
begin
  FPreviousMessageEater:=CurrMessageEater;
  if assigned(FPreviousMessageEater) then
    begin
      FPreviousMessageEater.FNextMessageEater:=self;
    end;
  CurrMessageEater:=self;
end;

procedure TNVIAC_BASIS.UnHookForm;
begin
  if assigned(FPreviousMessageEater) then
    begin
      FPreviousMessageEater.FNextMessageEater:=FNextMessageEater;
    end;
  if assigned(FNextMessageEater) then
    begin
      FNextMessageEater.FPreviousMessageEater:=FPreviousMessageEater;
      if CurrMessageEater=self then CurrMessageEater:=FNextMessageEater;
    end else
    begin
      if CurrMessageEater=self then CurrMessageEater:=FPreviousMessageEater;
    end;
end;

function TNVIAC_BASIS.MyMessageHook(Wparam, LParam: Integer): integer;
var MStruct : PCWPSTRUCT;
    AWinControl : TWinControl;
begin
  Result:=0;
  MStruct:=PCWPSTRUCT(LParam);
  if assigned(Owner) and (Owner is TForm) and (Owner as TForm).HandleAllocated and
    IsNotLoadingDestroying then
    begin

      if MStruct.hwnd=(Owner as TForm).Handle then
        begin
          case MStruct.message of
            WM_SIZE :
              begin
                FOwnerSize.cx:=LOWORD(MStruct.lParam);
                FOwnerSize.cy:=HIWORD(MStruct.lParam);
                AllBackIsUpdated;
                DrawOnForm;
              end;
            WM_HSCROLL,WM_VSCROLL :
              begin
                AllBackIsUpdated;
                DrawOnForm;
              end;  
          end;
        end else
        begin
          case MStruct.message of
            WM_SIZE,WM_MOVE :
              begin
                if IsHandleOfMe((Owner as TForm),MStruct.hwnd,AWinControl) then
                  begin
                    if (not ControlSupportsSemi(AWinControl)) and
                       (csAcceptsControls in AWinControl.ControlStyle) then
                      begin
                        BackIsUpdated(AWinControl);
                        DrawOnForm;
                      end;
                  end;
              end;
          end;
        end;
    end;
  if assigned(FPreviousMessageEater) then
    begin
      Result:=Result or FPreviousMessageEater.MyMessageHook(Wparam, LParam);
    end;
end;
procedure TNVIAC_BASIS.DrawOnForm;
var
  DC : HDC;
  RGN1,RGN2 : HRGN;
  i : integer;
  Pos1 : TSize;
begin
if assigned(Owner) and (Owner is TForm) and (Owner as TForm).HandleAllocated and IsNotLoadingDestroying and (AFirstSemi<>nil) then
  begin

  RGN1:=CreateRectRGN(0,0,(Owner as TForm).Width,(Owner as TForm).Height);
  for i:=0 to (Owner as TForm).controlcount-1 do
    begin
      Pos1:=GetControlPosition((Owner as TForm).controls[i]);
      if (Owner as TForm).controls[i].Visible then
        begin
          if (Owner as TForm).controls[i] is TWinControl then
            begin
              RGN2:=CreateRectRGN(0,0,0,0);
              if 0<>Integer(GetWindowRGN(((Owner as TForm).controls[i] as TWinControl).Handle,RGN2)) then
                begin
                  offsetRGN(RGN2,Pos1.cx,Pos1.cy);
                end else
                begin
                  DeleteObject(RGN2);
                  RGN2:=CreateRectRGN(Pos1.cx,
                                  Pos1.cy,
                                  Pos1.cx+
                                  (Owner as TForm).controls[i].Width,
                                  Pos1.cy+
                                  (Owner as TForm).controls[i].Height);
                end;
            end else
            begin
              RGN2:=CreateRectRGN(Pos1.cx,
                                  Pos1.cy,
                                  Pos1.cx+
                                  (Owner as TForm).controls[i].Width,
                                  Pos1.cy+
                                  (Owner as TForm).controls[i].Height);
            end;
          CombineRGN(RGN1,RGN1,RGN2,RGN_DIFF);
          DeleteObject(RGN2);
        end;
    end;
  DC:=GetDC((Owner as TForm).Handle);  
  SelectClipRGN(DC,RGN1);
  BitBlt(DC,0,0,(Owner as TForm).ClientWidth,(Owner as TForm).ClientHeight,ABasisBitmap.Canvas.Handle,0,0,SRCCOPY);
  SelectClipRGN(DC,0);
  ReleaseDC((Owner as TForm).Handle,DC);
  DeleteObject(RGN1);
  end;
end;

procedure TNVIAC_BASIS.OnFormPaint(Sender: TObject);
begin
  DrawOnForm;
end;

procedure TNVIAC_BASIS.InternalHook;
begin
  if AInternalHookForm.HandleAllocated then
    begin
      OldParentWndProc:=TFarProc(GetWindowLong(AInternalHookForm.handle,GWL_WNDProc));
      NewParentWndProc:=MakeObjectInstance(HookWndProc);
      SetWindowLong(AInternalHookForm.handle,GWL_WNdProc,LongInt(NewParentWndProc));
    end else
    begin
      OldParentWndProc:=nil;
      ShowMessage('No Handle AInternalHookForm');
    end;
end;

procedure TNVIAC_BASIS.InternalUnHook;
begin
  if assigned(OldParentWndProc) then
    begin
      SetWindowLong(AInternalHookForm.handle,GWL_WNDProc,LongInt(OldParentWndProc));
      if assigned(NewParentWndProc) then FreeObjectInstance(NewParentWndProc);
      NewParentWndProc:=nil;
      OldParentWndProc:=nil;
    end;
end;
procedure TNVIAC_BASIS.HookWndProc(var Message : Tmessage);
begin
  if IsNotLoadingDestroying then
     begin
       case Message.Msg of
         CM_NVIAC_BASIS_TIMER :
           begin
             FIntTimer.ICanTime:=False;
             ATimerData:=Message.WParam;
             ProcessTimerQueue(ATimerData);
             CheckAndDrawOwnerForm;
             //Generation of timing...
             FIntTimer.ICanTime:=True;
           end;
       end;
     end;
   CallDefault(Message);
end;
procedure TNVIAC_BASIS.CallDefault(var Message : Tmessage);
begin
  if AInternalHookForm.HandleAllocated then
  Message.Result:=
  CallWindowProc(OldParentWndProc,AInternalHookForm.Handle,Message.Msg,Message.wParam,Message.lParam);
end;

procedure TNVIAC_BASIS.CheckAndDrawOwnerForm;
var AProcedure1,AProcedure2 : TNotifyEvent;
begin
  if (not assigned(Owner)) or (not (Owner as TForm).HandleAllocated) then exit;
  if (Owner as TForm).HorzScrollBar.IsScrollBarVisible then HorScrollV:=True;
  if (Owner as TForm).VertScrollBar.IsScrollBarVisible then VerScrollV:=True;

  if (FOwnerColor<>(Owner as TForm).Color) or
     (FOwnerSize.cx<>(Owner as TForm).ClientWidth) or
     (FOwnerSize.cy<>(Owner as TForm).ClientHeight) or
     (HorScrollV<>(Owner as TForm).HorzScrollBar.IsScrollBarVisible) or
     (VerScrollV<>(Owner as TForm).VertScrollBar.IsScrollBarVisible)then
    begin
      FOwnerColor :=(Owner as TForm).Color;
      FOwnerSize.cx:=(Owner as TForm).ClientWidth;
      FOwnerSize.cy:=(Owner as TForm).ClientHeight;
      HorScrollV:=(Owner as TForm).HorzScrollBar.IsScrollBarVisible;
      VerScrollV:=(Owner as TForm).VertScrollBar.IsScrollBarVisible;
      AllBackIsUpdated;
      DrawOnForm;
    end else
    begin
      if (csDesigning in ComponentState) then
        begin
          if BackisCleared  then
            begin
              if (AFirstSemi<>nil) then DrawOnForm;// else (Owner as TForm).Invalidate;
            end;
        end;
    end;
  if assigned((Owner as TForm).OnPaint) then
    begin
      AProcedure1:=(Owner as TForm).OnPaint;
      AProcedure2:=OnFormPaint;
      if @AProcedure1<>@AProcedure2 then
        begin
          ShowMessage('Please do not change OnPaint Event, I Will Correct');
          (Owner as TForm).OnPaint:=OnFormPaint;
        end;
    end else
    begin
      (Owner as TForm).OnPaint:=OnFormPaint;
    end;

end;
procedure TNVIAC_BASIS.BackIsUpdated(AControl : TControl);
var
  AWorkSemi : PNVIACSemi_LIST;
  ASize,ASize1 : TSize;
  AOffset,AOffset1 : TPoint;
  ARect,ACurrRect : TRect;
  ARGN,ARGN2 :HRGN;
begin
  if (AFirstSemi=nil) or (not IsNotLoadingDestroying) then exit;
  if not assigned(Owner) then exit;
  if INeedRearrange then
    begin
      INeedRearrange:=False;
      ReArrangeSemi;
    end;
  ASize:=GetControlPosition(AControl);
  AOffset.x:=ASize.cx;
  AOffset.y:=ASize.cy;
  ASize.cx:=AControl.Width;
  ASize.cy:=AControl.Height;
  ABasisBitmap.Width:=(Owner as TForm).ClientWidth;
  ABasisBitmap.Height:=(Owner as TForm).ClientHeight;
  DrawBack(ABasisBitmap.Canvas.Handle,Rect(0,0,ABasisBitmap.Width,ABasisBitmap.Height));


  AWorkSemi:=AFirstSemi;
  repeat
    if AWorkSemi.ASemi.IsVisible then
      begin
        ASize1:=AWorkSemi.ASemi.GetCurrentSize;
        AOffset1:=AWorkSemi.ASemi.GetCurrentOffset;
        intersectrect(ARect,Rect(AOffset.x,AOffset.y,AOffset.x+ASize.cx,AOffset.y+ASize.cy),
                            Rect(AOffset1.x,AOffset1.y,AOffset1.x+ASize1.cx,AOffset1.y+ASize1.cy));
        if not  IsRectEmpty(ARect) then
          begin
            ACurrRect:=Rect(AOffset.x,AOffset.y,ASize.cx+AOffset.x,AOffset.y+ASize.cy);
            OffsetRect(ACurrRect,-AOffset1.x,-AOffset1.y);
            AWorkSemi.ASemi.SetCurrRect(ACurrRect);
            ARGN:=AWorkSemi.ASemi.GetCurrentRegion;
            ARGN2:=GetControlVisualRGN(AWorkSemi.ASemi.GetSemiControl);
              if ARGN2<>0 then
                begin
                  CombineRGN(ARGN,ARGN,ARGN2,RGN_AND);
                  DeleteObject(ARGN2);
                end;
            if ARGN=0 then
              begin
                if AWorkSemi.ASemi.GetSemiClass=1 then
                  begin// by alpha
                    NVIAC_GetAlphaBitmap24(ABasisBitmap,AWorkSemi.ASemi.GetCurrentBitmap,AWorkSemi.ASemi.GetAlpha,
                                           AOffset1.x,AOffset1.y);
                  end else
                  begin

                   NVIAC_GetABitAlphaBitmap24(ABasisBitmap,AWorkSemi.ASemi.GetCurrentBitmap,AWorkSemi.ASemi.GetAlphaBitmap,
                                                   AOffset1.x,AOffset1.y);

                  end;
              end else
              begin
                if AWorkSemi.ASemi.GetSemiClass=1 then
                  begin// by alpha
                    NVIAC_GetAlphaBitmap24RGN(ABasisBitmap,AWorkSemi.ASemi.GetCurrentBitmap,AWorkSemi.ASemi.GetAlpha,
                                              AOffset1.x,AOffset1.y,ARGN);
                  end else
                  begin
                    NVIAC_GetABitAlphaBitmap24RGN(ABasisBitmap,AWorkSemi.ASemi.GetCurrentBitmap,AWorkSemi.ASemi.GetAlphaBitmap,
                                                  AOffset1.x,AOffset1.y,ARGN);
                  end;
              end;
            AWorkSemi.ASemi.ContinueBitmap;//Draw the Bitmap...to end...
            //Back updating...
            if ARGN=0 then
              begin
                ABasisBitmap.Canvas.Draw(AOffset1.x,AOffset1.y,AWorkSemi.ASemi.GetFullBitmap);
              end else
              begin
                OffsetRGN(ARGN,AOffset1.x,AOffset1.y);
                SelectClipRgn(ABasisBitmap.canvas.handle,ARGN);
                ABasisBitmap.Canvas.Draw(AOffset1.x,AOffset1.y,AWorkSemi.ASemi.GetFullBitmap);
                SelectClipRgn(ABasisBitmap.canvas.handle,0);
                OffsetRGN(ARGN,-AOffset1.x,-AOffset1.y);
                DeleteObject(ARGN);
              end;

            AWorkSemi.ASemi.TryPaint; //invalidating...
          end;
        AWorkSemi.ASemi.SetCurrRect(Rect(0,0,0,0));
      end;
    AWorkSemi:=AWorkSemi.NextSemi;
  until not assigned(AWorkSemi);
end;
procedure TNVIAC_BASIS.AllBackIsUpdated;
var
  AWorkSemi : PNVIACSemi_LIST;
  ASize,ASize1 : TSize;
  AOffset,AOffset1 : TPoint;
  ARect,ACurrRect : TRect;
  ARGN,ARGN2 :HRGN;
begin

  if (not assigned(Owner)) or (not (Owner is TForm)) or (not(Owner as TForm).HandleAllocated) or
     (not IsNotLoadingDestroying) then exit;
  if INeedRearrange then
    begin
      INeedRearrange:=False;
      ReArrangeSemi;
    end;   
  AOffset.x:=0;
  AOffset.y:=0;
  ASize.cx:=(Owner as TForm).ClientWidth;
  ASize.cy:=(Owner as TForm).ClientHeight;
  ABasisBitmap.Width:=(Owner as TForm).ClientWidth;
  ABasisBitmap.Height:=(Owner as TForm).ClientHeight;
  DrawBack(ABasisBitmap.Canvas.Handle,Rect(0,0,ABasisBitmap.Width,ABasisBitmap.Height));
  if AFirstSemi=nil then exit;

  AWorkSemi:=AFirstSemi;
  repeat
    if AWorkSemi.ASemi.IsVisible then
      begin
        ASize1:=AWorkSemi.ASemi.GetCurrentSize;
        AOffset1:=AWorkSemi.ASemi.GetCurrentOffset;
        intersectrect(ARect,Rect(AOffset.x,AOffset.y,AOffset.x+ASize.cx,AOffset.y+ASize.cy),
                            Rect(AOffset1.x,AOffset1.y,AOffset1.x+ASize1.cx,AOffset1.y+ASize1.cy));
        if not  IsRectEmpty(ARect) then
          begin
            ACurrRect:=Rect(AOffset.x,AOffset.y,ASize.cx+AOffset.x,AOffset.y+ASize.cy);
            OffsetRect(ACurrRect,-AOffset1.x,-AOffset1.y);
            AWorkSemi.ASemi.SetCurrRect(ACurrRect);
            ARGN:=AWorkSemi.ASemi.GetCurrentRegion;
            ARGN2:=GetControlVisualRGN(AWorkSemi.ASemi.GetSemiControl);
              if ARGN2<>0 then
                begin
                  CombineRGN(ARGN,ARGN,ARGN2,RGN_AND);
                  DeleteObject(ARGN2);
                end;
            if ARGN=0 then
              begin
                if AWorkSemi.ASemi.GetSemiClass=1 then
                  begin// by alpha
                    NVIAC_GetAlphaBitmap24(ABasisBitmap,AWorkSemi.ASemi.GetCurrentBitmap,AWorkSemi.ASemi.GetAlpha,
                                           AOffset1.x,AOffset1.y);
                  end else
                  begin

                   NVIAC_GetABitAlphaBitmap24(ABasisBitmap,AWorkSemi.ASemi.GetCurrentBitmap,AWorkSemi.ASemi.GetAlphaBitmap,
                                                   AOffset1.x,AOffset1.y);

                  end;
              end else
              begin
                if AWorkSemi.ASemi.GetSemiClass=1 then
                  begin// by alpha
                    NVIAC_GetAlphaBitmap24RGN(ABasisBitmap,AWorkSemi.ASemi.GetCurrentBitmap,AWorkSemi.ASemi.GetAlpha,
                                              AOffset1.x,AOffset1.y,ARGN);
                  end else
                  begin
                    NVIAC_GetABitAlphaBitmap24RGN(ABasisBitmap,AWorkSemi.ASemi.GetCurrentBitmap,AWorkSemi.ASemi.GetAlphaBitmap,
                                                  AOffset1.x,AOffset1.y,ARGN);
                  end;
              end;
            AWorkSemi.ASemi.ContinueBitmap;//Draw the Bitmap...to end...
            //Back updating...
            if ARGN=0 then
              begin
                ABasisBitmap.Canvas.Draw(AOffset1.x,AOffset1.y,AWorkSemi.ASemi.GetFullBitmap);
              end else
              begin
                OffsetRGN(ARGN,AOffset1.x,AOffset1.y);
                SelectClipRgn(ABasisBitmap.canvas.handle,ARGN);
                ABasisBitmap.Canvas.Draw(AOffset1.x,AOffset1.y,AWorkSemi.ASemi.GetFullBitmap);
                SelectClipRgn(ABasisBitmap.canvas.handle,0);
                OffsetRGN(ARGN,-AOffset1.x,-AOffset1.y);
                DeleteObject(ARGN);
              end;

            AWorkSemi.ASemi.TryPaint; //invalidating...
          end;
        AWorkSemi.ASemi.SetCurrRect(Rect(0,0,0,0));
      end;
    AWorkSemi:=AWorkSemi.NextSemi;
  until not assigned(AWorkSemi);
end;

procedure TNVIAC_BASIS.DrawBack(DC : HDC;ARect : TRect);
var ACanvas : TCanvas;
    i,j : integer;
begin
  if (not assigned(Owner)) or (not (Owner as TForm).HandleAllocated) or (not assigned(FFormBitmap))
  or (not IsNotLoadingDestroying) then exit;
  ACanvas:=TCanvas.Create;
  ACanvas.Handle:=DC;
  ACanvas.Lock;
  ACanvas.Brush.Color:=(Owner as TForm).Color;
  ACanvas.FillRect(ARect);
  if (FFormBitmap.Width>0) and (FFormBitmap.Height>0) then
  case FFormBitmapApply of
    nviacbaTile :
      begin
        for i:=0 to (ARect.Right-ARect.Left) div FFormBitmap.Width do
          for j:=0 to (ARect.Bottom-ARect.Top) div FFormBitmap.Height do
            begin
              ACanvas.Draw(ARect.Left+i*FFormBitmap.Width,
                           ARect.Top+j*FFormBitmap.Height,FFormBitmap);
            end;
      end;
    nviacbaCenter :
      begin
        ACanvas.Draw(ARect.Left+(ARect.Right-ARect.Left-FFormBitmap.Width ) div 2,
                     ARect.Top+ (ARect.Bottom-ARect.Top-FFormBitmap.Height) div 2,FFormBitmap);
      end;
    nviacbaStretch :
      begin
        //ACanvas.StretchDraw(ARect,FFormBitmap);
        SetStretchBltMode(ACanvas.Handle,COLORONCOLOR);
       // SetStretchBltMode(ACanvas.Handle,HALFTONE);
       // SetBrushOrgEx(ACanvas.Handle,0,0,nil);
        StretchBlt(ACanvas.Handle,ARect.Left,ARect.Top,ARect.Right,ARect.Bottom,FFormBitmap.Canvas.Handle,0,0,
        FFormBitmap.Width,FFormBitmap.Height,SRCCOPY);
      end;
    nviacbaCenterTile :
      begin
        for i:=0 to (ARect.Right-ARect.Left) div (2*FFormBitmap.Width) do
          for j:=0 to (ARect.Bottom-ARect.Top) div (2*FFormBitmap.Height) do
            begin
              ACanvas.Draw(ARect.Left+(ARect.Right-ARect.Left) div 2+i*FFormBitmap.Width,
                           ARect.Top+ (ARect.Bottom-ARect.Top) div 2+j*FFormBitmap.Height,FFormBitmap);
              ACanvas.Draw(ARect.Left+(ARect.Right-ARect.Left) div 2-(i+1)*FFormBitmap.Width,
                           ARect.Top+ (ARect.Bottom-ARect.Top) div 2+j*FFormBitmap.Height,FFormBitmap);
              ACanvas.Draw(ARect.Left+(ARect.Right-ARect.Left) div 2+i*FFormBitmap.Width,
                           ARect.Top+ (ARect.Bottom-ARect.Top) div 2-(j+1)*FFormBitmap.Height,FFormBitmap);
              ACanvas.Draw(ARect.Left+(ARect.Right-ARect.Left) div 2-(i+1)*FFormBitmap.Width,
                           ARect.Top+ (ARect.Bottom-ARect.Top) div 2-(j+1)*FFormBitmap.Height,FFormBitmap);
            end;
      end;
  end;
  if (csDesigning in ComponentState) and FGridEnabled then
    begin
      ACanvas.Pen.Color:=FGridColor;
      for i:=0 to (Owner as TForm).ClientWidth div FGridSizeDesign do
        begin
          ACanvas.MoveTo(i*FGridSizeDesign,0);
          ACanvas.LineTo(i*FGridSizeDesign,(Owner as TForm).ClientHeight);
        end;
      for i:=0 to (Owner as TForm).ClientHeight div FGridSizeDesign do
        begin
          ACanvas.MoveTo(0,i*FGridSizeDesign);
          ACanvas.LineTo((Owner as TForm).ClientWidth,i*FGridSizeDesign);
        end;
    end;
  ACanvas.Unlock;
  ACanvas.Handle:=0;
  ACanvas.Free;
end;

function TNVIAC_BASIS.BackisCleared: Boolean;

begin
  Result:=false;
  if (4*(ATimerData div 4)) = ATimerData then Result:=True;
end;

function TNVIAC_BASIS.IsHandleOfMe(AWinControl : TWinControl;AHandle : HWND;out AWinControlRes : TWinControl): Boolean;
var i : Integer;
begin
  if Assigned(AWinControl) and AWinControl.HandleAllocated then
    begin
      if AWinControl.Handle=AHandle then
        begin
          AWinControlRes:=AWinControl;
          Result:=True;
        end else
        begin
          Result:=False;
          for i:=0 to AWinControl.ControlCount-1 do
            begin
              if (AWinControl.Controls[i] is TWinControl) then
                begin
                  Result:=IsHandleOfMe((AWinControl.Controls[i] as TWinControl),AHandle,AWinControlRes);
                  if Result then break;
                end;
            end;
        end;
    end else
    begin
      AWinControlRes:=nil;
      Result:=false;
    end;
end;



function TNVIAC_BASIS.IsNotLoadingDestroying: Boolean;
begin
  if assigned(Owner) and (Owner is TForm) and (Owner as TForm).HandleAllocated and
    (not (csLoading in (Owner as TForm).ComponentState)) and
    (not (csReading in (Owner as TForm).ComponentState)) and
    (not (csDestroying in (Owner as TForm).ComponentState)) then Result:=True else Result:=False;
end;

procedure TNVIAC_BASIS.AddToSemiQueue2(ASemi: INVIAC_SEMITRANSPARENCE);
var
  AOldSemi2 : PNVIACSemi_LIST;
begin
  //add to end of queue...
  AOldSemi2:=ACurrSemi2;
  New(ACurrSemi2);
  ACurrSemi2.ASemi:=ASemi;
  ACurrSemi2.NextSemi:=nil;
  if nil<>AOldSemi2 then
    begin
      AOldSemi2.NextSemi:=ACurrSemi2;
      ACurrSemi2.PreviousSemi:=AOldSemi2;
    end else
    begin
      ACurrSemi2.PreviousSemi:=Nil;
    end;
  if nil=AFirstSemi2 then AFirstSemi2:=ACurrSemi2;
  ALastSemi2:=ACurrSemi2;
end;

procedure TNVIAC_BASIS.ArrangeSemiAt(AWinControl: TWinControl;  var NumberEated: integer; NumberAll: integer);
var AControl: TControl;
    TempP,TempP2 : PNVIACSemi_LIST;
    NoIn : Boolean;
    i: integer;
    AInterface : INVIAC_SEMITRANSPARENCE;
begin
  //Finding of main controls

  TempP:=AFirstSemi;
  while nil<>TempP do
    begin
      AControl:=TempP.ASemi.GetSemiControl;
      if AControl is TWinControl then
        begin
        end else
        begin
          if (AControl.Parent=AWinControl) then
            begin
              inc(NumberEated);
              AddToSemiQueue2(TempP.ASemi);
            end;
        end;
      TempP:=TempP.NextSemi;
    end;
  if NumberEated>=NumberAll then exit;
  //finding of wincontrols
  for i:=0 to AWinControl.ControlCount-1 do
    begin
      if AWinControl.Controls[i] is TWinControl then
        begin
          if AWinControl.Controls[i].GetInterface(INVIAC_SEMITRANSPARENCE,AInterface) then
            begin
              inc(NumberEated);
              AddToSemiQueue2(AInterface);
              if NumberEated>=NumberAll then Break;
            end;
          ArrangeSemiAt(AWinControl.Controls[i] as TWinControl,NumberEated,NumberAll);
          if NumberEated>=NumberAll then Break;
        end;
    end;
  if NumberEated>=NumberAll then exit;
  //Last for Any Case....
  if AWinControl=Owner then
    begin
      TempP:=AFirstSemi;
      while nil<>TempP do
        begin
          TempP2:=AFirstSemi2;
          NoIn:=True;
          while nil<>TempP2 do
            begin
              if TempP.ASemi=TempP2.ASemi then
                begin
                  NoIn:=False;
                  Break;
                end;
              TempP2:=TempP2.NextSemi;
            end;
          if NoIn then
            begin
              inc(NumberEated);
              AddToSemiQueue2(TempP.ASemi);
            end;
          if TempP=ALastSemi then break;  
          TempP:=TempP.NextSemi;
        end;
    end;
end;

procedure TNVIAC_BASIS.ReArrangeSemi;
var AllNumber,NumberEated : integer;
    TempP : PNVIACSemi_LIST;
begin
  AFirstSemi2:=NIL;
  ALastSemi2:=NIl;
  ACurrSemi2:=NIL;
  TempP:=AFirstSemi;AllNumber:=0;
  while nil<>TempP do
    begin
      inc(AllNumber);
      TempP:=TempP.NextSemi;
    end;
  if (AllNumber>0) then
    begin
      NumberEated:=0;
      ArrangeSemiAt(Owner as TForm,NumberEated,AllNumber);
      MoveQueue2to1;
    end;
end;

procedure TNVIAC_BASIS.MoveQueue2to1;
var TempP1,TempP2 : PNVIACSemi_LIST;
begin
  TempP1:=AFirstSemi;
  TempP2:=AFirstSemi2;
  while TempP1<>nil do
    begin
      TempP1.ASemi:=TempP2.ASemi;
      TempP1:=TempP1.NextSemi;
      TempP2:=Tempp2.NextSemi;
    end;
  while nil<>ALastSemi2 do
    begin
      ACurrSemi2:=ALastSemi2.PreviousSemi;
      Dispose(ALastSemi2);
      ALastSemi2:=ACurrSemi2;
    end;
end;

procedure TNVIAC_BASIS.SetGridSizeDesign(Value: byte);
begin
  if (Value<>FGridSizeDesign) and (Value>0) then
    begin
      FGridSizeDesign := Value;
      if csDesigning in ComponentState then
        begin
          AllBackIsUpdated;
          DrawOnForm;
        end;
    end;
end;

procedure TNVIAC_BASIS.SetGridColor(Value: Tcolor);
begin
  if Value<>FGridColor then
    begin
      FGridColor := Value;
      if csDesigning in ComponentState then
        begin
          AllBackIsUpdated;
          DrawOnForm;
        end;
    end;
end;

function TNVIAC_BASIS.SemiIsChild(AParentSemi,ATestSemi: INVIAC_SEMITRANSPARENCE): Boolean;
var AControl1,AControl2 : TControl;
begin
  Result:=false;
  AControl1:= AParentSemi.GetSemiControl;
  if AControl1 is TWinControl then
    begin
      AControl2:=ATestSemi.GetSemiControl;
      while assigned(AControl2.Parent) do
        begin
          if AControl1=AControl2.Parent then
            begin
              Result:=True;
              Exit;
            end;
          AControl2:=AControl2.Parent;
        end;
    end;
end;

procedure TNVIAC_BASIS.SetGridEnabled(Value: Boolean);
begin
  if Value<>FGridEnabled then
    begin
      FGridEnabled := Value;
      if csDesigning in ComponentState then
        begin
          AllBackIsUpdated;
          DrawOnForm;
        end;
    end;
end;

procedure TNVIAC_BASIS.AddToTimerQueue(ATimed: INVIAC_TIMER);
var
  AOldTimed : PNVIACTimer_LIST;
begin
  //add to end of queue...
  AOldTimed:=ACurrTimed;
  New(ACurrTimed);
  ACurrTimed.ATimed:=ATimed;
  ACurrTimed.NextTimed:=nil;
  if nil<>AOldTimed then
    begin
      AOldTimed.NextTimed:=ACurrTimed;
      ACurrTimed.PreviousTimed:=AOldTimed;
    end else
    begin
      ACurrTimed.PreviousTimed:=Nil;
    end;
  if nil=AFirstTimed then AFirstTimed:=ACurrTimed;
  ALastTimed:=ACurrTimed;
end;

procedure TNVIAC_BASIS.RemoveFromTimerQueue(ATimed: INVIAC_TIMER);
var
  AFoundTimed : PNVIACTimer_LIST;
begin
  AFoundTimed:=AFirstTimed;
  if nil<>AFoundTimed then
    begin
      while (ATimed<>AFoundTimed.ATimed) and (nil<>AFoundTimed.NextTimed) do AFoundTimed:=AFoundTimed.NextTimed;
      if ATimed=AFoundTimed.ATimed then
        begin
          if nil<>AFoundTimed.PreviousTimed then
            begin
              AFoundTimed.PreviousTimed.NextTimed:=AFoundTimed.NextTimed;
            end;
          if nil<>AFoundTimed.NextTimed then
            begin
              AFoundTimed.NextTimed.PreviousTimed:=AFoundTimed.PreviousTimed;
            end;
          if AFirstTimed=AFoundTimed then
            begin
              AFirstTimed:=AFoundTimed.NextTimed;
            end;
          if ALastTimed=AFoundTimed then
            begin
              ALastTimed:=AFoundTimed.PreviousTimed;
            end;
          if ACurrTimed=AFoundTimed then
            begin
              if nil<>AFoundTimed.PreviousTimed then
                begin
                  ACurrTimed:=AFoundTimed.PreviousTimed;
                end else
                begin
                  ACurrTimed:=AFoundTimed.NextTimed;
                end;
            end;  
          Dispose(AFoundTimed);
        end;
    end;
end;

procedure TNVIAC_BASIS.ProcessTimerQueue(ANumberTick: Integer);
var AWorkTimed : PNVIACTimer_LIST;
begin
  FIntTimer.Suspend;
  AWorkTimed:=AFirstTimed;
  while assigned(AWorkTimed) do
    begin
      AWorkTimed.ATimed.TimerTick(ANumberTick);
      AWorkTimed:=AWorkTimed.NextTimed;
    end;
  FIntTimer.Resume;  
end;

initialization
  begin
    CurrMessageEater:=nil;
    FHook:=SetWindowsHookEx(WH_CALLWNDPROC,@MessageProc_,0,GetCurrentThreadId);
  end;
finalization
  begin  
    UnhookWindowsHookEx(FHook);
  end;

end.
