unit NVIAC_AnimaImage_Unit;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,NVIAC_BASIS,nviac_textlines_unit,
  nviac_bitmap_unit,ExtCtrls;

Type
TNVIAC_AnimaImage_SemiStyle =(nviacaissSimple,nviacaissMasked);
TNVIAC_AnimaImage_AnimaStyle = (nviacaiasSimple,nviacaiasMixing);
TNVIAC_AnimaImage = class(TGraphicControl,INVIAC_SEMITRANSPARENCE,INVIAC_TIMER)
private
  ATimerBasis : TNVIAC_BASIS;

  ABasis : TNVIAC_BASIS;
  ACurrRect : TRect;
  AImage : TBitmap;
  TimeIs : Integer;
  AAlphaImage,SuppBit : TBitmap;
  FSemiTransparence: Byte;
  FSemiMaskTransparence: Byte;
  FMaskColor: TColor;
  FImageList: TImageList;
  FSemiType: TNVIAC_AnimaImage_SemiStyle;
  FAnimaSemiList: TStringList;
  FCurrSemiIndex,FCurrAnimaIndex : Integer;
  FFramesTimeInterval: integer;
  FFramesByteFirst : Byte;
  FAnimationStyle: TNVIAC_AnimaImage_AnimaStyle;
  FAnimationEnabled: Boolean;
  AColor : TColor;
  FRepeatNumber,RepeatLeft: Integer;
  procedure GetBaseBitmap;
  procedure SetSemiTransparence(Value: Byte);
  function GetAutoSize: Boolean;
  function GetColor: TColor;
  function GetEnabled1: boolean;
  function GetVisible: boolean;
  procedure SetAutoSize(Value: Boolean);
  procedure SetColor(Value: TColor);
  procedure SetEnabled1(Value: boolean);
  procedure SetVisible(Value: boolean);
  procedure SetAnimaSemiList(Value: TStringList);
  procedure SetMaskColor(Value: TColor);
  procedure SetSemiMaskTransparence(Value: Byte);
  procedure SetSemiType(Value: TNVIAC_AnimaImage_SemiStyle);
  procedure SetImageList(Value: TImageList);
  procedure SetAnimationStyle(Value: TNVIAC_AnimaImage_AnimaStyle);
  procedure SetFramesTimeInterval(Value: integer);
  procedure SetAnimationEnabled(Value: Boolean);
  procedure SetRepeatNumber(Value: Integer);
protected
  procedure Paint; override;
  procedure Loaded; override;
  function CanAutoSize(var NewWidth, NewHeight: Integer): Boolean; override; 
  procedure SizedHiding;
  procedure SizedShowing;
public
  //Timer Interface begin
  procedure ReintroduceTimerBasis(ANewBasis : TNVIAC_BASIS);
  procedure TryRegisterTimer;
  procedure TryUnregisterTimer;
  procedure TimerTick(ANumberTick : Integer);//send the tick
  //Timer interface end
  //Semi interface begin
  procedure ReintroduceBasis(ANewBasis : TNVIAC_BASIS);
  procedure TryRegisterSemiQueque;
  procedure TryUnregisterSemiQueque;
  function GetFullBitmap: TBitmap;
  function GetCurrentSize : TSize;
  function GetCurrentBitmap: TBitmap;
  function GetCurrentOffset: TPoint;
  function GetCurrentRegion: HRGN;
  function GetSemiClass : Byte;//1 - Alpha,2 - bitmap
  function GetAlpha : Byte;
  function GetAlphaBitmap : TBitmap;
  procedure ContinueBitmap;
  procedure TryPaint;
  procedure SetCurrRect(ARect : TRect);
  function GetSemiControl: TControl;
  function IsVisible: Boolean;
  //Semi Interface End
  constructor Create(AOwner: TComponent); override;
  destructor Destroy; override;
  procedure SetBounds(ALeft, ATop, AWidth, AHeight: Integer);override;
published
  property AutoSize : Boolean read GetAutoSize write SetAutoSize;
  property Enabled : boolean read GetEnabled1 write SetEnabled1;
  property Visible : boolean read GetVisible write SetVisible;

  property Align;
  property Anchors;
  property Constraints;
  property DragCursor;
  property DragKind;
  property DragMode;
  property ParentShowHint;
  property PopupMenu;
  property ShowHint;
  property OnClick;
  property OnDblClick;
  property OnDragDrop;
  property OnDragOver;
  property OnEndDock;
  property OnEndDrag;
  property OnMouseDown;
  property OnMouseMove;
  property OnMouseUp;
  property OnStartDock;
  property OnStartDrag;
  property Color : TColor read GetColor write SetColor;
  property ParentColor;
  //Defined properties
  property SemiTransparence : Byte read FSemiTransparence write SetSemiTransparence default 0;
  property SemiMaskTransparence : Byte read FSemiMaskTransparence write SetSemiMaskTransparence default 255;
  property SemiType : TNVIAC_AnimaImage_SemiStyle read FSemiType write SetSemiType default nviacaissSimple;
  property MaskColor : TColor read FMaskColor write SetMaskColor default clBlack;
  property AnimaImageList : TImageList read FImageList write SetImageList;
  property AnimaSemiList : TStringList read FAnimaSemiList write SetAnimaSemiList;
  property FramesTimeInterval : integer read FFramesTimeInterval write SetFramesTimeInterval default 1;
  property AnimationStyle : TNVIAC_AnimaImage_AnimaStyle read FAnimationStyle write SetAnimationStyle
                            default nviacaiasSimple;
  property AnimationEnabled : Boolean read FAnimationEnabled write SetAnimationEnabled default True;
  property RepeatNumber : Integer read FRepeatNumber write SetRepeatNumber;
end;
implementation

{ TNVIAC_AnimaImage }

function TNVIAC_AnimaImage.CanAutoSize(var NewWidth,NewHeight: Integer): Boolean;
begin
  Result := True;
  if assigned(FImageList) and (FImageList.Count>0) and AutoSize then
    begin
      NewWidth:=FImageList.Width;
      NewHeight:=FImageList.Height;
    end else
    begin
      NewWidth:=Width;
      NewHeight:=Height;
    end;
end;

procedure TNVIAC_AnimaImage.ContinueBitmap;
var ARect : TRect;
    ARGN: HRGN;
begin
// here we continue to get the bitmap after semi...
  if assigned(AImage) and (AImage.Width>0) and (AImage.Height>0) then
    begin
      intersectrect(ARect,ACurrRect,Rect(0,0,AImage.Width,AImage.Height));
      if IsRectEmpty(ACurrRect) then ARect:=Rect(0,0,AImage.Width,AImage.Height);
      ARGN:=CreateRectRGN(ARect.Left,ARect.Top,ARect.Right,ARect.Bottom);
      SelectClipRGN(AImage.Canvas.Handle,ARGN);
      SelectClipRGN(AImage.Canvas.Handle,0);
      DeleteObject(ARGN);
    end;
end;

constructor TNVIAC_AnimaImage.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  if not Is_NVIAC_BASIS_We_Got(Self,ABasis) then
    begin
      Reintroduce_NVIAC_BASIS(Self);
      Is_NVIAC_BASIS_We_Got(Self,ABasis);
    end;
  TryRegisterSemiQueque;
  ATimerBasis:=ABasis;
  TryRegisterTimer;
  ControlStyle := ControlStyle + [csOpaque];
  inherited SetBounds(Left,Top,96,96);
  AImage:=TBitmap.Create;
  AImage.PixelFormat:=pf24Bit;
  AImage.Width:=Width;
  AImage.Height:=Height;
  SuppBit:=TBitmap.Create;
  SuppBit.PixelFormat:=pf24Bit;
  SuppBit.Width:=Width;
  SuppBit.Height:=Height;

  FSemiTransparence:=0;
  FSemiMaskTransparence:=255;
  FMaskColor:=clBlack;
  FImageList:=nil;
  FSemiType:=nviacaissSimple;
  FAnimaSemiList:=TStringList.Create;
  {List of Byte values of semitransparence at one space
   0 255
   20 240
   22 230
  }
  AAlphaImage:=TBitmap.Create;
  AAlphaImage.PixelFormat:=pf24Bit;
  FFramesTimeInterval:=1;
  FAnimationStyle:=nviacaiasSimple;
  FAnimationEnabled:=True;
  FRepeatNumber :=-1;
  RepeatLeft:=-1;
end;

destructor TNVIAC_AnimaImage.Destroy;
begin
  TryUnRegisterTimer;
  TryUnregisterSemiQueque;
  FAnimaSemiList.Free;
  AAlphaImage.Free;
  SuppBit.Free;
  AImage.Free;
  inherited Destroy;
end;

function TNVIAC_AnimaImage.GetAlpha: Byte;
var s : string;
    n : integer;
begin
  if assigned(FAnimaSemiList) and (FAnimaSemiList.Count>0) and (FCurrSemiIndex>=0) then
    begin
      s:=FAnimaSemiList.Strings[FCurrSemiIndex];
      n:=pos(' ',s);
      s:=copy(s,1,n-1);
      Result:=strtointdef(s,FSemiTransparence);
    end else
    begin
      Result:=FSemiTransparence;
    end;
end;

function TNVIAC_AnimaImage.GetAlphaBitmap: TBitmap;
var B1 : TBitmap;
    k1,k2,k1b,k2b : Byte;
    s : string;
    n,FNextSemiIndex : integer;
begin
  AAlphaImage.Width:=AImage.Width;
  AAlphaImage.Height:=AImage.Height;
  if assigned(FAnimaSemiList) and (FAnimaSemiList.Count>0) and (FCurrSemiIndex>=0) then
    begin
      s:=FAnimaSemiList.Strings[FCurrSemiIndex];
      n:=pos(' ',s);
      s:=copy(s,1,n-1);
      k1:=strtointdef(s,FSemiTransparence);
      s:=FAnimaSemiList.Strings[FCurrSemiIndex];
      s:=copy(s,n+1,length(s)-n);
      k2:=strtointdef(s,FSemiTransparence);
    end else
    begin
      k1:=FSemiTransparence;
      k2:=FSemiMaskTransparence;
    end;
  //=============
  SuppBit.Width:=AImage.Width;
  SuppBit.Height:=AImage.Height;
  if FAnimationStyle=nviacaiasMixing then
    begin

      if assigned(FAnimaSemiList) and (FAnimaSemiList.Count>0) and (FCurrSemiIndex>=0) then
        begin
          FNextSemiIndex:=FCurrSemiIndex+1;
          if FNextSemiIndex>=FAnimaSemiList.Count then FNextSemiIndex:=0;
          s:=FAnimaSemiList.Strings[FNextSemiIndex];
          n:=pos(' ',s);
          s:=copy(s,1,n-1);
          k1b:=strtointdef(s,FSemiTransparence);
          s:=FAnimaSemiList.Strings[FNextSemiIndex];
          s:=copy(s,n+1,length(s)-n);
          k2b:=strtointdef(s,FSemiTransparence);
          k1:=(k1*FFramesByteFirst+k1b*(255-FFramesByteFirst)) div 255;
          k2:=(k2*FFramesByteFirst+k2b*(255-FFramesByteFirst)) div 255;
        end;
    end;

  //=============
  if Assigned(FImageList) and (FImageList.Count>0) and (FCurrAnimaIndex>=0) then
    begin
      B1:=NVIAC_GetTransparentBitmapMask(SuppBit,ColorToRGB(AColor),k2,k1);
      AAlphaImage.Canvas.Draw(0,0,B1);
      B1.Free;
    end else
    begin
      AAlphaImage.Canvas.Brush.Color:=clBlack;
      AAlphaImage.Canvas.FillRect(Rect(0,0,AAlphaImage.Width,AAlphaImage.Height));
    end;
  Result:=AAlphaImage;
end;

function TNVIAC_AnimaImage.GetAutoSize: Boolean;
begin
  Result:=inherited AutoSize;
end;

procedure TNVIAC_AnimaImage.GetBaseBitmap;
begin
  if assigned(AImage) and (inherited Width>0) and (inherited Height>0)then
    begin
      AImage.Width:=inherited Width;
      AImage.Height:=inherited Height;
      if Assigned(ABasis) then ABasis.SemiIsUpdated(self);
    end;
end;

function TNVIAC_AnimaImage.GetColor: TColor;
begin
  Result:=inherited Color;
end;

function TNVIAC_AnimaImage.GetCurrentBitmap: TBitmap;
var ARect : TRect;
    ARGN: HRGN;
begin
  intersectrect(ARect,ACurrRect,Rect(0,0,Width,Height));
  if IsRectEmpty(ACurrRect) then ARect:=Rect(0,0,Width,Height);
  ARGN:=CreateRectRGN(ARect.Left,ARect.Top,ARect.Right,ARect.Bottom);

  AImage.Width:=Width;
  AImage.Height:=Height;
  SelectClipRGN(AImage.Canvas.Handle,ARGN);

  AImage.Canvas.Brush.Style := bsSolid;
  AImage.Canvas.Brush.Color:=ColorToRGB(Color);
  AImage.Canvas.FillRect(Rect(0,0,AImage.Width,AImage.Height));
  //FCurrAnimaIndex
  if assigned(FImageList) and (FImageList.Count>0) then
    begin
      case FAnimationStyle of
        nviacaiasSimple :
          begin
            FImageList.Draw(AImage.Canvas,0,0,FCurrAnimaIndex);
          end;
        nviacaiasMixing :
          begin
            AImage.Canvas.Draw(0,0,SuppBit);
          end;
      end;
    end;
  SelectClipRGN(AImage.Canvas.Handle,0);
  DeleteObject(ARGN);
  result:=AImage;
end;


function TNVIAC_AnimaImage.GetCurrentOffset: TPoint;
var APos1 : TSize;
begin
  APos1:=GetControlPosition(Self);
  Result.x:=APos1.cx;
  Result.y:=APos1.cy;
end;

function TNVIAC_AnimaImage.GetCurrentRegion: HRGN;
var ARect : TRect;
begin
  intersectrect(ARect,ACurrRect,Rect(0,0,AImage.Width,AImage.Height));
  if IsRectEmpty(ACurrRect) then ARect:=Rect(0,0,AImage.Width,AImage.Height);
  Result:=CreateRectRGN(ARect.Left,ARect.Top,ARect.Right,ARect.Bottom);
end;

function TNVIAC_AnimaImage.GetCurrentSize: TSize;
begin
  Result.cx:=AImage.Width;
  Result.cy:=AImage.Height;
end;

function TNVIAC_AnimaImage.GetEnabled1: boolean;
begin
  Result:=inherited Enabled;
end;

function TNVIAC_AnimaImage.GetFullBitmap: TBitmap;
begin
  Result:=AImage;
end;

function TNVIAC_AnimaImage.GetSemiClass: Byte;
begin
  case FSemiType of
    nviacaissSimple :
      begin
        Result:=1;
      end;
    nviacaissMasked :
      begin
        Result:=2;
      end;
    else Result:=1;  
  end;
end;

function TNVIAC_AnimaImage.GetSemiControl: TControl;
begin
  Result:=Self;
end;

function TNVIAC_AnimaImage.GetVisible: boolean;
begin
  Result:=inherited Visible;
end;

function TNVIAC_AnimaImage.IsVisible: Boolean;
begin
  Result:=inherited Visible;
end;

procedure TNVIAC_AnimaImage.Loaded;
begin
  inherited Loaded;
  SizedShowing;
end;

procedure TNVIAC_AnimaImage.Paint;
begin
  if assigned(AImage) and Visible then
    begin
      Canvas.Draw(0,0,AImage);
    end;
end;

procedure TNVIAC_AnimaImage.ReintroduceBasis(ANewBasis: TNVIAC_BASIS);
begin
  ABasis:=ANewBasis;
end;

procedure TNVIAC_AnimaImage.ReintroduceTimerBasis(ANewBasis: TNVIAC_BASIS);
begin
  ATimerBasis:=ANewBasis;
end;

procedure TNVIAC_AnimaImage.SetAnimaSemiList(Value: TStringList);
begin
  if Assigned(Value) then
    begin
      FAnimaSemiList.Text := Value.Text;
      if FCurrSemiIndex<0 then FCurrSemiIndex:=0;
      if FCurrSemiIndex>=FAnimaSemiList.Count then FCurrSemiIndex:=0;
      if FAnimaSemiList.Count=0 then FCurrSemiIndex:=-1;
    end else
    begin
      FAnimaSemiList.Clear;
      FCurrSemiIndex:=-1;
    end;
end;

procedure TNVIAC_AnimaImage.SetAnimationEnabled(Value: Boolean);
begin
  FAnimationEnabled := Value;
  if Value then RepeatLeft:=FRepeatNumber;
end;

procedure TNVIAC_AnimaImage.SetAnimationStyle(Value: TNVIAC_AnimaImage_AnimaStyle);
begin
  FAnimationStyle := Value;
end;

procedure TNVIAC_AnimaImage.SetAutoSize(Value: Boolean);
begin
  inherited AutoSize:=Value;
  if assigned(FImageList) and (FImageList.Count>0) and Value then
    begin
      SetBounds(Left, Top, FImageList.Width, FImageList.Height);
    end;
end;

procedure TNVIAC_AnimaImage.SetBounds(ALeft, ATop, AWidth,AHeight: Integer);
begin
  SizedHiding;
  inherited SetBounds(ALeft, ATop, AWidth, AHeight);
  SizedShowing;
end;

procedure TNVIAC_AnimaImage.SetColor(Value: TColor);
begin
  inherited Color:=Value;
  SizedShowing;
end;

procedure TNVIAC_AnimaImage.SetCurrRect(ARect: TRect);
begin
  ACurrRect.Left:=ARect.Left;
  ACurrRect.Top:=ARect.Top;
  ACurrRect.Right:=ARect.Right;
  ACurrRect.Bottom:=ARect.Bottom;
end;

procedure TNVIAC_AnimaImage.SetEnabled1(Value: boolean);
begin
  inherited Enabled:=Value;
  SizedShowing;
end;

procedure TNVIAC_AnimaImage.SetFramesTimeInterval(Value: integer);
begin
  FFramesTimeInterval := Value;
end;

procedure TNVIAC_AnimaImage.SetImageList(Value: TImageList);
begin
  FImageList := Value;
  if assigned(FImageList) then
    begin
      if FImageList.Count>0 then
        begin
          if FCurrAnimaIndex<0 then FCurrAnimaIndex:=0;
          if FCurrAnimaIndex>=FImageList.Count then FCurrAnimaIndex:=0;
        end else
        begin
          FCurrAnimaIndex:=-1;
        end;
    end else
    begin
      FCurrAnimaIndex:=-1;
    end;
end;

procedure TNVIAC_AnimaImage.SetMaskColor(Value: TColor);
begin
  if Value<>FMaskColor then
    begin
      FMaskColor := Value;
      SizedShowing;
    end;
end;

procedure TNVIAC_AnimaImage.SetRepeatNumber(Value: Integer);
begin
  if FRepeatNumber<>Value Then
    begin
      FRepeatNumber := Value;
      RepeatLeft:=FRepeatNumber;
    end;
end;

procedure TNVIAC_AnimaImage.SetSemiMaskTransparence(Value: Byte);
begin
  if Value<>FSemiMaskTransparence then
    begin
      FSemiMaskTransparence := Value;
      SizedShowing;
    end;
end;

procedure TNVIAC_AnimaImage.SetSemiTransparence(Value: Byte);
begin
  if Value<>FSemiTransparence then
    begin
      FSemiTransparence := Value;
      SizedShowing;
    end;
end;

procedure TNVIAC_AnimaImage.SetSemiType(Value: TNVIAC_AnimaImage_SemiStyle);
begin
  if Value<>FSemiType then
    begin
      FSemiType := Value;
      SizedShowing;
    end;
end;

procedure TNVIAC_AnimaImage.SetVisible(Value: boolean);
begin
  if Value<>(inherited Visible) then
    begin
      inherited Visible:=Value;
      if Value then
        begin
          SizedShowing;
        end else
        begin
          SizedHiding;
        end;
    end;
end;

procedure TNVIAC_AnimaImage.SizedHiding;
begin
  if assigned(ABasis) and Assigned(AImage) and assigned(Parent) and parent.handleallocated
    and (not (csLoading in ComponentState))then
    begin
      AImage.Width:=Width;
      AImage.Height:=Height;
      ABasis.SemiIsHiding(self);
    end;
end;

procedure TNVIAC_AnimaImage.SizedShowing;
begin
  if assigned(Parent) and parent.handleallocated and (not (csLoading in ComponentState))then GetBaseBitmap;
end;

procedure TNVIAC_AnimaImage.TimerTick(ANumberTick: Integer);
var cr1,cr2,cg1,cg2,cb1,cb2 : Byte;
    FNextAnimaIndex : integer;
    B1 : TBitmap;
begin
//FFramesTimeInterval
  if (FFramesTimeInterval>0) and (Abs(TimeIs-ANumberTick)>=FFramesTimeInterval) and FAnimationEnabled  then
    begin
      inc(FCurrSemiIndex);
      inc(FCurrAnimaIndex);
      if Assigned(FAnimaSemiList) then
        begin
          if FCurrSemiIndex<0 then FCurrSemiIndex:=0;
          if FCurrSemiIndex>=FAnimaSemiList.Count then FCurrSemiIndex:=0;
          if FAnimaSemiList.Count=0 then FCurrSemiIndex:=-1;
        end else
        begin
          FCurrSemiIndex:=-1;
        end;
      if assigned(FImageList) then
        begin
          if FImageList.Count>0 then
            begin
              if FCurrAnimaIndex<0 then FCurrAnimaIndex:=0;
              if FCurrAnimaIndex>=FImageList.Count then
                begin
                  FCurrAnimaIndex:=0;
                  if RepeatLeft>0 then dec(RepeatLeft);
                end;
            end else
            begin
              FCurrAnimaIndex:=-1;
            end;
        end else
        begin
          FCurrAnimaIndex:=-1;
        end;
      if (RepeatLeft=0) and (not(csDesigning in ComponentState)) then
        begin
          FAnimationEnabled:=false;
        end;
      FFramesByteFirst:=255;
      TimeIs:=ANumberTick;
//=============
SuppBit.Width:=Width;
SuppBit.Height:=Height;
SuppBit.Canvas.Brush.Style := bsSolid;
SuppBit.Canvas.Brush.Color:=ColorToRGB(Color);
SuppBit.Canvas.FillRect(Rect(0,0,SuppBit.Width,SuppBit.Height));
AColor:=FMaskColor;
  if assigned(FImageList) and (FImageList.Count>0) then
    begin
      case FAnimationStyle of
        nviacaiasSimple :
          begin
            FImageList.Draw(SuppBit.Canvas,0,0,FCurrAnimaIndex);
          end;
        nviacaiasMixing :
          begin
            FNextAnimaIndex:=FCurrAnimaIndex+1;
            if  FNextAnimaIndex>=FImageList.Count then FNextAnimaIndex:=0;
            if (FImageList.Count>1) and (FFramesByteFirst<255) then
              begin
                FImageList.Draw(SuppBit.Canvas,0,0,FCurrAnimaIndex);
                B1:=TBitmap.Create;
                B1.PixelFormat:=pf24Bit;
                B1.Width:=SuppBit.Width;
                B1.Height:=SuppBit.Height;
                B1.Canvas.Brush.Style := bsSolid;
                B1.Canvas.Brush.Color:=Color;
                B1.Canvas.FillRect(Rect(0,0,SuppBit.Width,SuppBit.Height));
                FImageList.Draw(B1.Canvas,0,0,FNextAnimaIndex);
                NVIAC_GetAlphaEqualsBitmaps24(SuppBit,B1,FFramesByteFirst);
                B1.Free;
                AColor:=ColorToRGB(FMaskColor);
                cr1:=(GetRValue(AColor)*FFramesByteFirst) div 256;
                cr2:=(GetRValue(AColor)*(255-FFramesByteFirst)) div 256;
                cg1:=(GetGValue(AColor)*FFramesByteFirst) div 256;
                cg2:=(GetGValue(AColor)*(255-FFramesByteFirst)) div 256;
                cb1:=(GetBValue(AColor)*FFramesByteFirst) div 256;
                cb2:=(GetBValue(AColor)*(255-FFramesByteFirst)) div 256;
                AColor:=RGB(cr1+cr2,cg1+cg2,cb1+cb2);
              end else
              begin
                FImageList.Draw(SuppBit.Canvas,0,0,FCurrAnimaIndex);
                AColor:=FMaskColor;
              end;
          end;
      end;
    end;
//=============
      SizedShowing;
    end else
    begin
      if FAnimationStyle=nviacaiasMixing then
        begin
          if (FFramesTimeInterval>0) and FAnimationEnabled then
            begin
              if assigned(FImageList) and (FImageList.Count>0) then
                begin
                  FFramesByteFirst:=255-(255*Abs(TimeIs-ANumberTick)) div FFramesTimeInterval;
         //===================
SuppBit.Width:=Width;
SuppBit.Height:=Height;
SuppBit.Canvas.Brush.Style := bsSolid;
SuppBit.Canvas.Brush.Color:=ColorToRGB(Color);
SuppBit.Canvas.FillRect(Rect(0,0,SuppBit.Width,SuppBit.Height));
AColor:=FMaskColor;
  if assigned(FImageList) and (FImageList.Count>0) then
    begin
      case FAnimationStyle of
        nviacaiasSimple :
          begin
            FImageList.Draw(SuppBit.Canvas,0,0,FCurrAnimaIndex);
          end;
        nviacaiasMixing :
          begin
            FNextAnimaIndex:=FCurrAnimaIndex+1;
            if  FNextAnimaIndex>=FImageList.Count then FNextAnimaIndex:=0;
            if (FImageList.Count>1) and (FFramesByteFirst<255) then
              begin
                FImageList.Draw(SuppBit.Canvas,0,0,FCurrAnimaIndex);
                B1:=TBitmap.Create;
                B1.PixelFormat:=pf24Bit;
                B1.Width:=SuppBit.Width;
                B1.Height:=SuppBit.Height;
                B1.Canvas.Brush.Style := bsSolid;
                B1.Canvas.Brush.Color:=Color;
                B1.Canvas.FillRect(Rect(0,0,SuppBit.Width,SuppBit.Height));
                FImageList.Draw(B1.Canvas,0,0,FNextAnimaIndex);
                NVIAC_GetAlphaEqualsBitmaps24(SuppBit,B1,FFramesByteFirst);
                B1.Free;
                AColor:=ColorToRGB(FMaskColor);
                cr1:=(GetRValue(AColor)*FFramesByteFirst) div 256;
                cr2:=(GetRValue(AColor)*(255-FFramesByteFirst)) div 256;
                cg1:=(GetGValue(AColor)*FFramesByteFirst) div 256;
                cg2:=(GetGValue(AColor)*(255-FFramesByteFirst)) div 256;
                cb1:=(GetBValue(AColor)*FFramesByteFirst) div 256;
                cb2:=(GetBValue(AColor)*(255-FFramesByteFirst)) div 256;
                AColor:=RGB(cr1+cr2,cg1+cg2,cb1+cb2);
              end else
              begin
                FImageList.Draw(SuppBit.Canvas,0,0,FCurrAnimaIndex);
                AColor:=FMaskColor;
              end;
          end;
      end;
    end;
   //=====================
                  SizedShowing;
                end;
            end;
        end;
    end;
end;

procedure TNVIAC_AnimaImage.TryPaint;
begin
  if assigned(Parent) and parent.handleallocated then Repaint;
end;

procedure TNVIAC_AnimaImage.TryRegisterSemiQueque;
begin
  if assigned(ABasis) then ABasis.AddToSemiQueue(self);
end;

procedure TNVIAC_AnimaImage.TryRegisterTimer;
begin
   if assigned(ATimerBasis) then ATimerBasis.AddToTimerQueue(self);
end;

procedure TNVIAC_AnimaImage.TryUnregisterSemiQueque;
begin
  if assigned(ABasis) then ABasis.RemoveFromSemiQueue(self);
end;

procedure TNVIAC_AnimaImage.TryUnregisterTimer;
begin
  if assigned(ATimerBasis) then ATimerBasis.RemoveFromTimerQueue(self);
end;

end.
