unit NVIAC_CheckBox_Unit;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,NVIAC_BASIS,nviac_textlines_unit,
  nviac_bitmap_unit,Math;
type
  TNVIAC_CheckBox_Style = (nviaccsBase,nviaccsStyle1,nviaccsStyle2,nviaccsImageList);
  TNVIAC_CheckBox = class(TCustomControl,INVIAC_SEMITRANSPARENCE)
  private
    ABasis : TNVIAC_BASIS;
    ACurrRect : TRect;


    FSemiTransparence: Byte;
    FMouseDown: Boolean;
    FCaptionAngle: integer;
    FCaptionAlign: TNVIAC_H_Align;
    FCaptionLines: TStringList;

    FCaption3DStyle: TNVIAC_3DStyle;
    FCheckColor1: TColor;
    FCheckColor2: TColor;
    FCheckImageList : TImageList;
    FCheckStyle: TNVIAC_CheckBox_Style;
    FAlignHorFirst: Boolean;
    FCheckFieldToTextGap: Byte;
    FCheckFieldHAlign: TNVIAC_H_Align;
    FCheckFieldVAlign: TNVIAC_V_Align;
    FTransparent: Boolean;




    function GetColor: TColor;
    function GetEnabled1: boolean;
    function GetFont: TFont;
    function GetHeight: integer;
    function GetLeft: integer;
    function GetText: TCaption;
    function GetTop: integer;
    function GetVisible: boolean;
    function GetWidth: integer;
    procedure SetColor(Value: TColor);
    procedure SetEnabled1(Value: boolean);
    procedure SetFont(Value: TFont);
    procedure SetHeight(Value: integer);
    procedure SetLeft(Value: integer);
    procedure SetText(Value: TCaption);
    procedure SetTop(Value: integer);
    procedure SetVisible(Value: boolean);
    procedure SetWidth(Value: integer);

    procedure FontIsChanged(Sender: TObject);
    procedure GetBaseBitmap;
    procedure SetSemiTransparence(Value: Byte);
    procedure WMLBUTTONDBLCLK(var message : TMessage);message WM_LBUTTONDBLCLK; 
    procedure WMLBUTTONDOWN(var message : TMessage);message WM_LBUTTONDOWN;
    procedure WMLBUTTONUP(var message : TMessage);message WM_LBUTTONUP;
    procedure WMKEYDOWN(var message : TMessage);message WM_KEYDOWN;
    procedure WMKEYUP(var message : TMessage);message WM_KEYUP;
    procedure WMKILLFOCUS(var message : TMessage);message WM_KILLFOCUS;
    procedure WMSETFOCUS(var message : TMessage); message WM_SETFOCUS;
    procedure DefineCurrentRegion;
    procedure SetAutoSize(Value: Boolean);
    function GetAutoSize: Boolean;
    procedure SetCaptionAlign(Value: TNVIAC_H_Align);
    procedure SetCaptionAngle(Value: integer);
    procedure SetCaptionLines(Value: TStringList);
    procedure SetCaption3DStyle(Value: TNVIAC_3DStyle);

    function GetCheckImageList: TImageList;
    procedure SetCheckColor1(Value: TColor);
    procedure SetCheckColor2(Value: TColor);
    procedure SetCheckImageList(Value: TImageList);
    procedure SetCheckStyle(Value: TNVIAC_CheckBox_Style);
    procedure SetAlignHorFirst(Value: Boolean);
    procedure SetCheckFieldHAlign(Value: TNVIAC_H_Align);
    procedure SetCheckFieldToTextGap(Value: Byte);
    procedure SetCheckFieldVAlign(Value: TNVIAC_V_Align);
    procedure SetTransparent(Value: Boolean);

  protected
    AImage : TBitmap;
    FChecked: Boolean;
    FCheckFieldPos,FCheckFieldSize : TSize;
    FTextFieldPos,FTextFieldSize : TSize;
    FTextOffset,FWaitForSize : TSize;
    procedure Paint;override;
    procedure CreateHandle;override;
    procedure AdjustSize; override;
    procedure DrawCheckBox; virtual;
    procedure DrawCheckBoxAfter;virtual;
    function GetCheckFieldRGN: HRGN;virtual;
    procedure SetChecked(Value: Boolean);virtual;
    procedure SizedHiding;
    procedure SizedShowing;
  public
    procedure ReintroduceBasis(ANewBasis : TNVIAC_BASIS);//Get new basis if it changes
    procedure TryRegisterSemiQueque;//Register in semi queue
    procedure TryUnregisterSemiQueque;//Unregister
    function GetFullBitmap: TBitmap;//This is full bitmap that we can look at form
    function GetCurrentSize : TSize;//Size of control
    function GetCurrentBitmap: TBitmap;//Bitmap to process semi
    function GetCurrentOffset: TPoint;//position of control by form client rect
    function GetCurrentRegion: HRGN;//Region of control trimming (where to paint - will painted only here on back)
    function GetSemiClass : Byte;//1 - Alpha,2 - bitmap
    function GetAlpha : Byte;//alpha
    function GetAlphaBitmap : TBitmap;//alpha bitmap sizes=Current Bitmap
    procedure ContinueBitmap;//Requiring to draw the bitmap after semi to full image
    procedure TryPaint;//Requiring to redraw the control (Repaint - usually, some complex for Controls having others controls)
    procedure SetCurrRect(ARect : TRect);//This is setting of rect where and only where you can draw Current/Continue bitmap
    function GetSemiControl: TControl;//Must Return someself t.i. -> Result:=Self;
    function IsVisible: Boolean;//MustReturn Visibility of item -> Result:=Self.Visible;

    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure SetBounds(ALeft, ATop, AWidth, AHeight: Integer);override;
    procedure Assign(Source: TPersistent);override;

  published
    property AutoSize : Boolean read GetAutoSize write SetAutoSize;
    property TabOrder;
    property TabStop;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseWheel;
    property OnMouseWheelDown;
    property OnMouseWheelUp;
    //before win
    property Caption : TCaption read GetText write SetText;
    property Color : TColor read GetColor write SetColor;
    property Font : TFont read GetFont write SetFont;
    property ParentBiDiMode;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;

    property OnClick;
    property OnDblClick;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;

    property Enabled : boolean read GetEnabled1 write SetEnabled1;

    property Align;
    property Anchors;
    property BiDiMode;
    property Constraints;
    property ShowHint;
    property Visible : boolean read GetVisible write SetVisible;
    property Left: integer read GetLeft write SetLeft;
    property Top: integer read GetTop write SetTop;
    property Width: integer read GetWidth write SetWidth;
    property Height: integer read GetHeight write SetHeight;
    //Defined properties
    property SemiTransparence : Byte read FSemiTransparence write SetSemiTransparence default 0;
    property CaptionLines : TStringList read FCaptionLines write SetCaptionLines;
    property CaptionAlign : TNVIAC_H_Align read FCaptionAlign write SetCaptionAlign default nviachLeft;
    property CaptionAngle : integer read FCaptionAngle write SetCaptionAngle default 0;
    property Checked : Boolean read FChecked write SetChecked;
    property Caption3DStyle : TNVIAC_3DStyle read FCaption3DStyle write SetCaption3DStyle default nviac3dsSimple;
    property CheckImageList : TImageList read GetCheckImageList write SetCheckImageList;
    //no checked,checked,no checked disabled,checked disabled
    property CheckColor1 : TColor read FCheckColor1 write SetCheckColor1 default clGray;
    property CheckColor2 : TColor read FCheckColor2 write SetCheckColor2 default clBlack;
    property CheckStyle : TNVIAC_CheckBox_Style read FCheckStyle write SetCheckStyle default nviaccsBase;
    property CheckFieldHAlign : TNVIAC_H_Align read FCheckFieldHAlign write SetCheckFieldHAlign default nviachLeft;
    property CheckFieldVAlign : TNVIAC_V_Align read FCheckFieldVAlign write SetCheckFieldVAlign default nviacvTop;
    property AlignHorFirst : Boolean read FAlignHorFirst write SetAlignHorFirst default True;
    property CheckFieldToTextGap : Byte read FCheckFieldToTextGap write SetCheckFieldToTextGap default 4;
    property Transparent : Boolean read FTransparent write SetTransparent default True;
  end;
implementation

{ TNVIAC_CheckBox }

procedure TNVIAC_CheckBox.AdjustSize;
begin
//
end;

procedure TNVIAC_CheckBox.Assign(Source: TPersistent);
begin
  if Source is TNVIAC_CheckBox then
    begin
      inherited Color:=(Source as TNVIAC_CheckBox).Color;
      inherited Font:=(Source as TNVIAC_CheckBox).Font;
      inherited Caption:=(Source as TNVIAC_CheckBox).Caption;

      ParentBiDiMode:=(Source as TNVIAC_CheckBox).ParentBiDiMode;
      ParentColor:=(Source as TNVIAC_CheckBox).ParentColor;
      ParentFont:=(Source as TNVIAC_CheckBox).ParentFont;
      ParentShowHint:=(Source as TNVIAC_CheckBox).ParentShowHint;
      Align:=(Source as TNVIAC_CheckBox).Align;
      Anchors:=(Source as TNVIAC_CheckBox).Anchors;
      BiDiMode:=(Source as TNVIAC_CheckBox).BiDiMode;
      Constraints:=(Source as TNVIAC_CheckBox).Constraints;
      ShowHint:=(Source as TNVIAC_CheckBox).ShowHint;
      inherited Width:=(Source as TNVIAC_CheckBox).Width;
      inherited Height:=(Source as TNVIAC_CheckBox).Height;

      FSemiTransparence:=(Source as TNVIAC_CheckBox).FSemiTransparence;
      FCaptionLines.Text:=(Source as TNVIAC_CheckBox).FCaptionLines.Text;
      FCaptionAlign:=(Source as TNVIAC_CheckBox).FCaptionAlign;
      FCaptionAngle:=(Source as TNVIAC_CheckBox).FCaptionAngle;
      FCaption3DStyle:=(Source as TNVIAC_CheckBox).FCaption3DStyle;
      FChecked:=(Source as TNVIAC_CheckBox).FChecked;
      FCheckImageList:=(Source as TNVIAC_CheckBox).FCheckImageList;
      FCheckColor1:=(Source as TNVIAC_CheckBox).FCheckColor1;
      FCheckColor2:=(Source as TNVIAC_CheckBox).FCheckColor2;
      FCheckStyle:=(Source as TNVIAC_CheckBox).FCheckStyle;
      FCheckFieldHAlign:=(Source as TNVIAC_CheckBox).FCheckFieldHAlign;
      FCheckFieldVAlign:=(Source as TNVIAC_CheckBox).FCheckFieldVAlign;
      FAlignHorFirst:=(Source as TNVIAC_CheckBox).FAlignHorFirst;
      FCheckFieldToTextGap:=(Source as TNVIAC_CheckBox).FCheckFieldToTextGap;
      FTransparent:=(Source as TNVIAC_CheckBox).FTransparent;
    end else
    begin
      inherited Assign(Source);
    end;
end;

procedure TNVIAC_CheckBox.ContinueBitmap;
var ARect : TRect;
    ARGN: HRGN;
begin
// here we continue to get the bitmap after semi...
  if assigned(AImage) and (AImage.Width>0) and (AImage.Height>0) then
    begin
      intersectrect(ARect,ACurrRect,Rect(0,0,AImage.Width,AImage.Height));
      if IsRectEmpty(ACurrRect) then ARect:=Rect(0,0,AImage.Width,AImage.Height);
      ARGN:=CreateRectRGN(ARect.Left,ARect.Top,ARect.Right,ARect.Bottom);
      AImage.Canvas.Brush.Color:=clYellow;
      SelectClipRGN(AImage.Canvas.Handle,ARGN);
      //Drawing
      if Enabled then
        begin
          AImage.Canvas.Brush.Style:=bsClear;
          NVIAC_DrawLinesAtAngle(FCaptionLines,AImage.Canvas,Font,FCaptionAngle,FTextFieldPos.cx+2,FTextFieldPos.cy+2,FCaptionAlign);
          AImage.Canvas.Brush.Style:=bsSolid;

        end;
      DrawCheckBoxAfter;  
      SelectClipRGN(AImage.Canvas.Handle,0);
      DeleteObject(ARGN);
    end;
end;

constructor TNVIAC_CheckBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  if not Is_NVIAC_BASIS_We_Got(Self,ABasis) then
    begin
      Reintroduce_NVIAC_BASIS(Self);
      Is_NVIAC_BASIS_We_Got(Self,ABasis);
    end;
  TryRegisterSemiQueque;
  FCheckImageList:=nil;
  ACurrRect:=Rect(0,0,0,0);
  ControlStyle:=ControlStyle+[csOpaque];
  TabStop:=True;
  inherited AutoSize:=TRUE;
  inherited Font.Name:='Arial';
  inherited Font.OnChange:=FontIsChanged;
  inherited Width:=80;
  inherited Height:=20;
  inherited Caption:='Check Text';
  FCaptionLines:=TStringList.Create;
  FCaptionLines.Add('Check Text');
  FCaptionLines.OnChange:=FontIsChanged;
  FCaptionAlign:=nviachLeft;
  FCaptionAngle:=0;
  FCaption3DStyle:=nviac3dsSimple;
  FChecked:=False;
  AImage:=TBitmap.Create;
  AImage.PixelFormat:=pf24Bit;
  AImage.Width:=inherited Width;
  AImage.Height:=Inherited Height;
  FSemiTransparence:=0;
  FCheckColor1:=clGray;
  FCheckColor2:=clBlack;
  FCheckStyle:=nviaccsBase;
  FCheckFieldHAlign:=nviachLeft;
  FCheckFieldVAlign:=nviacvTop;
  FAlignHorFirst:=True;
  FCheckFieldToTextGap:=4;
  FTransparent:=true;
end;

procedure TNVIAC_CheckBox.CreateHandle;
begin
  inherited CreateHandle;
  DefineCurrentRegion;
  SizedShowing;
end;

procedure TNVIAC_CheckBox.DefineCurrentRegion;
var ARGN,RGN1,RGN2 : HRGN;
    p1 : array [0..3] of Tpoint;
    ASize : TSize;
    Asin,ACos : Double;
    i : integer;
begin
  if HandleAllocated then
    begin
      //First Define the sizes
      case FCheckStyle of
        nviaccsStyle2 :
          begin
            FCheckFieldSize.cx:=15;
            FCheckFieldSize.cy:=15;
          end;
        nviaccsBase,nviaccsStyle1 :
          begin
            FCheckFieldSize.cx:=13;
            FCheckFieldSize.cy:=13;
          end;
        nviaccsImageList :
          begin
            if Assigned(FCheckImageList) and (FCheckImageList.Count>=4) then
              begin
                FCheckFieldSize.cx:=FCheckImageList.Width;
                FCheckFieldSize.cy:=FCheckImageList.Height;
              end else
              begin
                FCheckFieldSize.cx:=0;
                FCheckFieldSize.cy:=0;
              end;
          end;
      end;
      FTextFieldSize:=NVIAC_TextSizeAtAngle(FCaptionLines,Font,Canvas,FCaptionAngle);
      FTextOffset.cx:=2;
      FTextOffset.cy:=2;
      FTextFieldSize.cx:=FTextFieldSize.cx+4;
      FTextFieldSize.cy:=FTextFieldSize.cy+4;
      //Positions...
      if FAlignHorFirst then
        begin
          case FCheckFieldHAlign of
            nviachLeft :
              begin
                FCheckFieldPos.cx:=0;
                FTextFieldPos.cx:=FCheckFieldSize.cx+FCheckFieldToTextGap;
                FWaitForSize.cx:=FCheckFieldSize.cx+FCheckFieldToTextGap+FTextFieldSize.cx;
                FWaitForSize.cy:=max(FCheckFieldSize.cy,FTextFieldSize.cy);
                case FCheckFieldVAlign of
                  nviacvTop :
                    begin
                      FCheckFieldPos.cy:=0;
                      FTextFieldPos.cy:=0;
                    end;
                  nviacvBottom :
                    begin
                      FCheckFieldPos.cy:=FWaitForSize.cy-FCheckFieldSize.cy;
                      FTextFieldPos.cy:=FWaitForSize.cy-FTextFieldSize.cy;
                    end;
                  nviacvCenter :
                    begin
                      FCheckFieldPos.cy:=(FWaitForSize.cy-FCheckFieldSize.cy) div 2;
                      FTextFieldPos.cy:=(FWaitForSize.cy-FTextFieldSize.cy) div 2;
                    end;
                end;
              end;
            nviachRight :
              begin
                FTextFieldPos.cx:=0;
                FCheckFieldPos.cx:=FTextFieldSize.cx+FCheckFieldToTextGap;
                FWaitForSize.cx:=FCheckFieldSize.cx+FCheckFieldToTextGap+FTextFieldSize.cx;
                FWaitForSize.cy:=max(FCheckFieldSize.cy,FTextFieldSize.cy);
                case FCheckFieldVAlign of
                  nviacvTop :
                    begin
                      FCheckFieldPos.cy:=0;
                      FTextFieldPos.cy:=0;
                    end;
                  nviacvBottom :
                    begin
                      FCheckFieldPos.cy:=FWaitForSize.cy-FCheckFieldSize.cy;
                      FTextFieldPos.cy:=FWaitForSize.cy-FTextFieldSize.cy;
                    end;
                  nviacvCenter :
                    begin
                      FCheckFieldPos.cy:=(FWaitForSize.cy-FCheckFieldSize.cy) div 2;
                      FTextFieldPos.cy:=(FWaitForSize.cy-FTextFieldSize.cy) div 2;
                    end;
                end;
              end;
            nviachCenter :
              begin
                FWaitForSize.cx:=max(FCheckFieldSize.cx,FTextFieldSize.cx);
                FWaitForSize.cy:=FCheckFieldSize.cy+FCheckFieldToTextGap+FTextFieldSize.cy;
                FCheckFieldPos.cx:=(FWaitForSize.cx-FCheckFieldSize.cx) div 2;
                FTextFieldPos.cx:=(FWaitForSize.cx-FTextFieldSize.cx) div 2;
                case FCheckFieldVAlign of
                  nviacvTop :
                    begin
                      FCheckFieldPos.cy:=0;
                      FTextFieldPos.cy:=FWaitForSize.cy-FTextFieldSize.cy;
                    end;
                  nviacvBottom :
                    begin
                      FCheckFieldPos.cy:=FWaitForSize.cy-FCheckFieldSize.cy;
                      FTextFieldPos.cy:=0;
                    end;
                  nviacvCenter :
                    begin
                      FCheckFieldPos.cx:=0;
                      FTextFieldPos.cx:=FCheckFieldSize.cx+FCheckFieldToTextGap;
                      FWaitForSize.cx:=FCheckFieldSize.cx+FCheckFieldToTextGap+FTextFieldSize.cx;
                      FWaitForSize.cy:=max(FCheckFieldSize.cy,FTextFieldSize.cy);
                      FCheckFieldPos.cy:=(FWaitForSize.cy-FCheckFieldSize.cy) div 2;
                      FTextFieldPos.cy:=(FWaitForSize.cy-FTextFieldSize.cy) div 2;
                    end;
                end;
              end;
          end;
        end else//vertical first
        begin
          case FCheckFieldVAlign of
            nviacvTop :
              begin
                FWaitForSize.cx:=max(FCheckFieldSize.cx,FTextFieldSize.cx);
                FWaitForSize.cy:=FCheckFieldSize.cy+FCheckFieldToTextGap+FTextFieldSize.cy;
                FCheckFieldPos.cy:=0;
                FTextFieldPos.cy:=FWaitForSize.cy-FTextFieldSize.cy;
                case FCheckFieldHAlign of
                  nviachLeft :
                    begin
                      FCheckFieldPos.cx:=0;
                      FTextFieldPos.cx:=0;
                    end;
                  nviachRight :
                    begin
                      FCheckFieldPos.cx:=FWaitForSize.cx-FCheckFieldSize.cx;
                      FTextFieldPos.cx:=FWaitForSize.cx-FTextFieldSize.cx;
                    end;
                  nviachCenter :
                    begin
                      FCheckFieldPos.cx:=(FWaitForSize.cx-FCheckFieldSize.cx) div 2;
                      FTextFieldPos.cx:=(FWaitForSize.cx-FTextFieldSize.cx) div 2;
                    end;
                end;
              end;//top
            nviacvBottom :
              begin
                FWaitForSize.cx:=max(FCheckFieldSize.cx,FTextFieldSize.cx);
                FWaitForSize.cy:=FCheckFieldSize.cy+FCheckFieldToTextGap+FTextFieldSize.cy;
                FCheckFieldPos.cy:=FWaitForSize.cy-FCheckFieldSize.cy;
                FTextFieldPos.cy:=0;              
                case FCheckFieldHAlign of
                  nviachLeft :
                    begin
                      FCheckFieldPos.cx:=0;
                      FTextFieldPos.cx:=0;
                    end;
                  nviachRight :
                    begin
                      FCheckFieldPos.cx:=FWaitForSize.cx-FCheckFieldSize.cx;
                      FTextFieldPos.cx:=FWaitForSize.cx-FTextFieldSize.cx;
                    end;
                  nviachCenter :
                    begin
                      FCheckFieldPos.cx:=(FWaitForSize.cx-FCheckFieldSize.cx) div 2;
                      FTextFieldPos.cx:=(FWaitForSize.cx-FTextFieldSize.cx) div 2;
                    end;
                end;
              end;
            nviacvCenter :
              begin
                case FCheckFieldHAlign of
                  nviachLeft :
                    begin
                      FCheckFieldPos.cx:=0;
                      FTextFieldPos.cx:=FCheckFieldSize.cx+FCheckFieldToTextGap;
                      FWaitForSize.cx:=FCheckFieldSize.cx+FCheckFieldToTextGap+FTextFieldSize.cx;
                      FWaitForSize.cy:=max(FCheckFieldSize.cy,FTextFieldSize.cy);
                      FCheckFieldPos.cy:=(FWaitForSize.cy-FCheckFieldSize.cy) div 2;
                      FTextFieldPos.cy:=(FWaitForSize.cy-FTextFieldSize.cy) div 2;
                    end;
                  nviachRight :
                    begin
                      FTextFieldPos.cx:=0;
                      FCheckFieldPos.cx:=FTextFieldSize.cx+FCheckFieldToTextGap;
                      FWaitForSize.cx:=FCheckFieldSize.cx+FCheckFieldToTextGap+FTextFieldSize.cx;
                      FWaitForSize.cy:=max(FCheckFieldSize.cy,FTextFieldSize.cy);
                      FCheckFieldPos.cy:=(FWaitForSize.cy-FCheckFieldSize.cy) div 2;
                      FTextFieldPos.cy:=(FWaitForSize.cy-FTextFieldSize.cy) div 2;
                    end;
                  nviachCenter :
                    begin
                      FCheckFieldPos.cx:=0;
                      FTextFieldPos.cx:=FCheckFieldSize.cx+FCheckFieldToTextGap;
                      FWaitForSize.cx:=FCheckFieldSize.cx+FCheckFieldToTextGap+FTextFieldSize.cx;
                      FWaitForSize.cy:=max(FCheckFieldSize.cy,FTextFieldSize.cy);
                      FCheckFieldPos.cy:=(FWaitForSize.cy-FCheckFieldSize.cy) div 2;
                      FTextFieldPos.cy:=(FWaitForSize.cy-FTextFieldSize.cy) div 2;
                    end;
                end;
              end;
          end;
        end;
     //positions defined and waited size..
      if (inherited AutoSize) then
        begin
          inherited SetBounds(Left,Top,FWaitForSize.cx,FWaitForSize.cy);
        end;
      if Visible then
        begin
          if Transparent then
            begin
              ARGN:=CreateRectRGN(0,0,Width,Height);
              RGN1:=GetCheckFieldRGN;
              ASize:=NVIAC_TextSize(FCaptionLines,Font,Canvas);
              ASin:=sin(FCaptionAngle*pi/1800);
              ACos:=cos(FCaptionAngle*pi/1800);
              if ((Asin>=0) and (ACos>=0)) or
                 ((ASin<=0) and (ACos<=0)) then
                begin
                  p1[0].x:=FTextFieldPos.cx;
                  p1[0].y:=FTextFieldPos.cy+Round(ASize.cx*abs(ASin));
                  p1[1].x:=FTextFieldPos.cx+Round(ASize.cx*abs(ACos));
                  p1[1].y:=FTextFieldPos.cy;
                  p1[2].x:=FTextFieldPos.cx+FTextFieldSize.cx-4;
                  p1[2].y:=FTextFieldPos.cy+Round(ASize.cy*abs(ACos));
                  p1[3].x:=FTextFieldPos.cx+Round(ASize.cy*abs(ASin));
                  p1[3].y:=FTextFieldPos.cy+FTextFieldSize.cy-4;
                end else
                begin
                  p1[0].x:=FTextFieldPos.cx;
                  p1[0].y:=FTextFieldPos.cy+Round(ASize.cy*abs(ACos));
                  p1[1].x:=FTextFieldPos.cx+Round(ASize.cy*abs(ASin));
                  p1[1].y:=FTextFieldPos.cy;
                  p1[2].x:=FTextFieldPos.cx+FTextFieldSize.cx-4;
                  p1[2].y:=FTextFieldPos.cy+Round(ASize.cx*abs(ASin));
                  p1[3].x:=FTextFieldPos.cx+Round(ASize.cx*abs(ACos));
                  p1[3].y:=FTextFieldPos.cy+FTextFieldSize.cy-4;
                end;
              for i:=0 to 3 do
                begin
                  p1[i].x:=p1[i].x+2;
                  p1[i].y:=p1[i].y+2;
                  if p1[i].x=(FTextFieldPos.cx+2) then p1[i].x:=FTextFieldPos.cx;
                  if p1[i].x=(FTextFieldPos.cx+FTextFieldSize.cx-2) then p1[i].x:=FTextFieldPos.cx+FTextFieldSize.cx;
                  if p1[i].y=(FTextFieldPos.cy+2) then p1[i].y:=FTextFieldPos.cy;
                  if p1[i].y=(FTextFieldPos.cy+FTextFieldSize.cy-2) then p1[i].y:=FTextFieldPos.cy+FTextFieldSize.cy;
                end;
              RGN2:=CreatePolygonRGN(p1,4,Alternate);
              CombineRGN(ARGN,RGN1,RGN1,RGN_COPY);
              CombineRGN(ARGN,ARGN,RGN2,RGN_OR);
              SetWindowRGN(Handle,ARGN,True);
              DeleteObject(RGN1);
              DeleteObject(RGN2);                    
            end else
            begin
              SetWindowRGN(Handle,0,True);
            end;
        end else
        begin
          ARGN:=CreateRectRGN(0,0,0,0);
          SetWindowRGN(Handle,ARGN,True);
        end;
    end;
end;

destructor TNVIAC_CheckBox.Destroy;
begin
  TryUnregisterSemiQueque;
  AImage.Free;
  FCaptionLines.Free;
  inherited Destroy;
end;

procedure TNVIAC_CheckBox.DrawCheckBox;
begin
  case FCheckStyle of
    nviaccsBase,nviaccsStyle2 :
      begin
        {    FCheckColor1: TColor;
             FCheckColor2: TColor;}
        AImage.Canvas.Brush.Color:=FCheckColor1;
        AImage.Canvas.FillRect(Rect(FCheckFieldPos.cx,FCheckFieldPos.cy,
        FCheckFieldPos.cx+FCheckFieldSize.cx,FCheckFieldPos.cy+FCheckFieldSize.cy));
        AImage.Canvas.Pen.Color:=GetCColor(FCheckColor1,clBlack,35);
        AImage.Canvas.MoveTo(FCheckFieldPos.cx,FCheckFieldPos.cy+FCheckFieldSize.cy);
        AImage.Canvas.LineTo(FCheckFieldPos.cx+FCheckFieldSize.cx,FCheckFieldPos.cy+FCheckFieldSize.cy);
        AImage.Canvas.LineTo(FCheckFieldPos.cx+FCheckFieldSize.cx,FCheckFieldPos.cy);
        AImage.Canvas.Pen.Color:=GetCColor(FCheckColor1,clWhite,35);
        AImage.Canvas.MoveTo(FCheckFieldPos.cx,FCheckFieldPos.cy+FCheckFieldSize.cy);
        AImage.Canvas.LineTo(FCheckFieldPos.cx,FCheckFieldPos.cy);
        AImage.Canvas.LineTo(FCheckFieldPos.cx+FCheckFieldSize.cx,FCheckFieldPos.cy);
        AImage.Canvas.Pen.Color:=GetCColor(FCheckColor1,clWhite,35);
        AImage.Canvas.MoveTo(FCheckFieldPos.cx+2,FCheckFieldPos.cy+FCheckFieldSize.cy-2);
        AImage.Canvas.LineTo(FCheckFieldPos.cx+FCheckFieldSize.cx-2,FCheckFieldPos.cy+FCheckFieldSize.cy-2);
        AImage.Canvas.LineTo(FCheckFieldPos.cx+FCheckFieldSize.cx-2,FCheckFieldPos.cy+2);
        AImage.Canvas.Pen.Color:=GetCColor(FCheckColor1,clBlack,35);
        AImage.Canvas.MoveTo(FCheckFieldPos.cx+2,FCheckFieldPos.cy+FCheckFieldSize.cy-2);
        AImage.Canvas.LineTo(FCheckFieldPos.cx+2,FCheckFieldPos.cy+2);
        AImage.Canvas.LineTo(FCheckFieldPos.cx+FCheckFieldSize.cx-2,FCheckFieldPos.cy+2);
      end;
    nviaccsStyle1 :
      begin
        AImage.Canvas.Brush.Color:=FCheckColor1;
        AImage.Canvas.Pen.Width:=2;
        AImage.Canvas.FillRect(Rect(FCheckFieldPos.cx,FCheckFieldPos.cy,
        FCheckFieldPos.cx+FCheckFieldSize.cx,FCheckFieldPos.cy+FCheckFieldSize.cy));
        AImage.Canvas.Pen.Color:=GetCColor(FCheckColor1,clBlack,35);
        AImage.Canvas.MoveTo(FCheckFieldPos.cx+1,FCheckFieldPos.cy+FCheckFieldSize.cy-1);
        AImage.Canvas.LineTo(FCheckFieldPos.cx+FCheckFieldSize.cx-1,FCheckFieldPos.cy+FCheckFieldSize.cy-1);
        AImage.Canvas.LineTo(FCheckFieldPos.cx+FCheckFieldSize.cx-1,FCheckFieldPos.cy+1);
        AImage.Canvas.Pen.Color:=GetCColor(FCheckColor1,clWhite,35);
        AImage.Canvas.MoveTo(FCheckFieldPos.cx+1,FCheckFieldPos.cy+FCheckFieldSize.cy-1);
        AImage.Canvas.LineTo(FCheckFieldPos.cx+1,FCheckFieldPos.cy+1);
        AImage.Canvas.LineTo(FCheckFieldPos.cx+FCheckFieldSize.cx-1,FCheckFieldPos.cy+1);
        AImage.Canvas.Pen.Width:=1;
        if Checked then
          begin
            AImage.Canvas.Pen.Color:=GetCColor(FCheckColor1,clWhite,35);
            AImage.Canvas.Pen.Width:=2;
            AImage.Canvas.MoveTo(FCheckFieldPos.cx+5,FCheckFieldPos.cy+4);
            AImage.Canvas.LineTo(FCheckFieldPos.cx+FCheckFieldSize.cx-3,FCheckFieldPos.cy+FCheckFieldSize.cy-4);
            AImage.Canvas.MoveTo(FCheckFieldPos.cx+FCheckFieldSize.cx-3,FCheckFieldPos.cy+4);
            AImage.Canvas.LineTo(FCheckFieldPos.cx+5,FCheckFieldPos.cy+FCheckFieldSize.cy-4);
            AImage.Canvas.Pen.Color:=GetCColor(FCheckColor1,clBlack,35);
            AImage.Canvas.MoveTo(FCheckFieldPos.cx+3,FCheckFieldPos.cy+3);
            AImage.Canvas.LineTo(FCheckFieldPos.cx+FCheckFieldSize.cx-5,FCheckFieldPos.cy+FCheckFieldSize.cy-5);
            AImage.Canvas.MoveTo(FCheckFieldPos.cx+FCheckFieldSize.cx-5,FCheckFieldPos.cy+3);
            AImage.Canvas.LineTo(FCheckFieldPos.cx+3,FCheckFieldPos.cy+FCheckFieldSize.cy-5);
            AImage.Canvas.Pen.Width:=1;
          end;
      end;  
    nviaccsImageList :
      begin
        if assigned(FCheckImageList) and (CheckImageList.Count>=4) then
          begin
            if not Enabled then
              begin
                    CheckImageList.draw(AImage.Canvas,FCheckFieldPos.cx,FCheckFieldPos.cy,2);
              end else
              begin
                    CheckImageList.draw(AImage.Canvas,FCheckFieldPos.cx,FCheckFieldPos.cy,0);
              end;
          end;
      end;
  end;

end;
procedure TNVIAC_CheckBox.DrawCheckBoxAfter;
begin
  case FCheckStyle of
    nviaccsBase,nviaccsStyle2 :
      begin
        if Checked then
          begin
            AImage.Canvas.Pen.Color:=FCheckColor2;
            AImage.Canvas.Pen.Width:=2;
            AImage.Canvas.MoveTo(FCheckFieldPos.cx+3,FCheckFieldPos.cy+3);
            AImage.Canvas.LineTo(FCheckFieldPos.cx+FCheckFieldSize.cx-3,FCheckFieldPos.cy+FCheckFieldSize.cy-3);
            AImage.Canvas.MoveTo(FCheckFieldPos.cx+FCheckFieldSize.cx-3,FCheckFieldPos.cy+3);
            AImage.Canvas.LineTo(FCheckFieldPos.cx+3,FCheckFieldPos.cy+FCheckFieldSize.cy-3);
            AImage.Canvas.Pen.Width:=1;
          end;
      end;
    nviaccsStyle1 :
      begin
        if Checked and Enabled then
          begin
            AImage.Canvas.Pen.Color:=FCheckColor2;
            AImage.Canvas.Pen.Width:=2;
            AImage.Canvas.MoveTo(FCheckFieldPos.cx+4,FCheckFieldPos.cy+4);
            AImage.Canvas.LineTo(FCheckFieldPos.cx+FCheckFieldSize.cx-4,FCheckFieldPos.cy+FCheckFieldSize.cy-4);
            AImage.Canvas.MoveTo(FCheckFieldPos.cx+FCheckFieldSize.cx-4,FCheckFieldPos.cy+4);
            AImage.Canvas.LineTo(FCheckFieldPos.cx+4,FCheckFieldPos.cy+FCheckFieldSize.cy-4);
            AImage.Canvas.Pen.Width:=1;
          end;
      end;  
    nviaccsImageList :
      begin
        if assigned(FCheckImageList) and (CheckImageList.Count>=4) then
          begin
            if Checked then
              begin
                if not Enabled then
                  begin
                        CheckImageList.draw(AImage.Canvas,FCheckFieldPos.cx,FCheckFieldPos.cy,3);
                  end else
                  begin
                        CheckImageList.draw(AImage.Canvas,FCheckFieldPos.cx,FCheckFieldPos.cy,1);
                  end;
              end;
          end;
      end;
  end;
end;

procedure TNVIAC_CheckBox.FontIsChanged(Sender: TObject);
begin
  if inherited Caption<>FCaptionLines.Text then inherited Caption:=FCaptionLines.Text;
  if AutoSize then
    begin
      SizedHiding;
      DefineCurrentRegion;
      SizedShowing;
    end else
    begin
      SizedShowing;
    end;
end;

function TNVIAC_CheckBox.GetAlpha: Byte;
begin
  Result:=FSemiTransparence;
end;

function TNVIAC_CheckBox.GetAlphaBitmap: TBitmap;
begin
  Result:=nil;
end;

function TNVIAC_CheckBox.GetAutoSize: Boolean;
begin
  result:=inherited AutoSize;
end;

procedure TNVIAC_CheckBox.GetBaseBitmap;
begin
  if assigned(AImage) and (inherited Width>0) and (inherited Height>0) and HandleAllocated then
    begin
      AImage.Width:=inherited Width;
      AImage.Height:=inherited Height;
      if Assigned(ABasis) then ABasis.SemiIsUpdated(self);
    end;
end;

function TNVIAC_CheckBox.GetCheckFieldRGN: HRGN;
var p1 : array [0..15] of TPoint;
begin
  case FCheckStyle of
    nviaccsStyle2 :
      begin
        //FCheckFieldPos,FCheckFieldSize
        p1[ 0].x:=FCheckFieldPos.cx;
        p1[ 1].x:=FCheckFieldPos.cx+3;
        p1[ 2].x:=FCheckFieldPos.cx+FCheckFieldSize.cx div 2;
        p1[ 3].x:=FCheckFieldPos.cx+FCheckFieldSize.cx-1-3;
        p1[ 4].x:=FCheckFieldPos.cx+FCheckFieldSize.cx-1;
        p1[ 5].x:=FCheckFieldPos.cx+FCheckFieldSize.cx-1;
        p1[ 6].x:=FCheckFieldPos.cx+FCheckFieldSize.cx div 2+3;
        p1[ 7].x:=FCheckFieldPos.cx+FCheckFieldSize.cx-1;
        p1[ 8].x:=FCheckFieldPos.cx+FCheckFieldSize.cx-1;
        p1[ 9].x:=FCheckFieldPos.cx+FCheckFieldSize.cx-1-3;
        p1[10].x:=FCheckFieldPos.cx+FCheckFieldSize.cx div 2;
        p1[11].x:=FCheckFieldPos.cx+3;
        p1[12].x:=FCheckFieldPos.cx;
        p1[13].x:=FCheckFieldPos.cx;
        p1[14].x:=FCheckFieldPos.cx+FCheckFieldSize.cx div 2-3;
        p1[15].x:=FCheckFieldPos.cx;



        p1[ 0].y:=FCheckFieldPos.cy;
        p1[ 1].y:=FCheckFieldPos.cy;
        p1[ 2].y:=FCheckFieldPos.cy+FCheckFieldSize.cy div 2-3;
        p1[ 3].y:=FCheckFieldPos.cy;
        p1[ 4].y:=FCheckFieldPos.cy;
        p1[ 5].y:=FCheckFieldPos.cy+3;
        p1[ 6].y:=FCheckFieldPos.cy+FCheckFieldSize.cy div 2;
        p1[ 7].y:=FCheckFieldPos.cy+FCheckFieldSize.cy-1-3;
        p1[ 8].y:=FCheckFieldPos.cy+FCheckFieldSize.cy-1;
        p1[ 9].y:=FCheckFieldPos.cy+FCheckFieldSize.cy-1;
        p1[10].y:=FCheckFieldPos.cy+FCheckFieldSize.cy div 2+3;
        p1[11].y:=FCheckFieldPos.cy+FCheckFieldSize.cy-1;
        p1[12].y:=FCheckFieldPos.cy+FCheckFieldSize.cy-1;
        p1[13].y:=FCheckFieldPos.cy+FCheckFieldSize.cy-1-3;
        p1[14].y:=FCheckFieldPos.cy+FCheckFieldSize.cy div 2;
        p1[15].y:=FCheckFieldPos.cy+3;
        Result:=CreatePolygonRGN(p1,16,Alternate);
      end;
    else
      begin
        Result:=CreateRectRGN(FCheckFieldPos.cx,FCheckFieldPos.cy,
                              FCheckFieldPos.cx+FCheckFieldSize.cx,
                              FCheckFieldPos.cy+FCheckFieldSize.cy);
      end;                  
  end;                      
end;

function TNVIAC_CheckBox.GetCheckImageList: TImageList;
begin
  Result:=FCheckImageList;
end;

function TNVIAC_CheckBox.GetColor: TColor;
begin
  Result:=inherited Color;
end;

function TNVIAC_CheckBox.GetCurrentBitmap: TBitmap;
var ARect : TRect;
    ARGN,RGN: HRGN;

begin
  intersectrect(ARect,ACurrRect,Rect(0,0,Width,Height));
  if IsRectEmpty(ACurrRect) then ARect:=Rect(0,0,Width,Height);
  ARGN:=CreateRectRGN(ARect.Left,ARect.Top,ARect.Right,ARect.Bottom);

  AImage.Width:=Width;
  AImage.Height:=Height;
  SelectClipRGN(AImage.Canvas.Handle,ARGN);


  AImage.Canvas.Brush.Color:=Color;
  AImage.Canvas.FillRect(rect(0,0,AImage.Width,AImage.Height));

  AImage.Canvas.Brush.Style:=bsClear;
  AImage.Canvas.Font.Assign(Font);
  case FCaption3DStyle of
    nviac3dsSimple :
      begin
        if not Enabled then
          begin
            AImage.Canvas.Font.Color:=GetCColor(Color,clBlack,35);
            NVIAC_DrawLinesAtAngle(FCaptionLines,AImage.Canvas,AImage.Canvas.Font,FCaptionAngle,
            FTextFieldPos.cx+2,FTextFieldPos.cy+2,FCaptionAlign);
          end;
      end;
    nviac3dsRised :
      begin
        AImage.Canvas.Font.Color:=GetCColor(Color,clBlack,35);
        NVIAC_DrawLinesAtAngle(FCaptionLines,AImage.Canvas,AImage.Canvas.Font,FCaptionAngle,
        FTextFieldPos.cx+3,FTextFieldPos.cy+3,FCaptionAlign);
      end;
    nviac3dsPressed :
      begin
        AImage.Canvas.Font.Color:=GetCColor(Color,clWhite,35);
        NVIAC_DrawLinesAtAngle(FCaptionLines,AImage.Canvas,AImage.Canvas.Font,FCaptionAngle,
        FTextFieldPos.cx+3,FTextFieldPos.cy+3,FCaptionAlign);
      end;
  end;

  AImage.Canvas.Font.Assign(Font);
  case FCaption3DStyle of
    nviac3dsRised :
      begin
        AImage.Canvas.Font.Color:=GetCColor(Color,clWhite,35);
        NVIAC_DrawLinesAtAngle(FCaptionLines,AImage.Canvas,AImage.Canvas.Font,FCaptionAngle,
        FTextFieldPos.cx+1,FTextFieldPos.cy+1,FCaptionAlign);
      end;
    nviac3dsPressed :
      begin
        AImage.Canvas.Font.Color:=GetCColor(Color,clBlack,35);
        NVIAC_DrawLinesAtAngle(FCaptionLines,AImage.Canvas,AImage.Canvas.Font,FCaptionAngle,
        FTextFieldPos.cx+1,FTextFieldPos.cy+1,FCaptionAlign);
      end;
  end;
  AImage.Canvas.Brush.Style:=bsSolid;
  if Enabled and Focused then
    begin
      RGN:=CreateRectRGN(0,0,0,0);
      if 0=Integer(GetWindowRGN(Handle,RGN)) then//not
        begin
          DeleteObject(RGN);
          RGN:=CreateRectRGN(0,0,AImage.Width,AImage.Height);
        end;
      AImage.Canvas.Brush.Color:=GetCColor(Color,clBlack,35);
      FrameRGN(AImage.Canvas.Handle,RGN,AImage.Canvas.Brush.Handle,-2,-2);
      AImage.Canvas.Brush.Color:=GetCColor(Color,clWhite,35);
      FrameRGN(AImage.Canvas.Handle,RGN,AImage.Canvas.Brush.Handle,-1,-1);
      DeleteObject(RGN);
    end;
  //Draw the Checkbox
  DrawCheckBox;
  SelectClipRGN(AImage.Canvas.Handle,0);
  DeleteObject(ARGN);
  result:=AImage;
end;

function TNVIAC_CheckBox.GetCurrentOffset: TPoint;
var APos1 : TSize;
begin
  APos1:=GetControlPosition(Self);
  Result.x:=APos1.cx;
  Result.y:=APos1.cy;
end;

function TNVIAC_CheckBox.GetCurrentRegion: HRGN;
var ARect : TRect;
begin
  intersectrect(ARect,ACurrRect,Rect(0,0,AImage.Width,AImage.Height));
  if IsRectEmpty(ACurrRect) then ARect:=Rect(0,0,AImage.Width,AImage.Height);
  Result:=CreateRectRGN(ARect.Left,ARect.Top,ARect.Right,ARect.Bottom);
end;

function TNVIAC_CheckBox.GetCurrentSize: TSize;
begin
  Result.cx:=AImage.Width;
  Result.cy:=AImage.Height;
end;

function TNVIAC_CheckBox.GetEnabled1: boolean;
begin
   Result:=inherited Enabled;
end;

function TNVIAC_CheckBox.GetFont: TFont;
begin
  Result:=inherited Font;
end;

function TNVIAC_CheckBox.GetFullBitmap: TBitmap;
begin
  Result:=AImage;
end;

function TNVIAC_CheckBox.GetHeight: integer;
begin
  Result:=inherited Height;
end;

function TNVIAC_CheckBox.GetLeft: integer;
begin
  Result:=inherited Left;
end;

function TNVIAC_CheckBox.GetSemiClass: Byte;
begin
  Result:=1;
end;

function TNVIAC_CheckBox.GetSemiControl: TControl;
begin
  Result:=self;
end;

function TNVIAC_CheckBox.GetText: TCaption;
begin
  Result:=inherited Caption;
  
end;

function TNVIAC_CheckBox.GetTop: integer;
begin
  Result:=inherited Top;
end;

function TNVIAC_CheckBox.GetVisible: boolean;
begin
  Result:=inherited Visible;
end;

function TNVIAC_CheckBox.GetWidth: integer;
begin
  Result:=inherited Width;
end;

function TNVIAC_CheckBox.IsVisible: Boolean;
begin
  Result:=inherited Visible;
end;

procedure TNVIAC_CheckBox.Paint;
begin
  if Assigned(AImage) and HandleAllocated then
    begin
      Canvas.Draw(0,0,AImage);
    end;
end;

procedure TNVIAC_CheckBox.ReintroduceBasis(ANewBasis: TNVIAC_BASIS);
begin
  ABasis:=ANewBasis;
end;

procedure TNVIAC_CheckBox.SetAlignHorFirst(Value: Boolean);
begin
  if Value<>FAlignHorFirst then
    begin
      FAlignHorFirst := Value;
      SizedHiding;
      DefineCurrentRegion;//such case could chenge the size...
      SizedShowing;
    end;
end;

procedure TNVIAC_CheckBox.SetAutoSize(Value: Boolean);
begin
  inherited AutoSize:=Value;
  if Value then
    begin
      SizedHiding;
      DefineCurrentRegion;
      SizedShowing;
    end;
end;

procedure TNVIAC_CheckBox.SetBounds(ALeft, ATop, AWidth, AHeight: Integer);
begin
  SizedHiding;
  inherited SetBounds(ALeft, ATop, AWidth, AHeight);
  DefineCurrentRegion;
  SizedShowing;
end;

procedure TNVIAC_CheckBox.SetCaption3DStyle(Value: TNVIAC_3DStyle);
begin
  if Value<>FCaption3DStyle then
    begin
      FCaption3DStyle := Value;
      SizedShowing;
    end;
end;

procedure TNVIAC_CheckBox.SetCaptionAlign(Value: TNVIAC_H_Align);
begin
  if Value<>FCaptionAlign then
    begin
      FCaptionAlign := Value;
      SizedShowing;
    end;
end;

procedure TNVIAC_CheckBox.SetCaptionAngle(Value: integer);
begin
while Value>1800 do dec(Value,3600);
while Value<=-1800 do inc(Value,3600);
  if Value<>FCaptionAngle then
    begin
      FCaptionAngle := Value;
      SizedHiding;
      DefineCurrentRegion;
      SizedShowing;
    end;
end;

procedure TNVIAC_CheckBox.SetCaptionLines(Value: TStringList);
begin
  if assigned(Value) then
    begin
      if FCaptionLines.Text=Value.Text then exit;
      FCaptionLines.Assign(Value);
    end else
    begin
      FCaptionLines.Clear;
    end;
    SizedHiding;
    DefineCurrentRegion;
    SizedShowing;
end;

procedure TNVIAC_CheckBox.SetCheckColor1(Value: TColor);
begin
  if Value<>FCheckColor1 then
    begin
      FCheckColor1 := Value;
      SizedShowing;
    end;
end;

procedure TNVIAC_CheckBox.SetCheckColor2(Value: TColor);
begin
  if Value<>FCheckColor2 then
    begin
      FCheckColor2 := Value;
      SizedShowing;
    end;
end;

procedure TNVIAC_CheckBox.SetChecked(Value: Boolean);
begin
  if Value<>FChecked then
    begin
      FChecked := Value;
      SizedShowing;
    end;
end;

procedure TNVIAC_CheckBox.SetCheckFieldHAlign(Value: TNVIAC_H_Align);
begin
  if Value<>FCheckFieldHAlign then
    begin
      FCheckFieldHAlign := Value;
      SizedHiding;
      DefineCurrentRegion;//such case could chenge the size...
      SizedShowing;
    end;
end;

procedure TNVIAC_CheckBox.SetCheckFieldToTextGap(Value: Byte);
begin
  if Value<>FCheckFieldToTextGap then
    begin
      FCheckFieldToTextGap := Value;
      SizedHiding;
      DefineCurrentRegion;//such case could chenge the size...
      SizedShowing;
    end;
end;

procedure TNVIAC_CheckBox.SetCheckFieldVAlign(Value: TNVIAC_V_Align);
begin
  if Value<>FCheckFieldVAlign then
    begin
      FCheckFieldVAlign := Value;
      SizedHiding;
      DefineCurrentRegion;//such case could chenge the size...
      SizedShowing;
    end;
end;

procedure TNVIAC_CheckBox.SetCheckImageList(Value: TImageList);
begin
  if Assigned(Value) then FCheckImageList:=Value else FCheckImageList:=nil;
  SizedHiding;
  DefineCurrentRegion;//such case could chenge the size...
  SizedShowing;
end;

procedure TNVIAC_CheckBox.SetCheckStyle(Value: TNVIAC_CheckBox_Style);
begin
  if Value<>FCheckStyle then
    begin
      FCheckStyle := Value;
      SizedHiding;
      DefineCurrentRegion;//such case could chenge the size...
      SizedShowing;
    end;
end;

procedure TNVIAC_CheckBox.SetColor(Value: TColor);
begin
  inherited Color:=Value;
  SizedShowing;
end;

procedure TNVIAC_CheckBox.SetCurrRect(ARect: TRect);
begin
  ACurrRect.Left:=ARect.Left;
  ACurrRect.Top:=ARect.Top;
  ACurrRect.Right:=ARect.Right;
  ACurrRect.Bottom:=ARect.Bottom;
end;

procedure TNVIAC_CheckBox.SetEnabled1(Value: boolean);
begin
  inherited Enabled:=Value;
  SizedShowing;
end;

procedure TNVIAC_CheckBox.SetFont(Value: TFont);
begin
  inherited Font:=Value;
  if AutoSize then
    begin
      SizedHiding;
      DefineCurrentRegion;
      SizedShowing;
    end else
    begin
      SizedShowing;
    end;
end;

procedure TNVIAC_CheckBox.SetHeight(Value: integer);
begin
  inherited Height:=Value;
end;

procedure TNVIAC_CheckBox.SetLeft(Value: integer);
begin
  inherited Left:=Value;
end;


procedure TNVIAC_CheckBox.SetSemiTransparence(Value: Byte);
begin
  if Value<>FSemiTransparence then
    begin
      FSemiTransparence := Value;
      SizedShowing;
    end;
end;

procedure TNVIAC_CheckBox.SetText(Value: TCaption);
begin
  inherited Caption:=Value;
  if FCaptionLines.Text<>Value then FCaptionLines.Text:=Value else SizedShowing;
end;

procedure TNVIAC_CheckBox.SetTop(Value: integer);
begin
  inherited Top:=Value;
end;

procedure TNVIAC_CheckBox.SetTransparent(Value: Boolean);
begin
  if Value<>FTransparent then
    begin
      FTransparent := Value;
      SizedHiding;
      DefineCurrentRegion;
      SizedShowing;
    end;
end;

procedure TNVIAC_CheckBox.SetVisible(Value: boolean);
begin
  if Value<>(inherited Visible) then
    begin
      inherited Visible:=Value;
      DefineCurrentRegion;
      if Value then
        begin
          SizedShowing;
        end else
        begin
          SizedHiding;
        end;
    end;
end;

procedure TNVIAC_CheckBox.SetWidth(Value: integer);
begin
  inherited Width:=Value;
end;

procedure TNVIAC_CheckBox.SizedHiding;
begin
  if assigned(ABasis) and Assigned(AImage) and assigned(Parent) and parent.handleallocated and HandleAllocated then
    begin
      AImage.Width:=Width;
      AImage.Height:=Height;
      ABasis.SemiIsHiding(self);
    end;
end;

procedure TNVIAC_CheckBox.SizedShowing;
begin
  if HandleAllocated then
    begin
      GetBaseBitmap;
    end;
end;

procedure TNVIAC_CheckBox.TryPaint;
begin
  if HandleAllocated then Repaint;
end;

procedure TNVIAC_CheckBox.TryRegisterSemiQueque;
begin
  if assigned(ABasis) then ABasis.AddToSemiQueue(self);
end;

procedure TNVIAC_CheckBox.TryUnregisterSemiQueque;
begin
  if assigned(ABasis) then ABasis.RemoveFromSemiQueue(self);
end;

procedure TNVIAC_CheckBox.WMKEYDOWN(var message: TMessage);
begin
  inherited;
  case message.WParam of
    VK_SPACE,VK_RETURN :
      begin
        FMouseDown:=True;
        SetFocus;
        Checked:=not Checked;
      end;
  end;
end;

procedure TNVIAC_CheckBox.WMKEYUP(var message: TMessage);
begin
  inherited;
  case message.WParam of
    VK_SPACE,VK_RETURN :
      begin
        FMouseDown:=False;
        if assigned(OnClick) then OnClick(Self);
      end;
  end;
end;

procedure TNVIAC_CheckBox.WMKILLFOCUS(var message: TMessage);
begin
  inherited;
  SizedShowing;
end;

procedure TNVIAC_CheckBox.WMLBUTTONDBLCLK(var message: TMessage);
begin
  perform(WM_LBUTTONDOWN,0,0);
end;

procedure TNVIAC_CheckBox.WMLBUTTONDOWN(var message: TMessage);
begin
  inherited;
  FMouseDown:=True;
  SetFocus;
  Checked:=not Checked;
end;

procedure TNVIAC_CheckBox.WMLBUTTONUP(var message: TMessage);
begin
  inherited;
  FMouseDown:=False;
  SizedShowing;
end;

procedure TNVIAC_CheckBox.WMSETFOCUS(var message: TMessage);
begin
  inherited;
  if not FMouseDown then SizedShowing;
end;

end.
