unit NVIAC_Panel_Unit;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,NVIAC_BASIS,nviac_textlines_unit,
  nviac_bitmap_unit;
  
type
TNVIAC_Panel_SemiStyle =(nviacpssSimple,nviacpssHorGradient,nviacpssVertGradient,
                         nviacpssHorStripe,nviacpssVertStripe,nviacpssCenter,nviacpssBitmap);
TNVIAC_Panel_FormStyle =(nviacpfsRect,nviacpfsHorShifted,nviacpfsInvHorShifted,
                         nviacpfsVertShifted,nviacpfsInvVertShifted,nviacpfsElliptic);
TNVIAC_Panel = class(TCustomControl,INVIAC_SEMITRANSPARENCE)
private
  ABasis : TNVIAC_BASIS;
  ACurrRect : TRect;
  AImage : TBitmap;
  AAlphaImage : TBitmap;
  ASemiHelpBitmap : TBitmap;
  FSemiTransparence: Byte;
  FSemiTransparence2: Byte;
  FSemiBitmap: TBitmap;
  FSemiStyle: TNVIAC_Panel_SemiStyle;
  FFormStyle: TNVIAC_Panel_FormStyle;
  FFormShiftPercent: Byte;
  FSkinBitmap: TBitmap;
  FSkinApply: TNVIAC_Bitmap_Apply;
  FBorderGapWidth: Byte;
  FBorderOutWidth: Byte;
  FBorderInnerWidth: Byte;
    FBorderIsUp: Boolean;
  procedure WMSize(var Message: TWMSize); message WM_SIZE;
  procedure WMMove(var Message: TWMMove); message WM_MOVE;
  procedure WMSizing(var Message: TWMSize); message WM_SIZING;
  procedure WMMoving(var Message: TWMMove); message WM_MOVING;
  function GetColor: TColor;
  function GetEnabled1: boolean;
  function GetFont: TFont;
  function GetHeight: integer;
  function GetLeft: integer;
  function GetText: TCaption;
  function GetTop: integer;
  function GetVisible: boolean;
  function GetWidth: integer;
  procedure SetColor(Value: TColor);
  procedure SetEnabled1(Value: boolean);
  procedure SetFont(Value: TFont);
  procedure SetHeight(Value: integer);
  procedure SetLeft(Value: integer);
  procedure SetText(Value: TCaption);
  procedure SetTop(Value: integer);
  procedure SetVisible(Value: boolean);
  procedure SetWidth(Value: integer);
  procedure SetSemiTransparence(Value: Byte);
  procedure GetBaseBitmap;
  procedure SizedHiding;
  procedure SizedShowing;
  procedure FontIsChanged(Sender: TObject);
  procedure SetSemiBitmap(Value: TBitmap);
  procedure SetSemiStyle(Value: TNVIAC_Panel_SemiStyle);
  procedure SetSemiTransparence2(Value: Byte);
  procedure ControlGradientSemi;
  procedure SetFormStyle(Value: TNVIAC_Panel_FormStyle);
  procedure ControlFormStyle;
  procedure SetFormShiftPercent(Value: Byte);
  procedure SetSkinBitmap(Value: TBitmap);
  procedure SetSkinApply(Value: TNVIAC_Bitmap_Apply);
  procedure SetBorderGapWidth(Value: Byte);
  procedure SetBorderInnerWidth(Value: Byte);
  procedure SetBorderOutWidth(Value: Byte);
  function AllGapWidth : Integer;
    procedure SetBorderIsUp(Value: Boolean);
protected
  procedure Paint;override;
  procedure CreateHandle;override;
public
  procedure ReintroduceBasis(ANewBasis : TNVIAC_BASIS);//Get new basis if it changes
  procedure TryRegisterSemiQueque;//Register in semi queue
  procedure TryUnregisterSemiQueque;//Unregister
  function GetFullBitmap: TBitmap;//This is full bitmap that we can look at form
  function GetCurrentSize : TSize;//Size of control
  function GetCurrentBitmap: TBitmap;//Bitmap to process semi
  function GetCurrentOffset: TPoint;//position of control by form client rect
  function GetCurrentRegion: HRGN;//Region of control trimming (where to paint - will painted only here on back)
  function GetSemiClass : Byte;//1 - Alpha,2 - bitmap
  function GetAlpha : Byte;//alpha
  function GetAlphaBitmap : TBitmap;//alpha bitmap sizes=Current Bitmap
  procedure ContinueBitmap;//Requiring to draw the bitmap after semi to full image
  procedure TryPaint;//Requiring to redraw the control (Repaint - usually, some complex for Controls having others controls)
  procedure SetCurrRect(ARect : TRect);//This is setting of rect where and only where you can draw Current/Continue bitmap
  function GetSemiControl: TControl;//Must Return someself t.i. -> Result:=Self;
  function IsVisible: Boolean;//MustReturn Visibility of item -> Result:=Self.Visible;
  constructor Create(AOwner: TComponent); override;
  destructor Destroy; override;
  procedure SetBounds(ALeft, ATop, AWidth, AHeight: Integer);override;
  procedure Assign(Source: TPersistent);override;
published
  property OnEnter;
  property OnExit;
  property OnKeyDown;
  property OnKeyPress;
  property OnKeyUp;
  property OnMouseWheel;
  property OnMouseWheelDown;
  property OnMouseWheelUp;
  //before win
  property Caption : TCaption read GetText write SetText;
  property Color : TColor read GetColor write SetColor;
  property Font : TFont read GetFont write SetFont;
  property ParentBiDiMode;
  property ParentColor;
  property ParentFont;
  property ParentShowHint;

  property OnClick;
  property OnDblClick;
  property OnMouseDown;
  property OnMouseMove;
  property OnMouseUp;
  property OnResize;

  property Enabled : boolean read GetEnabled1 write SetEnabled1;

  property Align;
  property Anchors;
  property BiDiMode;
  property Constraints;
  property ShowHint;
  property Visible : boolean read GetVisible write SetVisible;
  property Left: integer read GetLeft write SetLeft;
  property Top: integer read GetTop write SetTop;
  property Width: integer read GetWidth write SetWidth;
  property Height: integer read GetHeight write SetHeight;
  //Defined Properties...
  property SemiTransparence : Byte read FSemiTransparence write SetSemiTransparence default 0;
  property SemiTransparence2 : Byte read FSemiTransparence2 write SetSemiTransparence2 default 200;
  property SemiStyle : TNVIAC_Panel_SemiStyle read FSemiStyle write SetSemiStyle default nviacpssSimple;
  property SemiBitmap : TBitmap read FSemiBitmap write SetSemiBitmap;
  property FormStyle : TNVIAC_Panel_FormStyle read FFormStyle write SetFormStyle default nviacpfsRect;
  property FormShiftPercent : Byte read FFormShiftPercent write SetFormShiftPercent default 15;
  property SkinBitmap : TBitmap read FSkinBitmap write SetSkinBitmap;
  property SkinApply : TNVIAC_Bitmap_Apply read FSkinApply write SetSkinApply default nviacbaTile;
  property BorderOutWidth : Byte read FBorderOutWidth write SetBorderOutWidth default 2;
  property BorderInnerWidth : Byte read FBorderInnerWidth write SetBorderInnerWidth default 1;
  property BorderGapWidth : Byte read FBorderGapWidth write SetBorderGapWidth default 2;
  property BorderIsUp : Boolean read FBorderIsUp write SetBorderIsUp default True;
end;  
implementation

{ TNVIAC_Panel }

procedure TNVIAC_Panel.ContinueBitmap;
var ARect : TRect;
    ARgn: HRGN;
    s : string;
    ASize : TSize;
begin
// here we continue to get the bitmap after semi...

  if assigned(AImage) and (AImage.Width>0) and (AImage.Height>0) then
    begin
      intersectrect(ARect,ACurrRect,Rect(0,0,AImage.Width,AImage.Height));
      if IsRectEmpty(ACurrRect) then ARect:=Rect(0,0,AImage.Width,AImage.Height);
      ARGN:=CreateRectRGN(ARect.Left,ARect.Top,ARect.Right,ARect.Bottom);
      AImage.Canvas.Brush.Color:=clYellow;
      SelectClipRGN(AImage.Canvas.Handle,ARGN);
      //Drawing
      AImage.Canvas.Font.Assign(Font);
      AImage.Canvas.Brush.Style:=bsClear;
      s:=Caption;
      GetTextExtentPoint32(AImage.Canvas.handle,PChar(s),length(s),ASize);
      case FFormStyle of
        nviacpfsRect :
          begin
            AImage.Canvas.TextOut(AllGapWidth,AllGapWidth,Caption);
          end;
        nviacpfsHorShifted :
          begin
            AImage.Canvas.TextOut(AllGapWidth+(AImage.Width*FFormShiftPercent) div 200,AllGapWidth,Caption);
          end;
        nviacpfsInvHorShifted :
          begin
            AImage.Canvas.TextOut(AImage.Width-AllGapWidth-(AImage.Width*FFormShiftPercent) div 200-
                                  ASize.cx,AllGapWidth,Caption);
          end;
        nviacpfsVertShifted :
          begin
            NVIAC_RotateFont(AImage.Canvas.Font,900);
            AImage.Canvas.TextOut(AllGapWidth,
                                  AImage.Height-AllGapWidth-(AImage.Height*FFormShiftPercent) div 200,Caption);
          end;
        nviacpfsInvVertShifted :
          begin
            NVIAC_RotateFont(AImage.Canvas.Font,900);
            AImage.Canvas.TextOut(AllGapWidth,
                                  (AImage.Height*FFormShiftPercent) div 200+ASize.cx,Caption);
          end;
        nviacpfsElliptic :
          begin
            AImage.Canvas.TextOut((AImage.Width-ASize.cx) div 2,
                                  (AImage.Height-ASize.cy) div 2,
                                  Caption);
          end;
      end;
      AImage.Canvas.Brush.Style:=bsSolid;
      SelectClipRGN(AImage.Canvas.Handle,0);
      DeleteObject(ARGN);
    end;
end;

constructor TNVIAC_Panel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  if not Is_NVIAC_BASIS_We_Got(Self,ABasis) then
    begin
      Reintroduce_NVIAC_BASIS(Self);
      Is_NVIAC_BASIS_We_Got(Self,ABasis);
    end;
  TryRegisterSemiQueque;
  ACurrRect:=Rect(0,0,0,0);
  FBorderGapWidth:=2;
  FBorderOutWidth:=2;
  FBorderInnerWidth:=1;
  FBorderIsUp:=True;
  FSemiTransparence:=0;
  FSemiTransparence2:=200;
  FSemiStyle:=nviacpssSimple;
  FFormStyle:=nviacpfsRect;
  FFormShiftPercent:=15;
  FSemiBitmap:=TBitmap.Create;
  FSemiBitmap.PixelFormat:=pf24Bit;
  ASemiHelpBitmap:=nil;
  ControlStyle:=ControlStyle+[csOpaque]+[csAcceptsControls];
  inherited Font.Name:='Arial';
  inherited Font.OnChange:=FontIsChanged;
  inherited Width:=120;
  inherited Height:=40;
  inherited Caption:=Name;
  AImage:=TBitmap.Create;
  AImage.PixelFormat:=pf24Bit;
  AImage.Width:=inherited Width;
  AImage.Height:=Inherited Height;
  AAlphaImage:=TBitmap.Create;
  AAlphaImage.PixelFormat:=pf24Bit;
  FSkinBitmap:=TBitmap.Create;
  FSkinBitmap.PixelFormat:=pf24Bit;
  FSkinApply:=nviacbaTile;
end;

destructor TNVIAC_Panel.Destroy;
begin
  TryUnregisterSemiQueque;
  if assigned(ASemiHelpBitmap) then ASemiHelpBitmap.Free;
  FSkinBitmap.Free;
  FSemiBitmap.Free;
  AAlphaImage.Free;
  AImage.Free;
  inherited Destroy;
end;

function TNVIAC_Panel.GetAlpha: Byte;
begin
  Result:=FSemiTransparence;
end;

function TNVIAC_Panel.GetAlphaBitmap: TBitmap;
begin
  AAlphaImage.Width:=AImage.Width;
  AAlphaImage.Height:=AImage.Height;
  case FSemiStyle of
    nviacpssHorGradient,nviacpssVertGradient,nviacpssHorStripe,nviacpssVertStripe,nviacpssCenter :
      begin
        AAlphaImage.Canvas.StretchDraw(Rect(0,0,AAlphaImage.Width,AAlphaImage.Height),ASemiHelpBitmap);
      end;
    nviacpssBitmap :
      begin
        AAlphaImage.Canvas.StretchDraw(Rect(0,0,AAlphaImage.Width,AAlphaImage.Height),FSemiBitmap);
      end;
  end;
  Result:=AAlphaImage;
end;

function TNVIAC_Panel.GetColor: TColor;
begin
  Result:=inherited Color;
end;

function TNVIAC_Panel.GetSemiControl: TControl;
begin
  Result:=Self;
end;

function TNVIAC_Panel.GetCurrentBitmap: TBitmap;
var ARect : TRect;
    ARgn,LRGN,DRGN,RGN,RGN2,RGN3: HRGN;
    i,j,dx1,dx2,dx3,dx4,dy1,dy2,dy3,dy4 : integer;
    P1 : array [0..5] of TPoint;
    P2 : array [0..2] of TPoint;
    LBitmap,DBitmap : TBitmap;
begin
  intersectrect(ARect,ACurrRect,Rect(0,0,Width,Height));
  if IsRectEmpty(ACurrRect) then ARect:=Rect(0,0,Width,Height);
  ARGN:=CreateRectRGN(ARect.Left,ARect.Top,ARect.Right,ARect.Bottom);

  AImage.Width:=Width;
  AImage.Height:=Height;

  SelectClipRGN(AImage.Canvas.Handle,ARGN);

  AImage.Canvas.Brush.Color:=Color;
  AImage.Canvas.FillRect(rect(0,0,AImage.Width,AImage.Height));
  if (FSkinBitmap.Width>0) and (FSkinBitmap.Height>0) then
    begin
      case FSkinApply of
        nviacbaTile :
          begin
            for i:=0 to (AImage.Width div FSkinBitmap.Width) do
              for j:=0 to (AImage.Height div FSkinBitmap.Height) do
                begin
                  AImage.Canvas.Draw(FSkinBitmap.Width*i,
                                     FSkinBitmap.Height*j,
                                     FSkinBitmap);
                end;
          end;
        nviacbaCenter :
          begin
            AImage.Canvas.Draw((AImage.Width-FSkinBitmap.Width) div 2,
                               (AImage.Height-FSkinBitmap.Height) div 2,
                               FSkinBitmap);
          end;
        nviacbaStretch :
          begin
            AImage.Canvas.StretchDraw(Rect(0,0,AImage.Width,AImage.Height),FSkinBitmap);
          end;
        nviacbaCenterTile :
          begin
            for i:=0 to (AImage.Width div (2*FSkinBitmap.Width))  do
              for j:=0 to (AImage.Height div (2*FSkinBitmap.Height)) do
                begin
                  AImage.Canvas.Draw(AImage.Width div 2+i*FSkinBitmap.Width,
                                     AImage.Height div 2+j*FSkinBitmap.Height,
                                     FSkinBitmap);
                  AImage.Canvas.Draw(AImage.Width div 2-(i+1)*FSkinBitmap.Width,
                                     AImage.Height div 2+j*FSkinBitmap.Height,
                                     FSkinBitmap);
                  AImage.Canvas.Draw(AImage.Width div 2+i*FSkinBitmap.Width,
                                     AImage.Height div 2-(j+1)*FSkinBitmap.Height,
                                     FSkinBitmap);
                  AImage.Canvas.Draw(AImage.Width div 2-(i+1)*FSkinBitmap.Width,
                                     AImage.Height div 2-(j+1)*FSkinBitmap.Height,
                                     FSkinBitmap);
                end;
          end;
      end;
    end;
  LRGN:=0;DRGN:=0;
  dx1:=0;dx2:=0;dx3:=0;dx4:=0;
  dy1:=0;dy2:=0;dy3:=0;dy4:=0;
  case FFormStyle of
    nviacpfsHorShifted :
      begin
        dx1:=(Width*FFormShiftPercent) div 200;
        dx3:=-(Width*FFormShiftPercent) div 200;
      end;
    nviacpfsInvHorShifted :
      begin
        dx2:=-(Width*FFormShiftPercent) div 200;
        dx4:=(Width*FFormShiftPercent) div 200;
      end;
    nviacpfsVertShifted :
      begin
        dy2:=(Height*FFormShiftPercent) div 200;
        dy4:=-(Height*FFormShiftPercent) div 200;
      end;
    nviacpfsInvVertShifted :
      begin
        dy1:=(Height*FFormShiftPercent) div 200;
        dy3:=-(Height*FFormShiftPercent) div 200;;
      end;
  end;
  case FFormStyle of
    nviacpfsElliptic :
      begin
        RGN:=CreateEllipticRGN(FBorderOutWidth,FBorderOutWidth,AImage.Width-FBorderOutWidth,AImage.Height-FBorderOutWidth);
        LRGN:=CreateEllipticRGN(0,0,AImage.Width,AImage.Height);
        CombineRGN(LRGN,LRGN,RGN,RGN_DIFF);
        DeleteObject(RGN);
        P2[0].x:=AImage.Width;
        P2[0].y:=0;
        P2[1].x:=AImage.Width;
        P2[1].y:=AImage.Height;
        P2[2].x:=0;
        P2[2].y:=AImage.Height;
        RGN:=CreatePolygonRGN(P2,3,Alternate);
        DRGN:=CreateRectRGN(0,0,0,0);
        CombineRGN(DRGN,LRGN,RGN,RGN_AND);
        CombineRGN(LRGN,LRGN,RGN,RGN_DIFF);
        DeleteObject(RGN);

        RGN :=CreateEllipticRGN(AllGapWidth,AllGapWidth,AImage.Width-AllGapWidth,AImage.Height-AllGapWidth);
        RGN2:=CreateEllipticRGN(AllGapWidth-FBorderInnerWidth,AllGapWidth-FBorderInnerWidth,
                                AImage.Width-AllGapWidth+FBorderInnerWidth,AImage.Height-AllGapWidth+FBorderInnerWidth);
        CombineRGN(RGN2,RGN2,RGN,RGN_DIFF);
        DeleteObject(RGN);
        P2[0].x:=AImage.Width;
        P2[0].y:=0;
        P2[1].x:=AImage.Width;
        P2[1].y:=AImage.Height;
        P2[2].x:=0;
        P2[2].y:=AImage.Height;
        RGN:=CreatePolygonRGN(P2,3,Alternate);
        RGN3:=CreateRectRGN(0,0,0,0);
        CombineRGN(RGN3,RGN2,RGN,RGN_AND);
        CombineRGN(RGN2,RGN2,RGN,RGN_DIFF);
        DeleteObject(RGN);
        CombineRGN(LRGN,LRGN,RGN3,RGN_OR);
        CombineRGN(DRGN,DRGN,RGN2,RGN_OR);
        DeleteObject(RGN2);
        DeleteObject(RGN3);


      end;
    nviacpfsRect,nviacpfsHorShifted,nviacpfsInvHorShifted,
    nviacpfsVertShifted,nviacpfsInvVertShifted :
      begin
        P1[0].x:=0+dx4;
        P1[0].y:=AImage.Height+dy4;
        P1[1].x:=0+dx1;
        P1[1].y:=0+dy1;
        P1[2].x:=AImage.Width+dx2;
        P1[2].y:=0+dy2;
        P1[3].x:=AImage.Width-FBorderOutWidth+dx2;
        P1[3].y:=FBorderOutWidth+dy2;
        P1[4].x:=FBorderOutWidth+dx1;
        P1[4].y:=FBorderOutWidth+dy1;
        P1[5].x:=FBorderOutWidth+dx4;
        P1[5].y:=AImage.Height-FBorderOutWidth+dy4;


        LRGN:=CreatePolygonRGN(P1,6,Alternate);
        P1[0].x:=AllGapWidth+dx4;
        P1[0].y:=AImage.Height-AllGapWidth+dy4;
        P1[1].x:=AImage.Width-AllGapWidth+dx3;
        P1[1].y:=AImage.Height-AllGapWidth+dy3;
        P1[2].x:=AImage.Width-AllGapWidth+dx2;
        P1[2].y:=AllGapWidth+dy2;
        P1[3].x:=AImage.Width-AllGapWidth+FBorderInnerWidth+dx2;
        P1[3].y:=AllGapWidth-FBorderInnerWidth+dy2;
        P1[4].x:=AImage.Width-AllGapWidth+FBorderInnerWidth+dx3;
        P1[4].y:=AImage.Height-AllGapWidth+FBorderInnerWidth+dy3;
        P1[5].x:=AllGapWidth-FBorderInnerWidth+dx4;
        P1[5].y:=AImage.Height-AllGapWidth+FBorderInnerWidth+dy4;
        RGN:=CreatePolygonRGN(P1,6,Alternate);
        CombineRGN(LRGN,LRGN,RGN,RGN_OR);
        DeleteObject(RGN);
        P1[0].x:=0+dx4;
        P1[0].y:=AImage.Height+dy4;
        P1[1].x:=AImage.Width+dx3;
        P1[1].y:=AImage.Height+dy3;
        P1[2].x:=AImage.Width+dx2;
        P1[2].y:=0+dy2;
        P1[3].x:=AImage.Width-FBorderOutWidth+dx2;
        P1[3].y:=FBorderOutWidth+dy2;
        P1[4].x:=AImage.Width-FBorderOutWidth+dx3;
        P1[4].y:=AImage.Height-FBorderOutWidth+dy3;
        P1[5].x:=FBorderOutWidth+dx4;
        P1[5].y:=AImage.Height-FBorderOutWidth+dy4;
        DRGN:=CreatePolygonRGN(P1,6,Alternate);
        P1[0].x:=AllGapWidth+dx4;
        P1[0].y:=AImage.Height-AllGapWidth+dy4;
        P1[1].x:=AllGapWidth+dx1;
        P1[1].y:=AllGapWidth+dy1;
        P1[2].x:=AImage.Width-AllGapWidth+dx2;
        P1[2].y:=AllGapWidth+dy2;
        P1[3].x:=AImage.Width-AllGapWidth+FBorderInnerWidth+dx2;
        P1[3].y:=FBorderOutWidth+dy2;
        P1[4].x:=FBorderOutWidth+dx1;
        P1[4].y:=FBorderOutWidth+dy1;
        P1[5].x:=FBorderOutWidth+dx4;
        P1[5].y:=AImage.Height-AllGapWidth+FBorderInnerWidth+dy4;
        RGN:=CreatePolygonRGN(P1,6,Alternate);
        CombineRGN(DRGN,DRGN,RGN,RGN_OR);
        DeleteObject(RGN);
      end;

    //  begin

    //  end;
  end;

  SelectClipRGN(AImage.Canvas.Handle,0);
  CombineRGN(LRGN,LRGN,ARGN,RGN_AND);
  CombineRGN(DRGN,DRGN,ARGN,RGN_AND);
  if FBorderIsUp then LBitmap:=NVIAC_GetLBitmapASM(AImage,32) else LBitmap:=NVIAC_GetDBitmapASM(AImage,32);
  SelectClipRGN(AImage.Canvas.Handle,LRGN);
  AImage.Canvas.Draw(0,0,LBitmap);
  LBitmap.Free;
  if FBorderIsUp then DBitmap:=NVIAC_GetDBitmapASM(AImage,32) else DBitmap:=NVIAC_GetLBitmapASM(AImage,32);
  SelectClipRGN(AImage.Canvas.Handle,DRGN);
  AImage.Canvas.Draw(0,0,DBitmap);
  DBitmap.Free;
  SelectClipRGN(AImage.Canvas.Handle,0);
  DeleteObject(ARGN);
  DeleteObject(LRGN);
  DeleteObject(DRGN);
  result:=AImage;
end;

function TNVIAC_Panel.GetCurrentOffset: TPoint;
var APos1 : TSize;
begin
  APos1:=GetControlPosition(Self);
  Result.x:=APos1.cx;
  Result.y:=APos1.cy;
end;

function TNVIAC_Panel.GetCurrentRegion: HRGN;
var ARect : TRect;

begin
  intersectrect(ARect,ACurrRect,Rect(0,0,AImage.Width,AImage.Height));
  if IsRectEmpty(ACurrRect) then ARect:=Rect(0,0,AImage.Width,AImage.Height);
  Result:=CreateRectRGN(ARect.Left,ARect.Top,ARect.Right,ARect.Bottom);
end;

function TNVIAC_Panel.GetCurrentSize: TSize;
begin
  Result.cx:=AImage.Width;
  Result.cy:=AImage.Height;
end;

function TNVIAC_Panel.GetEnabled1: boolean;
begin
  Result:=Inherited Enabled;
end;

function TNVIAC_Panel.GetFont: TFont;
begin
  Result:=Inherited Font;
end;

function TNVIAC_Panel.GetFullBitmap: TBitmap;
begin
  Result:=AImage;
end;

function TNVIAC_Panel.GetHeight: integer;
begin
  Result:=inherited Height;
end;

function TNVIAC_Panel.GetLeft: integer;
begin
  Result:=inherited Left;
end;

function TNVIAC_Panel.GetSemiClass: Byte;
begin
  if FSemiStyle=nviacpssSimple then Result:=1 else Result:=2;
end;

function TNVIAC_Panel.GetText: TCaption;
begin
  Result:=inherited Caption;
end;

function TNVIAC_Panel.GetTop: integer;
begin
  Result:=inherited Top;
end;

function TNVIAC_Panel.GetVisible: boolean;
begin
  Result:=inherited Visible;
end;

function TNVIAC_Panel.GetWidth: integer;
begin
  Result:=inherited Width;
end;

function TNVIAC_Panel.IsVisible: Boolean;
begin
  Result:=Visible;
end;

procedure TNVIAC_Panel.Paint;
begin
  if Assigned(AImage) and HandleAllocated then
    begin
      Canvas.Draw(0,0,AImage);
    end;
end;

procedure TNVIAC_Panel.ReintroduceBasis(ANewBasis: TNVIAC_BASIS);
begin
  ABasis:=ANewBasis;
end;

procedure TNVIAC_Panel.SetColor(Value: TColor);
begin
  inherited Color:=Value;
  SizedShowing;
end;

procedure TNVIAC_Panel.SetCurrRect(ARect: TRect);
begin
  ACurrRect.Left:=ARect.Left;
  ACurrRect.Top:=ARect.Top;
  ACurrRect.Right:=ARect.Right;
  ACurrRect.Bottom:=ARect.Bottom;
end;

procedure TNVIAC_Panel.SetEnabled1(Value: boolean);
begin
  inherited Enabled:=Value;
  SizedShowing;
end;

procedure TNVIAC_Panel.SetFont(Value: TFont);
begin
  inherited Font:=Value;
  SizedShowing;
end;

procedure TNVIAC_Panel.SetHeight(Value: integer);
begin
  inherited Height:=Value;
end;

procedure TNVIAC_Panel.SetLeft(Value: integer);
begin
  inherited Left:=Value;
end;

procedure TNVIAC_Panel.SetSemiTransparence(Value: Byte);
begin
  if Value<>FSemiTransparence then
    begin
      FSemiTransparence := Value;
      ControlGradientSemi;
      SizedShowing;
    end;
end;

procedure TNVIAC_Panel.SetText(Value: TCaption);
begin
  inherited Caption:=Value;
  SizedShowing;
end;

procedure TNVIAC_Panel.SetTop(Value: integer);
begin
  inherited Top:=Value;
end;

procedure TNVIAC_Panel.SetVisible(Value: boolean);
begin
  if Value<>(inherited Visible) then
    begin
      inherited Visible:=Value;
      ControlFormStyle;
      if Value then
        begin
          SizedShowing;
        end else
        begin
          SizedHiding;
        end;
    end;
end;

procedure TNVIAC_Panel.SetWidth(Value: integer);
begin
  inherited Width:=Value;
end;

procedure TNVIAC_Panel.TryPaint;
begin
  if HandleAllocated then Repaint;// Invalidate;//
end;

procedure TNVIAC_Panel.TryRegisterSemiQueque;
begin
  if assigned(ABasis) then ABasis.AddToSemiQueue(self);
end;

procedure TNVIAC_Panel.TryUnregisterSemiQueque;
begin
  if assigned(ABasis) then ABasis.RemoveFromSemiQueue(self);
end;

procedure TNVIAC_Panel.WMMove(var Message: TWMMove);
begin
  inherited;
//  SizedShowing;
end;

procedure TNVIAC_Panel.WMMoving(var Message: TWMMove);
begin
  inherited;
//  SizedHiding;
end;

procedure TNVIAC_Panel.WMSize(var Message: TWMSize);
begin
  inherited;
//  ControlFormStyle;
//  SizedShowing;
end;

procedure TNVIAC_Panel.WMSizing(var Message: TWMSize);
begin
  inherited;
//  SizedHiding;
end;
procedure TNVIAC_Panel.GetBaseBitmap;
begin
  //here we will got the bitmap with semi....
 if assigned(AImage) and (inherited Width>0) and (inherited Height>0) and HandleAllocated then
    begin
      AImage.Width:=inherited Width;
      AImage.Height:=inherited Height;
      if Assigned(ABasis) then ABasis.SemiIsUpdated(self);
    end;
end;
procedure TNVIAC_Panel.SizedHiding;
begin
  if assigned(ABasis) and Assigned(AImage) and assigned(Parent) and parent.handleallocated and HandleAllocated then
  begin
    AImage.Width:=Width;
    AImage.Height:=Height;
    ABasis.SemiIsHiding(self);
  end;
end;
procedure TNVIAC_Panel.SizedShowing;
begin
  if HandleAllocated then
    begin
      GetBaseBitmap;
//    invalidate;
    end;
end;
procedure TNVIAC_Panel.Assign(Source: TPersistent);
begin
  if Source is TNVIAC_Panel then
    begin
      inherited Color:=(Source as TNVIAC_Panel).Color;
      inherited Font:=(Source as TNVIAC_Panel).Font;
      inherited Caption:=(Source as TNVIAC_Panel).Caption;

      ParentBiDiMode:=(Source as TNVIAC_Panel).ParentBiDiMode;
      ParentColor:=(Source as TNVIAC_Panel).ParentColor;
      ParentFont:=(Source as TNVIAC_Panel).ParentFont;
      ParentShowHint:=(Source as TNVIAC_Panel).ParentShowHint;
      Align:=(Source as TNVIAC_Panel).Align;
      Anchors:=(Source as TNVIAC_Panel).Anchors;
      BiDiMode:=(Source as TNVIAC_Panel).BiDiMode;
      Constraints:=(Source as TNVIAC_Panel).Constraints;
      ShowHint:=(Source as TNVIAC_Panel).ShowHint;
      inherited Width:=(Source as TNVIAC_Panel).Width;
      inherited Height:=(Source as TNVIAC_Panel).Height;

      FSemiTransparence:=(Source as TNVIAC_Panel).FSemiTransparence;
      FSemiTransparence2:=(Source as TNVIAC_Panel).FSemiTransparence2;
      FSemiStyle:=(Source as TNVIAC_Panel).FSemiStyle;
      FSemiBitmap.Width:=(Source as TNVIAC_Panel).FSemiBitmap.Width;
      FSemiBitmap.Height:=(Source as TNVIAC_Panel).FSemiBitmap.Height;
      FSemiBitmap.Canvas.Draw(0,0,(Source as TNVIAC_Panel).FSemiBitmap);
      FFormStyle:=(Source as TNVIAC_Panel).FFormStyle;
      FFormShiftPercent:=(Source as TNVIAC_Panel).FFormShiftPercent;
      FSkinBitmap.Width:=(Source as TNVIAC_Panel).FSkinBitmap.Width;
      FSkinBitmap.Height:=(Source as TNVIAC_Panel).FSkinBitmap.Height;
      FSkinBitmap.Canvas.Draw(0,0,(Source as TNVIAC_Panel).FSkinBitmap);
      FSkinApply:=(Source as TNVIAC_Panel).FSkinApply;
      FBorderGapWidth:=(Source as TNVIAC_Panel).FBorderGapWidth;
      FBorderOutWidth:=(Source as TNVIAC_Panel).FBorderOutWidth;
      FBorderInnerWidth:=(Source as TNVIAC_Panel).FBorderInnerWidth;
      FBorderIsUp:=(Source as TNVIAC_Panel).FBorderIsUp;
    end else
    begin
      inherited Assign(Source);
    end;
end;

procedure TNVIAC_Panel.SetBounds(ALeft, ATop, AWidth, AHeight: Integer);
begin
  SizedHiding;
  inherited SetBounds(ALeft, ATop, AWidth, AHeight);
  ControlFormStyle;
  Application.HandleMessage;
  SizedShowing;
end;
procedure TNVIAC_Panel.FontIsChanged(Sender: TObject);
begin
 // if inherited Caption<>FCaptionLines.Text then inherited Caption:=FCaptionLines.Text;
  SizedShowing;
end;
procedure TNVIAC_Panel.SetSemiBitmap(Value: TBitmap);
begin
  if assigned(Value) then
    begin
      FSemiBitmap.Width:=Value.Width;
      FSemiBitmap.Height:=Value.Height;
      FSemiBitmap.Canvas.Draw(0,0,Value);
    end else
    begin
      FSemiBitmap.Width:=0;
    end;
  SizedShowing;
end;

procedure TNVIAC_Panel.SetSemiStyle(Value: TNVIAC_Panel_SemiStyle);

begin
  if Value<>FSemiStyle then
    begin
      FSemiStyle := Value;
      ControlGradientSemi;
      SizedShowing;
    end;
end;

procedure TNVIAC_Panel.SetSemiTransparence2(Value: Byte);
begin
  if Value<>FSemiTransparence2 then
    begin
      FSemiTransparence2 := Value;
      ControlGradientSemi;
      if FSemiStyle<>nviacpssSimple then SizedShowing;
    end;
end;

procedure TNVIAC_Panel.ControlGradientSemi;
var i,k : integer;
begin
  case FSemiStyle of
    nviacpssHorGradient :
      begin
        if not assigned(ASemiHelpBitmap) then
          begin
            ASemiHelpBitmap:=TBitmap.Create;
            ASemiHelpBitmap.PixelFormat:=pf24Bit;
          end;
            ASemiHelpBitmap.Height:=32;
            ASemiHelpBitmap.Width:=256;
            for i:=0 to 255 do
              begin
                k:=FSemiTransparence+(i*(FSemiTransparence2-FSemiTransparence)) div 255;
                ASemiHelpBitmap.Canvas.Pen.Color:=RGB(k,k,k);
                ASemiHelpBitmap.Canvas.Moveto(i,0);
                ASemiHelpBitmap.Canvas.Lineto(i,32);
              end;
      end;
    nviacpssVertGradient :
      begin
        if not assigned(ASemiHelpBitmap) then
          begin
            ASemiHelpBitmap:=TBitmap.Create;
            ASemiHelpBitmap.PixelFormat:=pf24Bit;
          end;
            ASemiHelpBitmap.Width:=32;
            ASemiHelpBitmap.Height:=256;
            for i:=0 to 255 do
              begin
                k:=FSemiTransparence+(i*(FSemiTransparence2-FSemiTransparence)) div 255;
                ASemiHelpBitmap.Canvas.Pen.Color:=RGB(k,k,k);
                ASemiHelpBitmap.Canvas.Moveto(0,i);
                ASemiHelpBitmap.Canvas.Lineto(32,i);
              end;
      end;
    nviacpssHorStripe :
      begin
        if not assigned(ASemiHelpBitmap) then
          begin
            ASemiHelpBitmap:=TBitmap.Create;
            ASemiHelpBitmap.PixelFormat:=pf24Bit;
          end;
            ASemiHelpBitmap.Height:=32;
            ASemiHelpBitmap.Width:=512;
            for i:=0 to 255 do
              begin
                k:=FSemiTransparence+(i*(FSemiTransparence2-FSemiTransparence)) div 255;
                ASemiHelpBitmap.Canvas.Pen.Color:=RGB(k,k,k);
                ASemiHelpBitmap.Canvas.Moveto(i,0);
                ASemiHelpBitmap.Canvas.Lineto(i,32);
                ASemiHelpBitmap.Canvas.Moveto(ASemiHelpBitmap.Width-i-1,0);
                ASemiHelpBitmap.Canvas.Lineto(ASemiHelpBitmap.Width-i-1,32);
              end;
      end;
    nviacpssVertStripe :
      begin
        if not assigned(ASemiHelpBitmap) then
          begin
            ASemiHelpBitmap:=TBitmap.Create;
            ASemiHelpBitmap.PixelFormat:=pf24Bit;
          end;
            ASemiHelpBitmap.Width:=32;
            ASemiHelpBitmap.Height:=512;
            for i:=0 to 255 do
              begin
                k:=FSemiTransparence+(i*(FSemiTransparence2-FSemiTransparence)) div 255;
                ASemiHelpBitmap.Canvas.Pen.Color:=RGB(k,k,k);
                ASemiHelpBitmap.Canvas.Moveto(0,i);
                ASemiHelpBitmap.Canvas.Lineto(32,i);
                ASemiHelpBitmap.Canvas.Moveto(0,ASemiHelpBitmap.Height-1-i);
                ASemiHelpBitmap.Canvas.Lineto(32,ASemiHelpBitmap.Height-1-i);
              end;
      end;
    nviacpssCenter :
      begin
        if not assigned(ASemiHelpBitmap) then
          begin
            ASemiHelpBitmap:=TBitmap.Create;
            ASemiHelpBitmap.PixelFormat:=pf24Bit;
          end;
        ASemiHelpBitmap.Width:=256;
        ASemiHelpBitmap.Height:=256;
        ASemiHelpBitmap.Canvas.Pen.Style:=psClear;
        ASemiHelpBitmap.Canvas.Brush.Color:=RGB(FSemiTransparence2,FSemiTransparence2,FSemiTransparence2);
        ASemiHelpBitmap.Canvas.FillRect(Rect(0,0,ASemiHelpBitmap.Width,ASemiHelpBitmap.Height));
        for i:=255 downto 0 do
          begin
            k:=FSemiTransparence+(i*(FSemiTransparence2-FSemiTransparence)) div 255;
            ASemiHelpBitmap.Canvas.Brush.Color:=RGB(k,k,k);
            ASemiHelpBitmap.Canvas.Ellipse((ASemiHelpBitmap.Width-i) div 2,
                                           (ASemiHelpBitmap.Height-i) div 2,
                                            (ASemiHelpBitmap.Width+i) div 2,
                                           (ASemiHelpBitmap.Height+i) div 2);
          end;
        ASemiHelpBitmap.Canvas.Pen.Style:=psSolid;   
      end;
    else if assigned(ASemiHelpBitmap) then begin ASemiHelpBitmap.Free; ASemiHelpBitmap:=nil; end;
  end;
end;

procedure TNVIAC_Panel.SetFormStyle(Value: TNVIAC_Panel_FormStyle);
begin
  if Value<>FFormStyle then
    begin
      SizedHiding;
      FFormStyle := Value;
      ControlFormStyle;
      SizedShowing;
    end;
end;

procedure TNVIAC_Panel.ControlFormStyle;
var ARGN : HRGN;
    P1 : array [0..3] of TPoint;
begin
  if not HandleAllocated then exit;
  if Visible then
  begin
    case FFormStyle of
      nviacpfsRect :
        begin
          SetWindowRGN(Handle,0,TRUE);
        end;
      nviacpfsHorShifted :
        begin
          P1[0].x:=(Width*FFormShiftPercent) div 200;
          P1[0].y:=0;
          P1[1].x:=Width;
          P1[1].y:=0;
          P1[2].x:=Width-(Width*FFormShiftPercent) div 200;
          P1[2].y:=Height;
          P1[3].x:=0;
          P1[3].y:=Height;
          ARGN:=CreatePolygonRGN(P1,4,Alternate);
          SetWindowRGN(Handle,ARGN,TRUE);
        end;
      nviacpfsInvHorShifted :
        begin
          P1[0].x:=0;
          P1[0].y:=0;
          P1[1].x:=Width-(Width*FFormShiftPercent) div 200;
          P1[1].y:=0;
          P1[2].x:=Width;
          P1[2].y:=Height;
          P1[3].x:=(Width*FFormShiftPercent) div 200;
          P1[3].y:=Height;
          ARGN:=CreatePolygonRGN(P1,4,Alternate);
          SetWindowRGN(Handle,ARGN,TRUE);
        end;
      nviacpfsVertShifted :
        begin
          P1[0].x:=0;
          P1[0].y:=0;
          P1[1].x:=Width;
          P1[1].y:=(Height*FFormShiftPercent) div 200;
          P1[2].x:=Width;
          P1[2].y:=Height;
          P1[3].x:=0;
          P1[3].y:=Height-(Height*FFormShiftPercent) div 200;
          ARGN:=CreatePolygonRGN(P1,4,Alternate);
          SetWindowRGN(Handle,ARGN,TRUE);
        end;
      nviacpfsInvVertShifted :
        begin
          P1[0].x:=0;
          P1[0].y:=(Height*FFormShiftPercent) div 200;
          P1[1].x:=Width;
          P1[1].y:=0;
          P1[2].x:=Width;
          P1[2].y:=Height-(Height*FFormShiftPercent) div 200;
          P1[3].x:=0;
          P1[3].y:=Height;
          ARGN:=CreatePolygonRGN(P1,4,Alternate);
          SetWindowRGN(Handle,ARGN,TRUE);
        end;
      nviacpfsElliptic :
        begin
          ARGN:=CreateEllipticRGN(0,0,Width,Height);
          SetWindowRGN(Handle,ARGN,TRUE);
        end;
    end;
  end else
  begin
    ARGN:=CreateRectRGN(0,0,0,0);
    SetWindowRGN(Handle,ARGN,TRUE);
  end;
end;

procedure TNVIAC_Panel.SetFormShiftPercent(Value: Byte);
begin
  if (Value<=100) and (Value<>FFormShiftPercent) then
    begin
      case FFormStyle of
        nviacpfsRect:
          begin
            FFormShiftPercent := Value;
          end;
        else
          begin
            SizedHiding;
            FFormShiftPercent := Value;
            ControlFormStyle;
            SizedShowing;
          end;
      end;
    end;
end;

procedure TNVIAC_Panel.CreateHandle;
begin
  inherited CreateHandle;
  ControlFormStyle;
  SizedShowing;
end;

procedure TNVIAC_Panel.SetSkinBitmap(Value: TBitmap);
begin
  if assigned(Value) then
    begin
      FSkinBitmap.Width:= Value.Width;
      FSkinBitmap.Height:=Value.Height;
      FSkinBitmap.Canvas.Draw(0,0,Value);
    end else
    begin
      FSkinBitmap.Width:=0;
    end;
  SizedShowing;  
end;

procedure TNVIAC_Panel.SetSkinApply(Value: TNVIAC_Bitmap_Apply);
begin
  if Value<>FSkinApply then
    begin
      FSkinApply := Value;
      SizedShowing; 
    end;
end;

procedure TNVIAC_Panel.SetBorderGapWidth(Value: Byte);
begin
  if Value<>FBorderGapWidth then
    begin
      FBorderGapWidth := Value;
      SizedShowing; 
    end;
end;

procedure TNVIAC_Panel.SetBorderInnerWidth(Value: Byte);
begin
  if Value<>FBorderInnerWidth then
    begin
      FBorderInnerWidth := Value;
      SizedShowing; 
    end;
end;

procedure TNVIAC_Panel.SetBorderOutWidth(Value: Byte);
begin
  if Value<>FBorderOutWidth then
    begin
      FBorderOutWidth := Value;
      SizedShowing; 
    end;
end;

function TNVIAC_Panel.AllGapWidth: Integer;
begin
  Result:=FBorderGapWidth+FBorderOutWidth+FBorderInnerWidth;
end;

procedure TNVIAC_Panel.SetBorderIsUp(Value: Boolean);
begin
if Value<>FBorderIsUp then
  begin
    FBorderIsUp := Value;
    SizedShowing;
  end;
end;




end.
