unit NVIAC_RadioButton_Unit;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,NVIAC_BASIS,nviac_textlines_unit,
  nviac_bitmap_unit,Math,NVIAC_CheckBox_Unit;
type
TNVIAC_RadioButton = class(TNVIAC_CheckBox)
private
  FGroupIndex: Integer;
  procedure WMLBUTTONDOWN(var message : TMessage);message WM_LBUTTONDOWN;
  procedure WMLBUTTONUP(var message : TMessage);message WM_LBUTTONUP;
  procedure WMKEYDOWN(var message : TMessage);message WM_KEYDOWN;
  procedure WMKEYUP(var message : TMessage);message WM_KEYUP;
  procedure SetGroupIndex(Value: Integer);
protected
  procedure DrawCheckBox; override;
  procedure DrawCheckBoxAfter;override;
  function GetCheckFieldRGN: HRGN;override;
  procedure SetChecked(Value: Boolean);override;
public

  constructor Create(AOwner: TComponent); override;
  destructor Destroy; override;
  procedure Assign(Source: TPersistent);override;
published

  property GroupIndex : Integer read FGroupIndex write SetGroupIndex default 0;
end;

implementation

{ TNVIAC_RadioButton }

procedure TNVIAC_RadioButton.Assign(Source: TPersistent);
begin
  if Source is TNVIAC_RadioButton then
    begin
      FGroupIndex:=(Source as TNVIAC_RadioButton).FGroupIndex;
    end;
  inherited Assign(Source);
end;

constructor TNVIAC_RadioButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FGroupIndex:=0;
end;

destructor TNVIAC_RadioButton.Destroy;
begin
  inherited Destroy;
end;

procedure TNVIAC_RadioButton.DrawCheckBox;
begin
//FCheckFieldPos,FCheckFieldSize : TSize;
  case CheckStyle of
    nviaccsBase :
      begin
        AImage.Canvas.Brush.Color:=CheckColor1;
        AImage.Canvas.Pen.Style:=psClear;
        AImage.Canvas.Ellipse(FCheckFieldPos.cx,FCheckFieldPos.cy,
        FCheckFieldPos.cx+FCheckFieldSize.cx,FCheckFieldPos.cy+FCheckFieldSize.cy);
        AImage.Canvas.Pen.Style:=psSolid;
        AImage.Canvas.Brush.Style:=bsClear;
        AImage.Canvas.Pen.Color:=GetCColor(CheckColor1,clBlack,50);
        AImage.Canvas.Ellipse(FCheckFieldPos.cx,FCheckFieldPos.cy,
        FCheckFieldPos.cx+FCheckFieldSize.cx,FCheckFieldPos.cy+FCheckFieldSize.cy);
        AImage.Canvas.Pen.Color:=GetCColor(CheckColor1,clWhite,50);
        AImage.Canvas.Ellipse(FCheckFieldPos.cx+1,FCheckFieldPos.cy+1,
        FCheckFieldPos.cx+FCheckFieldSize.cx-1,FCheckFieldPos.cy+FCheckFieldSize.cy-1);
        AImage.Canvas.Pen.Color:=GetCColor(CheckColor1,clBlack,35);
        AImage.Canvas.Ellipse(FCheckFieldPos.cx+2,FCheckFieldPos.cy+2,
        FCheckFieldPos.cx+FCheckFieldSize.cx-2,FCheckFieldPos.cy+FCheckFieldSize.cy-2);
        AImage.Canvas.Brush.Style:=bsSolid;
      end;
    nviaccsStyle1 :
      begin
        AImage.Canvas.Brush.Color:=CheckColor1;
        AImage.Canvas.Pen.Style:=psClear;
        AImage.Canvas.Ellipse(FCheckFieldPos.cx,FCheckFieldPos.cy,
        FCheckFieldPos.cx+FCheckFieldSize.cx,FCheckFieldPos.cy+FCheckFieldSize.cy);
        AImage.Canvas.Pen.Style:=psSolid;
        AImage.Canvas.Brush.Style:=bsClear;
        AImage.Canvas.Pen.Width:=2;
        AImage.Canvas.Pen.Color:=GetCColor(CheckColor1,clBlack,35);
        AImage.Canvas.Ellipse(FCheckFieldPos.cx,FCheckFieldPos.cy,
        FCheckFieldPos.cx+FCheckFieldSize.cx,FCheckFieldPos.cy+FCheckFieldSize.cy);
        AImage.Canvas.Pen.Color:=GetCColor(CheckColor1,clBlack,50);
        AImage.Canvas.Ellipse(FCheckFieldPos.cx+2,FCheckFieldPos.cy+2,
        FCheckFieldPos.cx+FCheckFieldSize.cx-2,FCheckFieldPos.cy+FCheckFieldSize.cy-2);
        AImage.Canvas.Brush.Style:=bsSolid;
        AImage.Canvas.Pen.Width:=1;
        if Checked then
           begin
              AImage.Canvas.Brush.Color:=GetCColor(CheckColor1,clWhite,35);
              AImage.Canvas.Pen.Color:=GetCColor(CheckColor1,clWhite,35);
              AImage.Canvas.Ellipse(FCheckFieldPos.cx+3,FCheckFieldPos.cy+3,
              FCheckFieldPos.cx+FCheckFieldSize.cx-5,FCheckFieldPos.cy+FCheckFieldSize.cy-5);
           end;
      end;
    nviaccsStyle2 :
      begin
        AImage.Canvas.Brush.Color:=CheckColor1;
        AImage.Canvas.Pen.Color:=GetCColor(CheckColor1,clBlack,50);
        AImage.Canvas.Ellipse(FCheckFieldPos.cx,FCheckFieldPos.cy,
        FCheckFieldPos.cx+FCheckFieldSize.cx,FCheckFieldPos.cy+FCheckFieldSize.cy);
      end;
    nviaccsImageList :
      begin
        inherited DrawCheckBox;
      end;
  end;
end;

procedure TNVIAC_RadioButton.DrawCheckBoxAfter;
begin
  case CheckStyle of
    nviaccsBase :
      begin
        if Checked then
           begin
             if Enabled then
               begin
                  AImage.Canvas.Brush.Color:=CheckColor2;
                  AImage.Canvas.Pen.Color:=GetCColor(CheckColor1,clBlack,50);
                  AImage.Canvas.Ellipse(FCheckFieldPos.cx+4,FCheckFieldPos.cy+4,
                  FCheckFieldPos.cx+FCheckFieldSize.cx-4,FCheckFieldPos.cy+FCheckFieldSize.cy-4);
               end else
               begin
                  AImage.Canvas.Brush.Color:=GetCColor(CheckColor1,CheckColor2,35);
                  AImage.Canvas.Pen.Color:=GetCColor(CheckColor1,clBlack,35);
                  AImage.Canvas.Ellipse(FCheckFieldPos.cx+4,FCheckFieldPos.cy+4,
                  FCheckFieldPos.cx+FCheckFieldSize.cx-4,FCheckFieldPos.cy+FCheckFieldSize.cy-4);
               end;
           end;

      end;
    nviaccsStyle1 :
      begin
        if Checked then
           begin
             if Enabled then
               begin
                  AImage.Canvas.Brush.Color:=CheckColor2;
                  AImage.Canvas.Pen.Color:=GetCColor(CheckColor1,clBlack,50);
                  AImage.Canvas.Ellipse(FCheckFieldPos.cx+4,FCheckFieldPos.cy+4,
                  FCheckFieldPos.cx+FCheckFieldSize.cx-4,FCheckFieldPos.cy+FCheckFieldSize.cy-4);
               end else
               begin
                  AImage.Canvas.Brush.Color:=GetCColor(CheckColor1,CheckColor2,35);
                  AImage.Canvas.Pen.Color:=GetCColor(CheckColor1,clBlack,35);
                  AImage.Canvas.Ellipse(FCheckFieldPos.cx+4,FCheckFieldPos.cy+4,
                  FCheckFieldPos.cx+FCheckFieldSize.cx-4,FCheckFieldPos.cy+FCheckFieldSize.cy-4);
               end;
           end;
      end;
    nviaccsStyle2 :
      begin
        if Checked then
           begin
             if Enabled then
               begin
                  AImage.Canvas.Brush.Color:=CheckColor2;
                  AImage.Canvas.Pen.Color:=GetCColor(CheckColor1,clBlack,50);
                  AImage.Canvas.Ellipse(FCheckFieldPos.cx+4,FCheckFieldPos.cy+4,
                  FCheckFieldPos.cx+FCheckFieldSize.cx-4,FCheckFieldPos.cy+FCheckFieldSize.cy-4);
               end else
               begin
                  AImage.Canvas.Brush.Color:=GetCColor(CheckColor1,CheckColor2,35);
                  AImage.Canvas.Pen.Color:=GetCColor(CheckColor1,clBlack,35);
                  AImage.Canvas.Ellipse(FCheckFieldPos.cx+4,FCheckFieldPos.cy+4,
                  FCheckFieldPos.cx+FCheckFieldSize.cx-4,FCheckFieldPos.cy+FCheckFieldSize.cy-4);
               end;
           end;
      end;
    nviaccsImageList :
      begin
        inherited DrawCheckBoxAfter;
      end;
  end;
end;

function TNVIAC_RadioButton.GetCheckFieldRGN: HRGN;
var RGN1,RGN2 : HRGN;
begin
  case CheckStyle of
      nviaccsStyle2 :
        begin
          Result:=CreateEllipticRGN(FCheckFieldPos.cx,FCheckFieldPos.cy,
                              FCheckFieldPos.cx+FCheckFieldSize.cx,
                              FCheckFieldPos.cy+FCheckFieldSize.cy);
          RGN1:=CreateEllipticRGN(FCheckFieldPos.cx+2,FCheckFieldPos.cy+2,
                              FCheckFieldPos.cx+FCheckFieldSize.cx-2,
                              FCheckFieldPos.cy+FCheckFieldSize.cy-2);
          RGN2:=CreateEllipticRGN(FCheckFieldPos.cx+4,FCheckFieldPos.cy+4,
                              FCheckFieldPos.cx+FCheckFieldSize.cx-4,
                              FCheckFieldPos.cy+FCheckFieldSize.cy-4);
          CombineRGN(Result,Result,RGN1,RGN_DIFF);
          CombineRGN(Result,Result,RGN2,RGN_OR);
          DeleteObject(RGN1);
          DeleteObject(RGN2);                    
        end;
      nviaccsBase,nviaccsStyle1 :
        begin
          Result:=CreateEllipticRGN(FCheckFieldPos.cx,FCheckFieldPos.cy,
                              FCheckFieldPos.cx+FCheckFieldSize.cx,
                              FCheckFieldPos.cy+FCheckFieldSize.cy);
        end;
     nviaccsImageList :
       begin
         Result:=inherited GetCheckFieldRGN;
       end;
     else Result:=inherited GetCheckFieldRGN;
  end;
end;

procedure TNVIAC_RadioButton.SetChecked(Value: Boolean);
var i : integer;
begin
  if Value<>FChecked then
    begin
      if Focused then FChecked:=True else  FChecked := Value;
      if Checked and assigned(Parent) then
        begin
          for i:=0 to Parent.ControlCount-1 do
            begin
              if (Parent.Controls[i] is TNVIAC_RadioButton) and
                 (Parent.Controls[i]<>self) and
                 ((Parent.Controls[i] as TNVIAC_RadioButton).FGroupIndex=FGroupIndex) then
                begin
                  (Parent.Controls[i] as TNVIAC_RadioButton).Checked:=False;
                end;  
            end;
        end;
      SizedShowing;
    end;
end;

procedure TNVIAC_RadioButton.SetGroupIndex(Value: Integer);
var i : integer;
begin
  if Value<>FGroupIndex then
    begin
      FGroupIndex := Value;
      if Checked and assigned(Parent) then
        begin
          for i:=0 to Parent.ControlCount-1 do
            begin
              if (Parent.Controls[i] is TNVIAC_RadioButton) and
                 (Parent.Controls[i]<>self) and
                 ((Parent.Controls[i] as TNVIAC_RadioButton).FGroupIndex=FGroupIndex) then
                begin
                  (Parent.Controls[i] as TNVIAC_RadioButton).Checked:=False;
                end;  
            end;
        end;
    end;
end;

procedure TNVIAC_RadioButton.WMKEYDOWN(var message: TMessage);
begin
  inherited;
end;

procedure TNVIAC_RadioButton.WMKEYUP(var message: TMessage);
begin
  inherited;
end;

procedure TNVIAC_RadioButton.WMLBUTTONDOWN(var message: TMessage);
begin
  inherited;
end;

procedure TNVIAC_RadioButton.WMLBUTTONUP(var message: TMessage);
begin
  inherited;
end;

end.
 