unit nviac_bitmap_unit;
//Data is coordinates with time for blending of 100 bitmaps 800 x 640  at Celeron 333
//Regions is not eated at these functions - so you need to delete it by deleteobject function manually
{$L MMX_DEF.obj}
{$L L_CPY_X.obj}
{$L L_CPY_NX.obj}
{$L D_CPY_X.obj}
{$L D_CPY_NX.obj}
{$L SEMI_L_X.obj}
{$L SEMI_B_X.obj}
{$L TranspX.obj}
interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;



function GetCColor(C1,C2 : TColor; APercent : Byte): TColor;
function NVIAC_GetLBitmap(ABitmap : TBitmap;AValue : Byte): TBitmap;
function NVIAC_GetDBitmap(ABitmap : TBitmap;AValue : Byte): TBitmap;

function NVIAC_GetLBitmapASM(ABitmap : TBitmap;AValue : Byte): TBitmap;
function NVIAC_GetDBitmapASM(ABitmap : TBitmap;AValue : Byte): TBitmap;


//__________Procedure for alpha of equal bitmaps 5,7 second (4,1 MMX)
procedure NVIAC_GetAlphaEqualsBitmaps24(ABackBitmap,AForeBitmap : TBitmap;ATransparency : Byte);
//Changes ABackBitmap as result

//__________procedure for alpha masking of equal bitmaps 6,3 second  (4,7 MMX)
procedure NVIAC_GetABitEqualsBitmaps24(ABackBitmap,AForeBitmap,AMaskBitmap : TBitmap);
//Changes ABackBitmap as result

//__________Procedure for alpha of unequal bitmaps 8,4 second          7,3
procedure NVIAC_GetAlphaBitmap24(ABackBitmap,AForeBitmap : TBitmap;ATransparency : Byte;X,Y : integer);
//Changes ABackBitmap and AForeBitmap as result

//__________Procedure for alpha of unequal bitmaps 8,6second for elliptic region
procedure NVIAC_GetAlphaBitmap24RGN(ABackBitmap,AForeBitmap : TBitmap;ATransparency : Byte;X,Y : integer;ARGN : HRGN);
//Changes ABackBitmap and AForeBitmap as result; ABackBitmap is accurate result; AForeBitmap is
// correct at ARGN region

//__________Procedure for alpha masking of unequal bitmaps 10,7 second
// size of  AMaskBitmap =  AForeBitmap
procedure NVIAC_GetABitAlphaBitmap24(ABackBitmap,AForeBitmap,AMaskBitmap : TBitmap;X,Y : integer);
//Changes ABackBitmap and AForeBitmap as result

//__________Procedure for alpha masking of unequal bitmaps 11,0 second for elliptic region
procedure NVIAC_GetABitAlphaBitmap24RGN(ABackBitmap,AForeBitmap,AMaskBitmap : TBitmap;X,Y : integer;ARGN : HRGN);
//Changes ABackBitmap and AForeBitmap as result; ABackBitmap is accurate result; AForeBitmap is
// correct at ARGN region

//all 24 bit, equals at height-width, transparency 0- opaque, 255 - transparent
function NVIAC_BytesPerScanline(PixelsPerScanline, BitsPerPixel, Alignment: Longint): Longint;

//Function for getting transparent mask
function NVIAC_GetTransparentBitmapMask(B1 : TBitmap;TranspColor : TColor;ATranspSemi,AOtherSemi : Byte): TBitmap;


implementation
var Ab,Af,At : TBitmap;
    NVIAC_MMX_SUPPORT : BOOLEAN;

function NVIAC_BytesPerScanline(PixelsPerScanline, BitsPerPixel, Alignment: Longint): Longint;
begin
  Dec(Alignment);
  Result := ((PixelsPerScanline * BitsPerPixel) + Alignment) and not Alignment;
  Result := Result div 8;
end;
//external functions on assembler...
function  _NVIAC_MMX_SUPPORT: DWORD;cdecl;external;
procedure _NVIAC_Bit_Light_Copy_MMX(P1,P2 : Pointer;L1 : integer;DLight : Byte);cdecl;external;
procedure _NVIAC_Bit_Light_Copy_NOMMX(P1,P2 : Pointer;L1 : integer;DLight : Byte);cdecl;external;
procedure _NVIAC_Bit_Dark_Copy_MMX(P1,P2 : Pointer;L1 : integer;DLight : Byte);cdecl;external;
procedure _NVIAC_Bit_Dark_Copy_NOMMX(P1,P2 : Pointer;L1 : integer;DLight : Byte);cdecl;external;
procedure _NVIAC_Semi_Equal_Bits_Coeff_MMX(P1,P2 : Pointer;L1 : integer;ASemi : Byte);cdecl;external;
procedure _NVIAC_Semi_Equal_Bits_Bit_MMX(P1,P2,P3 : Pointer;L1 : integer);cdecl;external;
procedure _NVIAC_Transp_Semi_MMX(P1 : Pointer;Height,Length_Byte,L_Point_Number : Integer;ATrColor : TColor;ATrSemi,ANoTrSemi : Byte);cdecl;external;



procedure NVIAC_GetAlphaEqualsBitmaps24(ABackBitmap,AForeBitmap : TBitmap;ATransparency : Byte);
var
  L1 : integer;
  p1,p2 : pByteArray;
begin
  if ATransparency<255 then
    begin
      p1:=ABackBitmap.ScanLine[ABackBitmap.height-1];
      p2:=AForeBitmap.ScanLine[AForeBitmap.height-1];
      L1:=AForeBitmap.height*NVIAC_BytesPerScanline(AForeBitmap.width,24,32);

      //assembler entires
      if NVIAC_MMX_SUPPORT then
        begin
          if ATransparency=0 then
            begin
              copymemory(p1,p2,L1);
            end else  _NVIAC_Semi_Equal_Bits_Coeff_MMX(p1,p2,L1,ATransparency);
        end else
        begin
          if ATransparency=0 then
            begin
              copymemory(p1,p2,L1);
            end else
            begin
              asm
                push ebx
                mov ecx,L1
                dec ecx
                jl @@2
                mov ebx,p1
                mov dl, ATransparency
              @@1 :
                mov al, byte ptr [ebx+ecx]
                mov ebx,p2
                mul dl
                mov al, byte ptr [ebx+ecx]
                not dl
                mov ebx,p1
                mov dh,ah
                mul dl
                not dl
                add ah,dh

                mov byte ptr [ebx+ecx],ah

                dec ecx
                jge @@1
              @@2 :
                pop ebx
              end;
            end;
        end;
    end;
end;
procedure NVIAC_GetABitEqualsBitmaps24(ABackBitmap,AForeBitmap,AMaskBitmap : TBitmap);
var
  L1 : integer;
  p1,p2,p3 : pByteArray;

begin
  p1:=ABackBitmap.ScanLine[ABackBitmap.height-1];
  p2:=AForeBitmap.ScanLine[AForeBitmap.height-1];
  p3:=AMaskBitmap.ScanLine[AMaskBitmap.height-1];
  L1:=AForeBitmap.height*NVIAC_BytesPerScanline(AForeBitmap.width,24,32);
    //assembler entires
  if NVIAC_MMX_SUPPORT then _NVIAC_Semi_Equal_Bits_Bit_MMX(p1,p2,p3,L1) else
      asm
        push ebx
        mov ecx,L1
        dec ecx
        jl @@2
        mov eax,p1
        mov ebx,p3
      @@1 :

        mov dl,byte ptr [ecx+ebx]
        mov al,byte ptr [ecx+eax]
        mul dl
        mov dh,ah
        not dl
        mov eax,p2
        mov al,byte ptr [ecx+eax]
        mul dl
        add dh,ah

        mov eax,p1
        mov byte ptr [ecx+eax],dh
        dec ecx
        jge  @@1
      @@2 :
        pop ebx
      end;

end;
procedure NVIAC_GetAlphaBitmap24(ABackBitmap,AForeBitmap : TBitmap;ATransparency : Byte;X,Y : integer);
var Rect1,Rect2,ARect : TRect;
begin
  Rect1:=Rect(0,0,ABackBitmap.Width,ABackBitmap.Height);
  Rect2:=Rect(0,0,AForeBitmap.Width,AForeBitmap.Height);
  OffsetRect(Rect2,X,Y);
  InterSectRect(ARect,Rect1,Rect2);
  if not IsRectEmpty(ARect) then
    begin
      Ab.Width:=ARect.Right-ARect.Left;
      Ab.Height:=ARect.Bottom-ARect.Top;
      Af.Width:=ARect.Right-ARect.Left;
      Af.Height:=ARect.Bottom-ARect.Top;
      Ab.Canvas.Draw(-ARect.Left,-ARect.Top,ABackBitmap);
      Af.Canvas.Draw(X-ARect.Left,Y-ARect.Top,AForeBitmap);
      NVIAC_GetAlphaEqualsBitmaps24(Ab,Af,ATransparency);
      ABackBitmap.Canvas.Draw(ARect.Left,ARect.Top,Ab);
      AForeBitmap.Canvas.Draw(ARect.Left-X,ARect.Top-Y,Ab);
      Ab.Width:=0;
      Ab.Height:=0;
      Af.Width:=0;
      Af.Height:=0;
    end;
end;
procedure NVIAC_GetAlphaBitmap24RGN(ABackBitmap,AForeBitmap : TBitmap;ATransparency : Byte;X,Y : integer;ARGN : HRGN);
var Rect1,Rect2,ARect : TRect;
begin
  Rect1:=Rect(0,0,ABackBitmap.Width,ABackBitmap.Height);
  Rect2:=Rect(0,0,AForeBitmap.Width,AForeBitmap.Height);
  OffsetRect(Rect2,X,Y);
  InterSectRect(ARect,Rect1,Rect2);
  if not IsRectEmpty(ARect) then
    begin
      Ab.Width:=ARect.Right-ARect.Left;
      Ab.Height:=ARect.Bottom-ARect.Top;
      Af.Width:=ARect.Right-ARect.Left;
      Af.Height:=ARect.Bottom-ARect.Top;
      Ab.Canvas.Draw(-ARect.Left,-ARect.Top,ABackBitmap);
      Af.Canvas.Draw(X-ARect.Left,Y-ARect.Top,AForeBitmap);
      NVIAC_GetAlphaEqualsBitmaps24(Ab,Af,ATransparency);
      OffsetRGN(ARGN,X,Y);
      SelectClipRgn(ABackBitmap.canvas.handle,ARGN);
      ABackBitmap.Canvas.Draw(ARect.Left,ARect.Top,Ab);
      SelectClipRgn(ABackBitmap.canvas.handle,0);
      OffsetRGN(ARGN,-X,-Y);
      SelectClipRgn(AForeBitmap.canvas.handle,ARGN);
      AForeBitmap.Canvas.Draw(ARect.Left-X,ARect.Top-Y,Ab);
      SelectClipRgn(AForeBitmap.canvas.handle,0);
      Ab.Width:=0;
      Ab.Height:=0;
      Af.Width:=0;
      Af.Height:=0;
    end;
end;
procedure NVIAC_GetABitAlphaBitmap24(ABackBitmap,AForeBitmap,AMaskBitmap : TBitmap;X,Y : integer);
var Rect1,Rect2,ARect : TRect;
begin
  Rect1:=Rect(0,0,ABackBitmap.Width,ABackBitmap.Height);
  Rect2:=Rect(0,0,AForeBitmap.Width,AForeBitmap.Height);
  OffsetRect(Rect2,X,Y);
  InterSectRect(ARect,Rect1,Rect2);
  if not IsRectEmpty(ARect) then
    begin
      Ab.Width:=ARect.Right-ARect.Left;
      Ab.Height:=ARect.Bottom-ARect.Top;
      Af.Width:=ARect.Right-ARect.Left;
      Af.Height:=ARect.Bottom-ARect.Top;
      At.Width:=ARect.Right-ARect.Left;
      At.Height:=ARect.Bottom-ARect.Top;

      Ab.Canvas.Draw(-ARect.Left,-ARect.Top,ABackBitmap);
      Af.Canvas.Draw(X-ARect.Left,Y-ARect.Top,AForeBitmap);
      At.Canvas.Draw(X-ARect.Left,Y-ARect.Top,AMaskBitmap);
      NVIAC_GetABitEqualsBitmaps24(Ab,Af,At);
      ABackBitmap.Canvas.Draw(ARect.Left,ARect.Top,Ab);
      AForeBitmap.Canvas.Draw(ARect.Left-X,ARect.Top-Y,Ab);
      Ab.Width:=0;
      Ab.Height:=0;
      Af.Width:=0;
      Af.Height:=0;
      At.Width:=0;
      At.Height:=0;
    end;
end;
procedure NVIAC_GetABitAlphaBitmap24RGN(ABackBitmap,AForeBitmap,AMaskBitmap : TBitmap;X,Y : integer;ARGN : HRGN);
var Rect1,Rect2,ARect : TRect;
begin
  Rect1:=Rect(0,0,ABackBitmap.Width,ABackBitmap.Height);
  Rect2:=Rect(0,0,AForeBitmap.Width,AForeBitmap.Height);
  OffsetRect(Rect2,X,Y);
  InterSectRect(ARect,Rect1,Rect2);
  if not IsRectEmpty(ARect) then
    begin
      Ab.Width:=ARect.Right-ARect.Left;
      Ab.Height:=ARect.Bottom-ARect.Top;
      Af.Width:=ARect.Right-ARect.Left;
      Af.Height:=ARect.Bottom-ARect.Top;
      At.Width:=ARect.Right-ARect.Left;
      At.Height:=ARect.Bottom-ARect.Top;
      Ab.Canvas.Draw(-ARect.Left,-ARect.Top,ABackBitmap);
      Af.Canvas.Draw(X-ARect.Left,Y-ARect.Top,AForeBitmap);
      At.Canvas.Draw(X-ARect.Left,Y-ARect.Top,AMaskBitmap);
      NVIAC_GetABitEqualsBitmaps24(Ab,Af,At);
      OffsetRGN(ARGN,X,Y);
      SelectClipRgn(ABackBitmap.canvas.handle,ARGN);
      ABackBitmap.Canvas.Draw(ARect.Left,ARect.Top,Ab);
      SelectClipRgn(ABackBitmap.canvas.handle,0);
      OffsetRGN(ARGN,-X,-Y);
      SelectClipRgn(AForeBitmap.canvas.handle,ARGN);
      AForeBitmap.Canvas.Draw(ARect.Left-X,ARect.Top-Y,Ab);
      SelectClipRgn(AForeBitmap.canvas.handle,0);
      Ab.Width:=0;
      Ab.Height:=0;
      Af.Width:=0;
      Af.Height:=0;
      At.Width:=0;
      At.Height:=0;
    end;
end;
function GetCColor(C1,C2 : TColor; APercent : Byte): TColor;
begin
  Result:=RGB((GetRValue(C2)*APercent+GetRValue(C1)*(100-APercent)) div 100,
              (GetGValue(C2)*APercent+GetGValue(C1)*(100-APercent)) div 100,
              (GetBValue(C2)*APercent+GetBValue(C1)*(100-APercent)) div 100);
end;
function NVIAC_GetLBitmap(ABitmap : TBitmap;AValue : Byte): TBitmap;
var P1,P2 : pByteArray;
    L1 : integer;
begin
  Result:=TBitmap.Create;
  Result.PixelFormat:=pf24Bit;
  Result.Width:=ABitmap.Width;
  Result.Height:=ABitmap.Height;
  P1:=ABitmap.ScanLine[ABitmap.Height-1];
  P2:=Result.ScanLine[Result.Height-1];
  L1:=ABitmap.height*NVIAC_BytesPerScanline(ABitmap.width,24,32);
  copymemory(P2,P1,L1);
  asm
     mov edx,P2
     add edx,L1
     mov ecx,P2
     mov ah,AValue
     mov al,255
     sub al,ah
    @@1 :
     dec edx

     cmp byte ptr [edx],al
     jb @@2
     mov byte ptr [edx],255
     jmp @@3
    @@2 :
     add byte ptr [edx],ah
    @@3 :
     cmp edx,ecx
     ja @@1
  end;
end;
function NVIAC_GetDBitmap(ABitmap : TBitmap;AValue : Byte): TBitmap;
var P1,P2 : pByteArray;
    L1 : integer; 
begin
  Result:=TBitmap.Create;
  Result.PixelFormat:=pf24Bit;
  Result.Width:=ABitmap.Width;
  Result.Height:=ABitmap.Height;
  P1:=ABitmap.ScanLine[ABitmap.Height-1];
  P2:=Result.ScanLine[Result.Height-1];
  L1:=ABitmap.height*NVIAC_BytesPerScanline(ABitmap.width,24,32);
  copymemory(P2,P1,L1);
  asm
     mov edx,P2
     add edx,L1
     mov ecx,P2
     mov ah,AValue
    @@1 :
     dec edx
     cmp byte ptr [edx],ah
     ja @@3
     mov byte ptr [edx],0
     jmp @@2
   @@3 :
     sub byte ptr [edx],ah
   @@2 :
     cmp edx,ecx
     ja @@1
  end;
end;
function NVIAC_GetLBitmapASM(ABitmap : TBitmap;AValue : Byte): TBitmap;
var P1,P2 : pByteArray;
    L1 : integer;
begin
  Result:=TBitmap.Create;
  Result.PixelFormat:=pf24Bit;
  Result.Width:=ABitmap.Width;
  Result.Height:=ABitmap.Height;
  P1:=ABitmap.ScanLine[ABitmap.Height-1];
  P2:=Result.ScanLine[Result.Height-1];
  L1:=ABitmap.height*NVIAC_BytesPerScanline(ABitmap.width,24,32);        //2.3
  if NVIAC_MMX_SUPPORT then _NVIAC_Bit_Light_Copy_MMX(P2,P1,L1,AValue)   //4.3
                       else _NVIAC_Bit_Light_Copy_NOMMX(P2,P1,L1,AValue);//6.0
end;
function NVIAC_GetDBitmapASM(ABitmap : TBitmap;AValue : Byte): TBitmap;
var P1,P2 : pByteArray;
    L1 : integer;
begin

  Result:=TBitmap.Create;
  Result.PixelFormat:=pf24Bit;
  Result.Width:=ABitmap.Width;
  Result.Height:=ABitmap.Height;
  P1:=ABitmap.ScanLine[ABitmap.Height-1];
  P2:=Result.ScanLine[Result.Height-1];
  L1:=ABitmap.height*NVIAC_BytesPerScanline(ABitmap.width,24,32);        //2.3
  if NVIAC_MMX_SUPPORT then _NVIAC_Bit_Dark_Copy_MMX(P2,P1,L1,AValue)   //4.3
                       else _NVIAC_Bit_Dark_Copy_NOMMX(P2,P1,L1,AValue);//6.0
end;
function NVIAC_GetTransparentBitmapMask(B1 : TBitmap;TranspColor : TColor;ATranspSemi,AOtherSemi : Byte): TBitmap;
var P1 : pByteArray;
    i,L1,H,L2 : integer;
begin
  Result:=TBitmap.Create;
  Result.PixelFormat:=pf24Bit;
  if (B1.Width<=0) or (B1.Height<=0) then Exit;
  Result.Width:=B1.Width;
  Result.Height:=B1.Height;
  Result.Canvas.Draw(0,0,B1);
  if NVIAC_MMX_SUPPORT then//7,9sec4,1
    begin
      P1:=Result.ScanLine[Result.Height-1];
      H:=Result.Height;
      L1:=NVIAC_BytesPerScanline(Result.width,24,32);
      L2:=3*Result.width;
      TranspColor:=ColorToRGB(TranspColor);
      TranspColor:=RGB(GetBValue(TranspColor),GetGValue(TranspColor),GetRValue(TranspColor));
      _NVIAC_Transp_Semi_MMX(P1,H,L1,L2,TranspColor,ATranspSemi,AOtherSemi);
    end else
    begin//13,9sec 5,4
      //_NVIAC_Transp_Semi_MMX
      At.Width:=B1.Width;
      At.Height:=B1.Height;
      At.Canvas.Brush.Color:=ColorToRGB(TranspColor);
      At.Canvas.FillRect(Rect(0,0,At.Width,At.Height));
      BitBlt(Result.Canvas.Handle,0,0,At.Width,At.Height,At.Canvas.Handle,0,0,SRCINVERT);
      L1:=NVIAC_BytesPerScanline(Result.width,24,32);
      for i:=0 to Result.Height-1 do
        begin
          P1:=Result.ScanLine[i];
          asm
            push ebx
            mov ecx,P1
            mov edx,L1
            dec edx
            jl @2 //if string is zero then to end
            add edx,P1
            mov bl,ATranspSemi
            mov bh,AOtherSemi
           @1 :
            mov eax,[ecx]
            or ah,al
            shr eax,8
            or ah,al
            je @3
            mov byte ptr [ecx],bh
            inc ecx
            mov byte ptr [ecx],bh
            inc ecx
            mov byte ptr [ecx],bh
            jmp @4
           @3 ://if transp color
            mov byte ptr [ecx],bl
            inc ecx
            mov byte ptr [ecx],bl
            inc ecx
            mov byte ptr [ecx],bl
           @4 :
            inc ecx
            cmp ecx,edx
            jle @1
           @2 :
            pop ebx
          end;
        end;





      At.Width:=0;
      At.Height:=0;
    end;
end;
initialization
  begin
    if _NVIAC_MMX_SUPPORT=0 then NVIAC_MMX_SUPPORT:=false else NVIAC_MMX_SUPPORT:=TRUE;
    Ab:=TBitmap.Create;
    Ab.PixelFormat:=pf24Bit;
    Af:=TBitmap.Create;
    Af.PixelFormat:=pf24Bit;
    At:=TBitmap.Create;
    At.PixelFormat:=pf24Bit;
  end;
finalization
  begin
    if assigned(Ab) then Ab.Free;
    if assigned(Af) then Af.Free;
    if assigned(At) then At.Free;
  end;
end.
