unit nviac_textlines_unit;

interface
uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,NVIAC_BASIS;

procedure NVIAC_RotateFont(AFont: TFont;Angle : Integer);
function  NVIAC_TextSize(ALines : TStringList;AFont: TFont;ACanvas : TCanvas): TSize;
function  NVIAC_TextSizeAtAngle(ALines : TStringList;AFont: TFont;ACanvas : TCanvas;Angle : Integer): TSize;
procedure NVIAC_DrawLinesAtAngle(ALines : TStringList;ACanvas :TCanvas;AFont: TFont;Angle : Integer;ShiftX,ShiftY : Integer;AlignIs : TNVIAC_H_Align);

implementation


procedure NVIAC_RotateFont(AFont: TFont;Angle : Integer);
var
  MyLFont : LogFONT;
begin
  GETOBJECT(AFont.Handle,sizeof(MyLFont),@MyLFont);
  MyLfont.lfEscapement:=Angle;
  MyLFont.lfOrientation:=Angle;
  MyLFont.lfQuality:=PROOF_QUALITY;
  MyLFont.lfOutPrecision:=OUT_TT_ONLY_PRECIS;
  AFont.Handle:=CREATEFONTINDIRECT(MyLFont);
end;
function  NVIAC_TextSize(ALines : TStringList;AFont: TFont;ACanvas : TCanvas): TSize;
var i : integer;
    s : string;
    s1 : TSize;
begin
  Result.cx:=0;
  Result.cy:=0;
  ACanvas.Font.Assign(AFont);
  for i:=0 to ALines.Count-1 do
    begin
      s:=ALines[i];
      GetTextExtentPoint32(ACanvas.handle,PChar(s),length(s),s1);
      Result.cy:=Result.cy+s1.cy;
      if Result.cx<s1.cx then Result.cx:=s1.cx;
    end;
end;
function  NVIAC_TextSizeAtAngle(ALines : TStringList;AFont: TFont;ACanvas : TCanvas;Angle : Integer): TSize;
var s1 : TSize;
begin
  s1:=NVIAC_TextSize(ALines,AFont,ACanvas);
  Result.cx:=round(abs(s1.cx*cos(Angle*pi/1800))+abs(s1.cy*sin(Angle*pi/1800)));
  Result.cy:=round(abs(s1.cx*sin(Angle*pi/1800))+abs(s1.cy*cos(Angle*pi/1800)));
end;
procedure  NVIAC_DrawLinesAtAngle(ALines : TStringList;ACanvas :TCanvas;AFont: TFont;Angle : Integer;ShiftX,ShiftY : Integer;AlignIs : TNVIAC_H_Align);
var ASize,ASizeR,AVector : TSize;
    i,dx,dy,X,Y,vX,vY,Rx,Ry : integer;
    s : string;
begin
  ASizeR:=NVIAC_TextSizeAtAngle(ALines,AFont,ACanvas,Angle);
  ASize:=NVIAC_TextSize(ALines,AFont,ACanvas);
  dx:=0;y:=0;
  for i:=0 to ALines.Count-1 do
    begin
      s:=ALines[i];
      ACanvas.Font.Assign(AFont);
      GetTextExtentPoint32(ACanvas.handle,PChar(s),length(s),AVector);
      NVIAC_RotateFont(ACanvas.Font,Angle);
      dy:=AVector.cy;
      case  AlignIs of
        nviachLeft   : dx:=0;
        nviachRight  : dx:=ASize.cx-AVector.cx;
        nviachCenter : dx:=(ASize.cx-AVector.cx) div 2;
      end;
      X:=dx;
      vX:=X-ASize.cx div 2;
      vY:=Y-ASize.cy div 2;
      Y:=Y+dy;
      Rx:=round(vX*cos(Angle*pi/1800)+vY*sin(Angle*pi/1800))+ASizeR.cx div 2;
      Ry:=round(-vX*sin(Angle*pi/1800)+vY*cos(Angle*pi/1800))+ASizeR.cy div 2;
      ACanvas.TextOut(Rx+ShiftX,Ry+ShiftY,s);
    end;
end;

end.
